#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 538
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 322
#define ALIAS_COUNT 0
#define TOKEN_COUNT 168
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 48
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 111

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_module = 2,
  anon_sym_version = 3,
  anon_sym_is = 4,
  anon_sym_end = 5,
  anon_sym_import = 6,
  anon_sym_LBRACK = 7,
  anon_sym_RBRACK = 8,
  anon_sym_as = 9,
  anon_sym_COLON = 10,
  anon_sym_AT = 11,
  anon_sym_EQ = 12,
  anon_sym_assert = 13,
  sym_controlled_language_tag = 14,
  anon_sym_LPAREN = 15,
  anon_sym_RPAREN = 16,
  anon_sym_COMMA = 17,
  anon_sym_u00b7 = 18,
  anon_sym_DOT = 19,
  sym_reserved_self = 20,
  anon_sym_with = 21,
  anon_sym_def = 22,
  anon_sym_LBRACE = 23,
  anon_sym_RBRACE = 24,
  anon_sym_Thing = 25,
  anon_sym_Nothing = 26,
  anon_sym_real = 27,
  anon_sym_rational = 28,
  anon_sym_anyURI = 29,
  anon_sym_iri = 30,
  anon_sym_base64Binary = 31,
  anon_sym_boolean = 32,
  anon_sym_date = 33,
  anon_sym_dateTime = 34,
  anon_sym_decimal = 35,
  anon_sym_double = 36,
  anon_sym_duration = 37,
  anon_sym_float = 38,
  anon_sym_gDay = 39,
  anon_sym_gMonth = 40,
  anon_sym_gMonthDay = 41,
  anon_sym_gYearMonth = 42,
  anon_sym_gYear = 43,
  anon_sym_hexBinary = 44,
  anon_sym_binary = 45,
  anon_sym_string = 46,
  anon_sym_time = 47,
  anon_sym_dateTimeStamp = 48,
  anon_sym_dayTimeDuration = 49,
  anon_sym_yearMonthDuration = 50,
  anon_sym_integer = 51,
  anon_sym_long = 52,
  anon_sym_int = 53,
  anon_sym_short = 54,
  anon_sym_byte = 55,
  anon_sym_nonNegativeInteger = 56,
  anon_sym_positiveInteger = 57,
  anon_sym_unsignedLong = 58,
  anon_sym_unsignedInt = 59,
  anon_sym_unsigned = 60,
  anon_sym_unsignedShort = 61,
  anon_sym_unsignedByte = 62,
  anon_sym_nonPositiveInteger = 63,
  anon_sym_negativeInteger = 64,
  anon_sym_normalizedString = 65,
  anon_sym_token = 66,
  anon_sym_language = 67,
  sym_quoted_string = 68,
  sym_language_tag = 69,
  anon_sym_LT = 70,
  aux_sym_iri_token1 = 71,
  anon_sym_GT = 72,
  anon_sym_POUND_LBRACK = 73,
  sym_hex_byte = 74,
  sym_double = 75,
  sym_decimal = 76,
  sym_integer = 77,
  sym_rational = 78,
  sym_unsigned = 79,
  anon_sym_true = 80,
  anon_sym_u22a4 = 81,
  anon_sym_false = 82,
  anon_sym_u22a5 = 83,
  anon_sym_datatype = 84,
  sym_opaque = 85,
  anon_sym_length = 86,
  anon_sym_maxLength = 87,
  anon_sym_minLength = 88,
  anon_sym_fractionDigits = 89,
  anon_sym_totalDigits = 90,
  anon_sym_maxExclusive = 91,
  anon_sym_maxInclusive = 92,
  anon_sym_minExclusive = 93,
  anon_sym_minInclusive = 94,
  anon_sym_explicitTimezone = 95,
  anon_sym_required = 96,
  anon_sym_prohibited = 97,
  anon_sym_optional = 98,
  anon_sym_pattern = 99,
  sym_kw_is_fixed = 100,
  anon_sym_dimension = 101,
  anon_sym_source = 102,
  anon_sym_parent = 103,
  anon_sym_entity = 104,
  anon_sym_enum = 105,
  anon_sym_of = 106,
  anon_sym_event = 107,
  anon_sym_property = 108,
  anon_sym_structure = 109,
  anon_sym_union = 110,
  anon_sym_rdf = 111,
  anon_sym_a = 112,
  anon_sym_type = 113,
  anon_sym_class = 114,
  sym_wildcard = 115,
  anon_sym_identity = 116,
  anon_sym_ref = 117,
  sym_unknown_type = 118,
  anon_sym_ordered = 119,
  anon_sym_unordered = 120,
  anon_sym_unique = 121,
  anon_sym_nonunique = 122,
  anon_sym_DOT_DOT = 123,
  anon_sym_SLASH_EQ = 124,
  anon_sym_u2260 = 125,
  sym_op_less_than = 126,
  sym_op_greater_than = 127,
  anon_sym_LT_EQ = 128,
  anon_sym_u2264 = 129,
  anon_sym_GT_EQ = 130,
  anon_sym_u2265 = 131,
  anon_sym_not = 132,
  anon_sym_u00ac = 133,
  anon_sym_and = 134,
  anon_sym_u2227 = 135,
  anon_sym_or = 136,
  anon_sym_u2228 = 137,
  anon_sym_xor = 138,
  anon_sym_u22bb = 139,
  anon_sym_implies = 140,
  anon_sym_EQ_EQ_GT = 141,
  anon_sym_u21d2 = 142,
  anon_sym_iff = 143,
  anon_sym_LT_EQ_EQ_GT = 144,
  anon_sym_u21d4 = 145,
  anon_sym_forall = 146,
  anon_sym_u2200 = 147,
  anon_sym_exists = 148,
  anon_sym_u2203 = 149,
  anon_sym_u222a = 150,
  anon_sym_intersection = 151,
  anon_sym_u2229 = 152,
  anon_sym_complement = 153,
  anon_sym_u2216 = 154,
  anon_sym_in = 155,
  anon_sym_u2208 = 156,
  sym_set_op_builder = 157,
  anon_sym_COLON_EQ = 158,
  anon_sym_u2254 = 159,
  anon_sym_u2192 = 160,
  anon_sym_DASH_GT = 161,
  anon_sym_u2190 = 162,
  anon_sym_LT_DASH = 163,
  anon_sym_PLUS = 164,
  anon_sym_u2295 = 165,
  sym__value_empty_sequence = 166,
  sym_line_comment = 167,
  sym_module = 168,
  sym__module_locations = 169,
  sym_module_body = 170,
  sym_import_statement = 171,
  sym__import = 172,
  sym__rename_import = 173,
  sym_member_import = 174,
  sym_module_import = 175,
  sym_qualified_identifier = 176,
  sym_identifier_reference = 177,
  sym_annotation = 178,
  sym_annotation_property = 179,
  sym_constraint = 180,
  sym_informal_constraint = 181,
  sym_formal_constraint = 182,
  sym_constraint_sentence = 183,
  sym_simple_sentence = 184,
  sym_atomic_sentence = 185,
  sym_actual_arguments = 186,
  sym_equation = 187,
  sym_inequation = 188,
  sym_boolean_sentence = 189,
  sym_unary_boolean_sentence = 190,
  sym_binary_boolean_sentence = 191,
  sym__logical_connective = 192,
  sym_quantified_sentence = 193,
  sym_quantified_variable_binding = 194,
  sym_quantified_variable = 195,
  sym_variable = 196,
  sym_term = 197,
  sym_functional_term = 198,
  sym_function_composition = 199,
  sym_predicate_value = 200,
  sym_sequence_of_predicate_values = 201,
  sym_constraint_environment = 202,
  sym_function_def = 203,
  sym_function_signature = 204,
  sym_function_parameter = 205,
  sym__function_type = 206,
  sym_function_cardinality_expression = 207,
  sym_function_type_reference = 208,
  sym_function_body = 209,
  sym_sequence_builder = 210,
  sym_sequence_builder_body = 211,
  sym_value = 212,
  sym_sequence_of_values = 213,
  sym__sequence_value_constraints = 214,
  sym_value_constructor = 215,
  sym_mapping_value = 216,
  sym_builtin_simple_type = 217,
  sym__owl_builtin_types = 218,
  sym__builtin_primitive_datatypes = 219,
  sym__derived_date_datetypes = 220,
  sym__derived_numeric_datatypes = 221,
  sym__derived_string_datatypes = 222,
  sym_simple_value = 223,
  sym_string = 224,
  sym_iri = 225,
  sym_binary = 226,
  sym_boolean = 227,
  sym_boolean_truth = 228,
  sym_boolean_falsity = 229,
  sym_definition = 230,
  sym_data_type_def = 231,
  sym__datatype_base = 232,
  sym_datatype_def_restriction = 233,
  sym__restriction_facet = 234,
  sym_length_restriction_facet = 235,
  sym_digit_restriction_facet = 236,
  sym_value_restriction_facet = 237,
  sym_restriction_value = 238,
  sym_tz_restriction_facet = 239,
  sym_tz_restriction_value = 240,
  sym_pattern_restriction_facet = 241,
  sym_annotation_only_body = 242,
  sym_dimension_def = 243,
  sym_dimension_body = 244,
  sym_source_entity = 245,
  sym__identifier_or_sequence = 246,
  sym_dimension_parent = 247,
  sym_entity_def = 248,
  sym_entity_body = 249,
  sym_enum_def = 250,
  sym_enum_body = 251,
  sym_event_def = 252,
  sym_event_body = 253,
  sym_property_def = 254,
  sym_structure_def = 255,
  sym_structure_body = 256,
  sym_union_def = 257,
  sym_union_body = 258,
  sym_rdf_def = 259,
  sym_rdf_types = 260,
  sym_type_class_def = 261,
  sym_type_variable = 262,
  sym__type_variable_restriction = 263,
  sym_type_class_reference = 264,
  sym_type_class_arguments = 265,
  sym_type_class_body = 266,
  sym_method_def = 267,
  sym_entity_identity = 268,
  sym_member = 269,
  sym_member_def = 270,
  sym_property_ref = 271,
  sym__type_expression_to = 272,
  sym_type_reference = 273,
  sym_mapping_type = 274,
  sym_cardinality_expression = 275,
  sym__cardinality_inner = 276,
  sym_sequence_ordering = 277,
  sym_sequence_uniqueness = 278,
  sym_cardinality_range = 279,
  sym_value_variant = 280,
  sym_type_variant = 281,
  sym_op_inequality = 282,
  sym_op_less_than_or_equal = 283,
  sym_op_greater_than_or_equal = 284,
  sym_logical_op_negation = 285,
  sym_logical_op_conjunction = 286,
  sym_logical_op_disjunction = 287,
  sym_logical_op_exclusive_disjunction = 288,
  sym_logical_op_implication = 289,
  sym_logical_op_biconditional = 290,
  sym_logical_quantifier_universal = 291,
  sym_logical_quantifier_existential = 292,
  sym_set_op_membership = 293,
  sym_function_op_by_definition = 294,
  sym__type_op_has_type = 295,
  sym__type_op_type_restriction = 296,
  sym_type_op_combiner = 297,
  aux_sym_module_body_repeat1 = 298,
  aux_sym_module_body_repeat2 = 299,
  aux_sym_module_body_repeat3 = 300,
  aux_sym_import_statement_repeat1 = 301,
  aux_sym_actual_arguments_repeat1 = 302,
  aux_sym_function_composition_repeat1 = 303,
  aux_sym_sequence_of_predicate_values_repeat1 = 304,
  aux_sym_constraint_environment_repeat1 = 305,
  aux_sym_function_signature_repeat1 = 306,
  aux_sym_sequence_builder_repeat1 = 307,
  aux_sym_sequence_of_values_repeat1 = 308,
  aux_sym_binary_repeat1 = 309,
  aux_sym_datatype_def_restriction_repeat1 = 310,
  aux_sym_pattern_restriction_facet_repeat1 = 311,
  aux_sym_dimension_body_repeat1 = 312,
  aux_sym_dimension_body_repeat2 = 313,
  aux_sym__identifier_or_sequence_repeat1 = 314,
  aux_sym_enum_body_repeat1 = 315,
  aux_sym_union_body_repeat1 = 316,
  aux_sym_rdf_types_repeat1 = 317,
  aux_sym_type_class_def_repeat1 = 318,
  aux_sym__type_variable_restriction_repeat1 = 319,
  aux_sym_type_class_arguments_repeat1 = 320,
  aux_sym_type_class_body_repeat1 = 321,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_module] = "module",
  [anon_sym_version] = "version",
  [anon_sym_is] = "is",
  [anon_sym_end] = "end",
  [anon_sym_import] = "import",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_as] = "as",
  [anon_sym_COLON] = ":",
  [anon_sym_AT] = "@",
  [anon_sym_EQ] = "=",
  [anon_sym_assert] = "assert",
  [sym_controlled_language_tag] = "controlled_language_tag",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_u00b7] = "\u00b7",
  [anon_sym_DOT] = ".",
  [sym_reserved_self] = "reserved_self",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_Thing] = "Thing",
  [anon_sym_Nothing] = "Nothing",
  [anon_sym_real] = "real",
  [anon_sym_rational] = "rational",
  [anon_sym_anyURI] = "anyURI",
  [anon_sym_iri] = "iri",
  [anon_sym_base64Binary] = "base64Binary",
  [anon_sym_boolean] = "boolean",
  [anon_sym_date] = "date",
  [anon_sym_dateTime] = "dateTime",
  [anon_sym_decimal] = "decimal",
  [anon_sym_double] = "double",
  [anon_sym_duration] = "duration",
  [anon_sym_float] = "float",
  [anon_sym_gDay] = "gDay",
  [anon_sym_gMonth] = "gMonth",
  [anon_sym_gMonthDay] = "gMonthDay",
  [anon_sym_gYearMonth] = "gYearMonth",
  [anon_sym_gYear] = "gYear",
  [anon_sym_hexBinary] = "hexBinary",
  [anon_sym_binary] = "binary",
  [anon_sym_string] = "string",
  [anon_sym_time] = "time",
  [anon_sym_dateTimeStamp] = "dateTimeStamp",
  [anon_sym_dayTimeDuration] = "dayTimeDuration",
  [anon_sym_yearMonthDuration] = "yearMonthDuration",
  [anon_sym_integer] = "integer",
  [anon_sym_long] = "long",
  [anon_sym_int] = "int",
  [anon_sym_short] = "short",
  [anon_sym_byte] = "byte",
  [anon_sym_nonNegativeInteger] = "nonNegativeInteger",
  [anon_sym_positiveInteger] = "positiveInteger",
  [anon_sym_unsignedLong] = "unsignedLong",
  [anon_sym_unsignedInt] = "unsignedInt",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_unsignedShort] = "unsignedShort",
  [anon_sym_unsignedByte] = "unsignedByte",
  [anon_sym_nonPositiveInteger] = "nonPositiveInteger",
  [anon_sym_negativeInteger] = "negativeInteger",
  [anon_sym_normalizedString] = "normalizedString",
  [anon_sym_token] = "token",
  [anon_sym_language] = "language",
  [sym_quoted_string] = "quoted_string",
  [sym_language_tag] = "language_tag",
  [anon_sym_LT] = "<",
  [aux_sym_iri_token1] = "iri_token1",
  [anon_sym_GT] = ">",
  [anon_sym_POUND_LBRACK] = "#[",
  [sym_hex_byte] = "hex_byte",
  [sym_double] = "double",
  [sym_decimal] = "decimal",
  [sym_integer] = "integer",
  [sym_rational] = "rational",
  [sym_unsigned] = "unsigned",
  [anon_sym_true] = "true",
  [anon_sym_u22a4] = "\u22a4",
  [anon_sym_false] = "false",
  [anon_sym_u22a5] = "\u22a5",
  [anon_sym_datatype] = "datatype",
  [sym_opaque] = "opaque",
  [anon_sym_length] = "length",
  [anon_sym_maxLength] = "maxLength",
  [anon_sym_minLength] = "minLength",
  [anon_sym_fractionDigits] = "fractionDigits",
  [anon_sym_totalDigits] = "totalDigits",
  [anon_sym_maxExclusive] = "maxExclusive",
  [anon_sym_maxInclusive] = "maxInclusive",
  [anon_sym_minExclusive] = "minExclusive",
  [anon_sym_minInclusive] = "minInclusive",
  [anon_sym_explicitTimezone] = "explicitTimezone",
  [anon_sym_required] = "required",
  [anon_sym_prohibited] = "prohibited",
  [anon_sym_optional] = "optional",
  [anon_sym_pattern] = "pattern",
  [sym_kw_is_fixed] = "kw_is_fixed",
  [anon_sym_dimension] = "dimension",
  [anon_sym_source] = "source",
  [anon_sym_parent] = "parent",
  [anon_sym_entity] = "entity",
  [anon_sym_enum] = "enum",
  [anon_sym_of] = "of",
  [anon_sym_event] = "event",
  [anon_sym_property] = "property",
  [anon_sym_structure] = "structure",
  [anon_sym_union] = "union",
  [anon_sym_rdf] = "rdf",
  [anon_sym_a] = "a",
  [anon_sym_type] = "type",
  [anon_sym_class] = "class",
  [sym_wildcard] = "wildcard",
  [anon_sym_identity] = "identity",
  [anon_sym_ref] = "ref",
  [sym_unknown_type] = "unknown_type",
  [anon_sym_ordered] = "ordered",
  [anon_sym_unordered] = "unordered",
  [anon_sym_unique] = "unique",
  [anon_sym_nonunique] = "nonunique",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_u2260] = "\u2260",
  [sym_op_less_than] = "op_less_than",
  [sym_op_greater_than] = "op_greater_than",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_u2264] = "\u2264",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_u2265] = "\u2265",
  [anon_sym_not] = "not",
  [anon_sym_u00ac] = "\u00ac",
  [anon_sym_and] = "and",
  [anon_sym_u2227] = "\u2227",
  [anon_sym_or] = "or",
  [anon_sym_u2228] = "\u2228",
  [anon_sym_xor] = "xor",
  [anon_sym_u22bb] = "\u22bb",
  [anon_sym_implies] = "implies",
  [anon_sym_EQ_EQ_GT] = "==>",
  [anon_sym_u21d2] = "\u21d2",
  [anon_sym_iff] = "iff",
  [anon_sym_LT_EQ_EQ_GT] = "<==>",
  [anon_sym_u21d4] = "\u21d4",
  [anon_sym_forall] = "forall",
  [anon_sym_u2200] = "\u2200",
  [anon_sym_exists] = "exists",
  [anon_sym_u2203] = "\u2203",
  [anon_sym_u222a] = "\u222a",
  [anon_sym_intersection] = "intersection",
  [anon_sym_u2229] = "\u2229",
  [anon_sym_complement] = "complement",
  [anon_sym_u2216] = "\u2216",
  [anon_sym_in] = "in",
  [anon_sym_u2208] = "\u2208",
  [sym_set_op_builder] = "set_op_builder",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_u2254] = "\u2254",
  [anon_sym_u2192] = "\u2192",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_u2190] = "\u2190",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_PLUS] = "+",
  [anon_sym_u2295] = "\u2295",
  [sym__value_empty_sequence] = "_value_empty_sequence",
  [sym_line_comment] = "line_comment",
  [sym_module] = "module",
  [sym__module_locations] = "_module_locations",
  [sym_module_body] = "module_body",
  [sym_import_statement] = "import_statement",
  [sym__import] = "_import",
  [sym__rename_import] = "_rename_import",
  [sym_member_import] = "member_import",
  [sym_module_import] = "module_import",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_identifier_reference] = "identifier_reference",
  [sym_annotation] = "annotation",
  [sym_annotation_property] = "annotation_property",
  [sym_constraint] = "constraint",
  [sym_informal_constraint] = "informal_constraint",
  [sym_formal_constraint] = "formal_constraint",
  [sym_constraint_sentence] = "constraint_sentence",
  [sym_simple_sentence] = "simple_sentence",
  [sym_atomic_sentence] = "atomic_sentence",
  [sym_actual_arguments] = "actual_arguments",
  [sym_equation] = "equation",
  [sym_inequation] = "inequation",
  [sym_boolean_sentence] = "boolean_sentence",
  [sym_unary_boolean_sentence] = "unary_boolean_sentence",
  [sym_binary_boolean_sentence] = "binary_boolean_sentence",
  [sym__logical_connective] = "_logical_connective",
  [sym_quantified_sentence] = "quantified_sentence",
  [sym_quantified_variable_binding] = "quantified_variable_binding",
  [sym_quantified_variable] = "quantified_variable",
  [sym_variable] = "variable",
  [sym_term] = "term",
  [sym_functional_term] = "functional_term",
  [sym_function_composition] = "function_composition",
  [sym_predicate_value] = "predicate_value",
  [sym_sequence_of_predicate_values] = "sequence_of_predicate_values",
  [sym_constraint_environment] = "constraint_environment",
  [sym_function_def] = "function_def",
  [sym_function_signature] = "function_signature",
  [sym_function_parameter] = "function_parameter",
  [sym__function_type] = "_function_type",
  [sym_function_cardinality_expression] = "function_cardinality_expression",
  [sym_function_type_reference] = "function_type_reference",
  [sym_function_body] = "function_body",
  [sym_sequence_builder] = "sequence_builder",
  [sym_sequence_builder_body] = "sequence_builder_body",
  [sym_value] = "value",
  [sym_sequence_of_values] = "sequence_of_values",
  [sym__sequence_value_constraints] = "_sequence_value_constraints",
  [sym_value_constructor] = "value_constructor",
  [sym_mapping_value] = "mapping_value",
  [sym_builtin_simple_type] = "builtin_simple_type",
  [sym__owl_builtin_types] = "_owl_builtin_types",
  [sym__builtin_primitive_datatypes] = "_builtin_primitive_datatypes",
  [sym__derived_date_datetypes] = "_derived_date_datetypes",
  [sym__derived_numeric_datatypes] = "_derived_numeric_datatypes",
  [sym__derived_string_datatypes] = "_derived_string_datatypes",
  [sym_simple_value] = "simple_value",
  [sym_string] = "string",
  [sym_iri] = "iri",
  [sym_binary] = "binary",
  [sym_boolean] = "boolean",
  [sym_boolean_truth] = "boolean_truth",
  [sym_boolean_falsity] = "boolean_falsity",
  [sym_definition] = "definition",
  [sym_data_type_def] = "data_type_def",
  [sym__datatype_base] = "_datatype_base",
  [sym_datatype_def_restriction] = "datatype_def_restriction",
  [sym__restriction_facet] = "_restriction_facet",
  [sym_length_restriction_facet] = "length_restriction_facet",
  [sym_digit_restriction_facet] = "digit_restriction_facet",
  [sym_value_restriction_facet] = "value_restriction_facet",
  [sym_restriction_value] = "restriction_value",
  [sym_tz_restriction_facet] = "tz_restriction_facet",
  [sym_tz_restriction_value] = "tz_restriction_value",
  [sym_pattern_restriction_facet] = "pattern_restriction_facet",
  [sym_annotation_only_body] = "annotation_only_body",
  [sym_dimension_def] = "dimension_def",
  [sym_dimension_body] = "dimension_body",
  [sym_source_entity] = "source_entity",
  [sym__identifier_or_sequence] = "_identifier_or_sequence",
  [sym_dimension_parent] = "dimension_parent",
  [sym_entity_def] = "entity_def",
  [sym_entity_body] = "entity_body",
  [sym_enum_def] = "enum_def",
  [sym_enum_body] = "enum_body",
  [sym_event_def] = "event_def",
  [sym_event_body] = "event_body",
  [sym_property_def] = "property_def",
  [sym_structure_def] = "structure_def",
  [sym_structure_body] = "structure_body",
  [sym_union_def] = "union_def",
  [sym_union_body] = "union_body",
  [sym_rdf_def] = "rdf_def",
  [sym_rdf_types] = "rdf_types",
  [sym_type_class_def] = "type_class_def",
  [sym_type_variable] = "type_variable",
  [sym__type_variable_restriction] = "_type_variable_restriction",
  [sym_type_class_reference] = "type_class_reference",
  [sym_type_class_arguments] = "type_class_arguments",
  [sym_type_class_body] = "type_class_body",
  [sym_method_def] = "method_def",
  [sym_entity_identity] = "entity_identity",
  [sym_member] = "member",
  [sym_member_def] = "member_def",
  [sym_property_ref] = "property_ref",
  [sym__type_expression_to] = "_type_expression_to",
  [sym_type_reference] = "type_reference",
  [sym_mapping_type] = "mapping_type",
  [sym_cardinality_expression] = "cardinality_expression",
  [sym__cardinality_inner] = "_cardinality_inner",
  [sym_sequence_ordering] = "sequence_ordering",
  [sym_sequence_uniqueness] = "sequence_uniqueness",
  [sym_cardinality_range] = "cardinality_range",
  [sym_value_variant] = "value_variant",
  [sym_type_variant] = "type_variant",
  [sym_op_inequality] = "op_inequality",
  [sym_op_less_than_or_equal] = "op_less_than_or_equal",
  [sym_op_greater_than_or_equal] = "op_greater_than_or_equal",
  [sym_logical_op_negation] = "logical_op_negation",
  [sym_logical_op_conjunction] = "logical_op_conjunction",
  [sym_logical_op_disjunction] = "logical_op_disjunction",
  [sym_logical_op_exclusive_disjunction] = "logical_op_exclusive_disjunction",
  [sym_logical_op_implication] = "logical_op_implication",
  [sym_logical_op_biconditional] = "logical_op_biconditional",
  [sym_logical_quantifier_universal] = "logical_quantifier_universal",
  [sym_logical_quantifier_existential] = "logical_quantifier_existential",
  [sym_set_op_membership] = "set_op_membership",
  [sym_function_op_by_definition] = "function_op_by_definition",
  [sym__type_op_has_type] = "_type_op_has_type",
  [sym__type_op_type_restriction] = "_type_op_type_restriction",
  [sym_type_op_combiner] = "type_op_combiner",
  [aux_sym_module_body_repeat1] = "module_body_repeat1",
  [aux_sym_module_body_repeat2] = "module_body_repeat2",
  [aux_sym_module_body_repeat3] = "module_body_repeat3",
  [aux_sym_import_statement_repeat1] = "import_statement_repeat1",
  [aux_sym_actual_arguments_repeat1] = "actual_arguments_repeat1",
  [aux_sym_function_composition_repeat1] = "function_composition_repeat1",
  [aux_sym_sequence_of_predicate_values_repeat1] = "sequence_of_predicate_values_repeat1",
  [aux_sym_constraint_environment_repeat1] = "constraint_environment_repeat1",
  [aux_sym_function_signature_repeat1] = "function_signature_repeat1",
  [aux_sym_sequence_builder_repeat1] = "sequence_builder_repeat1",
  [aux_sym_sequence_of_values_repeat1] = "sequence_of_values_repeat1",
  [aux_sym_binary_repeat1] = "binary_repeat1",
  [aux_sym_datatype_def_restriction_repeat1] = "datatype_def_restriction_repeat1",
  [aux_sym_pattern_restriction_facet_repeat1] = "pattern_restriction_facet_repeat1",
  [aux_sym_dimension_body_repeat1] = "dimension_body_repeat1",
  [aux_sym_dimension_body_repeat2] = "dimension_body_repeat2",
  [aux_sym__identifier_or_sequence_repeat1] = "_identifier_or_sequence_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_union_body_repeat1] = "union_body_repeat1",
  [aux_sym_rdf_types_repeat1] = "rdf_types_repeat1",
  [aux_sym_type_class_def_repeat1] = "type_class_def_repeat1",
  [aux_sym__type_variable_restriction_repeat1] = "_type_variable_restriction_repeat1",
  [aux_sym_type_class_arguments_repeat1] = "type_class_arguments_repeat1",
  [aux_sym_type_class_body_repeat1] = "type_class_body_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_version] = anon_sym_version,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_assert] = anon_sym_assert,
  [sym_controlled_language_tag] = sym_controlled_language_tag,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_u00b7] = anon_sym_u00b7,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_reserved_self] = sym_reserved_self,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_Thing] = anon_sym_Thing,
  [anon_sym_Nothing] = anon_sym_Nothing,
  [anon_sym_real] = anon_sym_real,
  [anon_sym_rational] = anon_sym_rational,
  [anon_sym_anyURI] = anon_sym_anyURI,
  [anon_sym_iri] = anon_sym_iri,
  [anon_sym_base64Binary] = anon_sym_base64Binary,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_date] = anon_sym_date,
  [anon_sym_dateTime] = anon_sym_dateTime,
  [anon_sym_decimal] = anon_sym_decimal,
  [anon_sym_double] = anon_sym_double,
  [anon_sym_duration] = anon_sym_duration,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_gDay] = anon_sym_gDay,
  [anon_sym_gMonth] = anon_sym_gMonth,
  [anon_sym_gMonthDay] = anon_sym_gMonthDay,
  [anon_sym_gYearMonth] = anon_sym_gYearMonth,
  [anon_sym_gYear] = anon_sym_gYear,
  [anon_sym_hexBinary] = anon_sym_hexBinary,
  [anon_sym_binary] = anon_sym_binary,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_time] = anon_sym_time,
  [anon_sym_dateTimeStamp] = anon_sym_dateTimeStamp,
  [anon_sym_dayTimeDuration] = anon_sym_dayTimeDuration,
  [anon_sym_yearMonthDuration] = anon_sym_yearMonthDuration,
  [anon_sym_integer] = anon_sym_integer,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_nonNegativeInteger] = anon_sym_nonNegativeInteger,
  [anon_sym_positiveInteger] = anon_sym_positiveInteger,
  [anon_sym_unsignedLong] = anon_sym_unsignedLong,
  [anon_sym_unsignedInt] = anon_sym_unsignedInt,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_unsignedShort] = anon_sym_unsignedShort,
  [anon_sym_unsignedByte] = anon_sym_unsignedByte,
  [anon_sym_nonPositiveInteger] = anon_sym_nonPositiveInteger,
  [anon_sym_negativeInteger] = anon_sym_negativeInteger,
  [anon_sym_normalizedString] = anon_sym_normalizedString,
  [anon_sym_token] = anon_sym_token,
  [anon_sym_language] = anon_sym_language,
  [sym_quoted_string] = sym_quoted_string,
  [sym_language_tag] = sym_language_tag,
  [anon_sym_LT] = anon_sym_LT,
  [aux_sym_iri_token1] = aux_sym_iri_token1,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_POUND_LBRACK] = anon_sym_POUND_LBRACK,
  [sym_hex_byte] = sym_hex_byte,
  [sym_double] = sym_double,
  [sym_decimal] = sym_decimal,
  [sym_integer] = sym_integer,
  [sym_rational] = sym_rational,
  [sym_unsigned] = sym_unsigned,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_u22a4] = anon_sym_u22a4,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_u22a5] = anon_sym_u22a5,
  [anon_sym_datatype] = anon_sym_datatype,
  [sym_opaque] = sym_opaque,
  [anon_sym_length] = anon_sym_length,
  [anon_sym_maxLength] = anon_sym_maxLength,
  [anon_sym_minLength] = anon_sym_minLength,
  [anon_sym_fractionDigits] = anon_sym_fractionDigits,
  [anon_sym_totalDigits] = anon_sym_totalDigits,
  [anon_sym_maxExclusive] = anon_sym_maxExclusive,
  [anon_sym_maxInclusive] = anon_sym_maxInclusive,
  [anon_sym_minExclusive] = anon_sym_minExclusive,
  [anon_sym_minInclusive] = anon_sym_minInclusive,
  [anon_sym_explicitTimezone] = anon_sym_explicitTimezone,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_prohibited] = anon_sym_prohibited,
  [anon_sym_optional] = anon_sym_optional,
  [anon_sym_pattern] = anon_sym_pattern,
  [sym_kw_is_fixed] = sym_kw_is_fixed,
  [anon_sym_dimension] = anon_sym_dimension,
  [anon_sym_source] = anon_sym_source,
  [anon_sym_parent] = anon_sym_parent,
  [anon_sym_entity] = anon_sym_entity,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_structure] = anon_sym_structure,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_rdf] = anon_sym_rdf,
  [anon_sym_a] = anon_sym_a,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_class] = anon_sym_class,
  [sym_wildcard] = sym_wildcard,
  [anon_sym_identity] = anon_sym_identity,
  [anon_sym_ref] = anon_sym_ref,
  [sym_unknown_type] = sym_unknown_type,
  [anon_sym_ordered] = anon_sym_ordered,
  [anon_sym_unordered] = anon_sym_unordered,
  [anon_sym_unique] = anon_sym_unique,
  [anon_sym_nonunique] = anon_sym_nonunique,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_u2260] = anon_sym_u2260,
  [sym_op_less_than] = sym_op_less_than,
  [sym_op_greater_than] = sym_op_greater_than,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_u2264] = anon_sym_u2264,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_u2265] = anon_sym_u2265,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_u00ac] = anon_sym_u00ac,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_u2227] = anon_sym_u2227,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_u2228] = anon_sym_u2228,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_u22bb] = anon_sym_u22bb,
  [anon_sym_implies] = anon_sym_implies,
  [anon_sym_EQ_EQ_GT] = anon_sym_EQ_EQ_GT,
  [anon_sym_u21d2] = anon_sym_u21d2,
  [anon_sym_iff] = anon_sym_iff,
  [anon_sym_LT_EQ_EQ_GT] = anon_sym_LT_EQ_EQ_GT,
  [anon_sym_u21d4] = anon_sym_u21d4,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_u2200] = anon_sym_u2200,
  [anon_sym_exists] = anon_sym_exists,
  [anon_sym_u2203] = anon_sym_u2203,
  [anon_sym_u222a] = anon_sym_u222a,
  [anon_sym_intersection] = anon_sym_intersection,
  [anon_sym_u2229] = anon_sym_u2229,
  [anon_sym_complement] = anon_sym_complement,
  [anon_sym_u2216] = anon_sym_u2216,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_u2208] = anon_sym_u2208,
  [sym_set_op_builder] = sym_set_op_builder,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_u2254] = anon_sym_u2254,
  [anon_sym_u2192] = anon_sym_u2192,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_u2190] = anon_sym_u2190,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_u2295] = anon_sym_u2295,
  [sym__value_empty_sequence] = sym__value_empty_sequence,
  [sym_line_comment] = sym_line_comment,
  [sym_module] = sym_module,
  [sym__module_locations] = sym__module_locations,
  [sym_module_body] = sym_module_body,
  [sym_import_statement] = sym_import_statement,
  [sym__import] = sym__import,
  [sym__rename_import] = sym__rename_import,
  [sym_member_import] = sym_member_import,
  [sym_module_import] = sym_module_import,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_identifier_reference] = sym_identifier_reference,
  [sym_annotation] = sym_annotation,
  [sym_annotation_property] = sym_annotation_property,
  [sym_constraint] = sym_constraint,
  [sym_informal_constraint] = sym_informal_constraint,
  [sym_formal_constraint] = sym_formal_constraint,
  [sym_constraint_sentence] = sym_constraint_sentence,
  [sym_simple_sentence] = sym_simple_sentence,
  [sym_atomic_sentence] = sym_atomic_sentence,
  [sym_actual_arguments] = sym_actual_arguments,
  [sym_equation] = sym_equation,
  [sym_inequation] = sym_inequation,
  [sym_boolean_sentence] = sym_boolean_sentence,
  [sym_unary_boolean_sentence] = sym_unary_boolean_sentence,
  [sym_binary_boolean_sentence] = sym_binary_boolean_sentence,
  [sym__logical_connective] = sym__logical_connective,
  [sym_quantified_sentence] = sym_quantified_sentence,
  [sym_quantified_variable_binding] = sym_quantified_variable_binding,
  [sym_quantified_variable] = sym_quantified_variable,
  [sym_variable] = sym_variable,
  [sym_term] = sym_term,
  [sym_functional_term] = sym_functional_term,
  [sym_function_composition] = sym_function_composition,
  [sym_predicate_value] = sym_predicate_value,
  [sym_sequence_of_predicate_values] = sym_sequence_of_predicate_values,
  [sym_constraint_environment] = sym_constraint_environment,
  [sym_function_def] = sym_function_def,
  [sym_function_signature] = sym_function_signature,
  [sym_function_parameter] = sym_function_parameter,
  [sym__function_type] = sym__function_type,
  [sym_function_cardinality_expression] = sym_function_cardinality_expression,
  [sym_function_type_reference] = sym_function_type_reference,
  [sym_function_body] = sym_function_body,
  [sym_sequence_builder] = sym_sequence_builder,
  [sym_sequence_builder_body] = sym_sequence_builder_body,
  [sym_value] = sym_value,
  [sym_sequence_of_values] = sym_sequence_of_values,
  [sym__sequence_value_constraints] = sym__sequence_value_constraints,
  [sym_value_constructor] = sym_value_constructor,
  [sym_mapping_value] = sym_mapping_value,
  [sym_builtin_simple_type] = sym_builtin_simple_type,
  [sym__owl_builtin_types] = sym__owl_builtin_types,
  [sym__builtin_primitive_datatypes] = sym__builtin_primitive_datatypes,
  [sym__derived_date_datetypes] = sym__derived_date_datetypes,
  [sym__derived_numeric_datatypes] = sym__derived_numeric_datatypes,
  [sym__derived_string_datatypes] = sym__derived_string_datatypes,
  [sym_simple_value] = sym_simple_value,
  [sym_string] = sym_string,
  [sym_iri] = sym_iri,
  [sym_binary] = sym_binary,
  [sym_boolean] = sym_boolean,
  [sym_boolean_truth] = sym_boolean_truth,
  [sym_boolean_falsity] = sym_boolean_falsity,
  [sym_definition] = sym_definition,
  [sym_data_type_def] = sym_data_type_def,
  [sym__datatype_base] = sym__datatype_base,
  [sym_datatype_def_restriction] = sym_datatype_def_restriction,
  [sym__restriction_facet] = sym__restriction_facet,
  [sym_length_restriction_facet] = sym_length_restriction_facet,
  [sym_digit_restriction_facet] = sym_digit_restriction_facet,
  [sym_value_restriction_facet] = sym_value_restriction_facet,
  [sym_restriction_value] = sym_restriction_value,
  [sym_tz_restriction_facet] = sym_tz_restriction_facet,
  [sym_tz_restriction_value] = sym_tz_restriction_value,
  [sym_pattern_restriction_facet] = sym_pattern_restriction_facet,
  [sym_annotation_only_body] = sym_annotation_only_body,
  [sym_dimension_def] = sym_dimension_def,
  [sym_dimension_body] = sym_dimension_body,
  [sym_source_entity] = sym_source_entity,
  [sym__identifier_or_sequence] = sym__identifier_or_sequence,
  [sym_dimension_parent] = sym_dimension_parent,
  [sym_entity_def] = sym_entity_def,
  [sym_entity_body] = sym_entity_body,
  [sym_enum_def] = sym_enum_def,
  [sym_enum_body] = sym_enum_body,
  [sym_event_def] = sym_event_def,
  [sym_event_body] = sym_event_body,
  [sym_property_def] = sym_property_def,
  [sym_structure_def] = sym_structure_def,
  [sym_structure_body] = sym_structure_body,
  [sym_union_def] = sym_union_def,
  [sym_union_body] = sym_union_body,
  [sym_rdf_def] = sym_rdf_def,
  [sym_rdf_types] = sym_rdf_types,
  [sym_type_class_def] = sym_type_class_def,
  [sym_type_variable] = sym_type_variable,
  [sym__type_variable_restriction] = sym__type_variable_restriction,
  [sym_type_class_reference] = sym_type_class_reference,
  [sym_type_class_arguments] = sym_type_class_arguments,
  [sym_type_class_body] = sym_type_class_body,
  [sym_method_def] = sym_method_def,
  [sym_entity_identity] = sym_entity_identity,
  [sym_member] = sym_member,
  [sym_member_def] = sym_member_def,
  [sym_property_ref] = sym_property_ref,
  [sym__type_expression_to] = sym__type_expression_to,
  [sym_type_reference] = sym_type_reference,
  [sym_mapping_type] = sym_mapping_type,
  [sym_cardinality_expression] = sym_cardinality_expression,
  [sym__cardinality_inner] = sym__cardinality_inner,
  [sym_sequence_ordering] = sym_sequence_ordering,
  [sym_sequence_uniqueness] = sym_sequence_uniqueness,
  [sym_cardinality_range] = sym_cardinality_range,
  [sym_value_variant] = sym_value_variant,
  [sym_type_variant] = sym_type_variant,
  [sym_op_inequality] = sym_op_inequality,
  [sym_op_less_than_or_equal] = sym_op_less_than_or_equal,
  [sym_op_greater_than_or_equal] = sym_op_greater_than_or_equal,
  [sym_logical_op_negation] = sym_logical_op_negation,
  [sym_logical_op_conjunction] = sym_logical_op_conjunction,
  [sym_logical_op_disjunction] = sym_logical_op_disjunction,
  [sym_logical_op_exclusive_disjunction] = sym_logical_op_exclusive_disjunction,
  [sym_logical_op_implication] = sym_logical_op_implication,
  [sym_logical_op_biconditional] = sym_logical_op_biconditional,
  [sym_logical_quantifier_universal] = sym_logical_quantifier_universal,
  [sym_logical_quantifier_existential] = sym_logical_quantifier_existential,
  [sym_set_op_membership] = sym_set_op_membership,
  [sym_function_op_by_definition] = sym_function_op_by_definition,
  [sym__type_op_has_type] = sym__type_op_has_type,
  [sym__type_op_type_restriction] = sym__type_op_type_restriction,
  [sym_type_op_combiner] = sym_type_op_combiner,
  [aux_sym_module_body_repeat1] = aux_sym_module_body_repeat1,
  [aux_sym_module_body_repeat2] = aux_sym_module_body_repeat2,
  [aux_sym_module_body_repeat3] = aux_sym_module_body_repeat3,
  [aux_sym_import_statement_repeat1] = aux_sym_import_statement_repeat1,
  [aux_sym_actual_arguments_repeat1] = aux_sym_actual_arguments_repeat1,
  [aux_sym_function_composition_repeat1] = aux_sym_function_composition_repeat1,
  [aux_sym_sequence_of_predicate_values_repeat1] = aux_sym_sequence_of_predicate_values_repeat1,
  [aux_sym_constraint_environment_repeat1] = aux_sym_constraint_environment_repeat1,
  [aux_sym_function_signature_repeat1] = aux_sym_function_signature_repeat1,
  [aux_sym_sequence_builder_repeat1] = aux_sym_sequence_builder_repeat1,
  [aux_sym_sequence_of_values_repeat1] = aux_sym_sequence_of_values_repeat1,
  [aux_sym_binary_repeat1] = aux_sym_binary_repeat1,
  [aux_sym_datatype_def_restriction_repeat1] = aux_sym_datatype_def_restriction_repeat1,
  [aux_sym_pattern_restriction_facet_repeat1] = aux_sym_pattern_restriction_facet_repeat1,
  [aux_sym_dimension_body_repeat1] = aux_sym_dimension_body_repeat1,
  [aux_sym_dimension_body_repeat2] = aux_sym_dimension_body_repeat2,
  [aux_sym__identifier_or_sequence_repeat1] = aux_sym__identifier_or_sequence_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_union_body_repeat1] = aux_sym_union_body_repeat1,
  [aux_sym_rdf_types_repeat1] = aux_sym_rdf_types_repeat1,
  [aux_sym_type_class_def_repeat1] = aux_sym_type_class_def_repeat1,
  [aux_sym__type_variable_restriction_repeat1] = aux_sym__type_variable_restriction_repeat1,
  [aux_sym_type_class_arguments_repeat1] = aux_sym_type_class_arguments_repeat1,
  [aux_sym_type_class_body_repeat1] = aux_sym_type_class_body_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_version] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [sym_controlled_language_tag] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u00b7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_reserved_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Thing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Nothing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_real] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rational] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyURI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iri] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_base64Binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_date] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dateTime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_decimal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_duration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gDay] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gMonth] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gMonthDay] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gYearMonth] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gYear] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hexBinary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_time] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dateTimeStamp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dayTimeDuration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yearMonthDuration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_integer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonNegativeInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_positiveInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedLong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedInt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedShort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsignedByte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonPositiveInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_negativeInteger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_normalizedString] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_token] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_language] = {
    .visible = true,
    .named = false,
  },
  [sym_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_language_tag] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_iri_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_hex_byte] = {
    .visible = true,
    .named = true,
  },
  [sym_double] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_unsigned] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22a4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22a5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_datatype] = {
    .visible = true,
    .named = false,
  },
  [sym_opaque] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_length] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_maxLength] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minLength] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fractionDigits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_totalDigits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_maxExclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_maxInclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minExclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minInclusive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicitTimezone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prohibited] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_optional] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pattern] = {
    .visible = true,
    .named = false,
  },
  [sym_kw_is_fixed] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_dimension] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_source] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_entity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_structure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rdf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [sym_wildcard] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_identity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [sym_unknown_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_ordered] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unordered] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonunique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2260] = {
    .visible = true,
    .named = false,
  },
  [sym_op_less_than] = {
    .visible = true,
    .named = true,
  },
  [sym_op_greater_than] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2264] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2265] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u00ac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2227] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2228] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22bb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iff] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exists] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2203] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u222a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_intersection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2229] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_complement] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2216] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2208] = {
    .visible = true,
    .named = false,
  },
  [sym_set_op_builder] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2254] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2190] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2295] = {
    .visible = true,
    .named = false,
  },
  [sym__value_empty_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module_locations] = {
    .visible = false,
    .named = true,
  },
  [sym_module_body] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import] = {
    .visible = false,
    .named = true,
  },
  [sym__rename_import] = {
    .visible = false,
    .named = true,
  },
  [sym_member_import] = {
    .visible = true,
    .named = true,
  },
  [sym_module_import] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_property] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_informal_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_actual_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_equation] = {
    .visible = true,
    .named = true,
  },
  [sym_inequation] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_boolean_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_boolean_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym__logical_connective] = {
    .visible = false,
    .named = true,
  },
  [sym_quantified_sentence] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified_variable_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_term] = {
    .visible = true,
    .named = true,
  },
  [sym_functional_term] = {
    .visible = true,
    .named = true,
  },
  [sym_function_composition] = {
    .visible = true,
    .named = true,
  },
  [sym_predicate_value] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_of_predicate_values] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_environment] = {
    .visible = true,
    .named = true,
  },
  [sym_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__function_type] = {
    .visible = false,
    .named = true,
  },
  [sym_function_cardinality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_builder] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_builder_body] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_of_values] = {
    .visible = true,
    .named = true,
  },
  [sym__sequence_value_constraints] = {
    .visible = false,
    .named = true,
  },
  [sym_value_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_mapping_value] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_simple_type] = {
    .visible = true,
    .named = true,
  },
  [sym__owl_builtin_types] = {
    .visible = false,
    .named = true,
  },
  [sym__builtin_primitive_datatypes] = {
    .visible = false,
    .named = true,
  },
  [sym__derived_date_datetypes] = {
    .visible = false,
    .named = true,
  },
  [sym__derived_numeric_datatypes] = {
    .visible = false,
    .named = true,
  },
  [sym__derived_string_datatypes] = {
    .visible = false,
    .named = true,
  },
  [sym_simple_value] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_iri] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_truth] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_falsity] = {
    .visible = true,
    .named = true,
  },
  [sym_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_data_type_def] = {
    .visible = true,
    .named = true,
  },
  [sym__datatype_base] = {
    .visible = false,
    .named = true,
  },
  [sym_datatype_def_restriction] = {
    .visible = true,
    .named = true,
  },
  [sym__restriction_facet] = {
    .visible = false,
    .named = true,
  },
  [sym_length_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_digit_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_value_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_restriction_value] = {
    .visible = true,
    .named = true,
  },
  [sym_tz_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_tz_restriction_value] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_restriction_facet] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_only_body] = {
    .visible = true,
    .named = true,
  },
  [sym_dimension_def] = {
    .visible = true,
    .named = true,
  },
  [sym_dimension_body] = {
    .visible = true,
    .named = true,
  },
  [sym_source_entity] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_or_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_dimension_parent] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_def] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_def] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_event_def] = {
    .visible = true,
    .named = true,
  },
  [sym_event_body] = {
    .visible = true,
    .named = true,
  },
  [sym_property_def] = {
    .visible = true,
    .named = true,
  },
  [sym_structure_def] = {
    .visible = true,
    .named = true,
  },
  [sym_structure_body] = {
    .visible = true,
    .named = true,
  },
  [sym_union_def] = {
    .visible = true,
    .named = true,
  },
  [sym_union_body] = {
    .visible = true,
    .named = true,
  },
  [sym_rdf_def] = {
    .visible = true,
    .named = true,
  },
  [sym_rdf_types] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_def] = {
    .visible = true,
    .named = true,
  },
  [sym_type_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__type_variable_restriction] = {
    .visible = false,
    .named = true,
  },
  [sym_type_class_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_method_def] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_identity] = {
    .visible = true,
    .named = true,
  },
  [sym_member] = {
    .visible = true,
    .named = true,
  },
  [sym_member_def] = {
    .visible = true,
    .named = true,
  },
  [sym_property_ref] = {
    .visible = true,
    .named = true,
  },
  [sym__type_expression_to] = {
    .visible = false,
    .named = true,
  },
  [sym_type_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_mapping_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cardinality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cardinality_inner] = {
    .visible = false,
    .named = true,
  },
  [sym_sequence_ordering] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_uniqueness] = {
    .visible = true,
    .named = true,
  },
  [sym_cardinality_range] = {
    .visible = true,
    .named = true,
  },
  [sym_value_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_type_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_op_inequality] = {
    .visible = true,
    .named = true,
  },
  [sym_op_less_than_or_equal] = {
    .visible = true,
    .named = true,
  },
  [sym_op_greater_than_or_equal] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_exclusive_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_implication] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_op_biconditional] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_quantifier_universal] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_quantifier_existential] = {
    .visible = true,
    .named = true,
  },
  [sym_set_op_membership] = {
    .visible = true,
    .named = true,
  },
  [sym_function_op_by_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_op_has_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_op_type_restriction] = {
    .visible = false,
    .named = true,
  },
  [sym_type_op_combiner] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_actual_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_composition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_of_predicate_values_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constraint_environment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_signature_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_builder_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_of_values_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_binary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_datatype_def_restriction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_restriction_facet_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimension_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimension_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__identifier_or_sequence_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rdf_types_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_class_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_variable_restriction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_class_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_argument = 1,
  field_arguments = 2,
  field_base = 3,
  field_binding = 4,
  field_body = 5,
  field_byte = 6,
  field_cardinality = 7,
  field_domain = 8,
  field_element = 9,
  field_empty = 10,
  field_entity = 11,
  field_environment = 12,
  field_facet = 13,
  field_function = 14,
  field_identity = 15,
  field_is_fixed = 16,
  field_language = 17,
  field_lhs = 18,
  field_max = 19,
  field_member = 20,
  field_method = 21,
  field_min = 22,
  field_module = 23,
  field_name = 24,
  field_opaque = 25,
  field_operator = 26,
  field_ordering = 27,
  field_parameter = 28,
  field_predicate = 29,
  field_property = 30,
  field_quantifier = 31,
  field_range = 32,
  field_relation = 33,
  field_rename = 34,
  field_restriction = 35,
  field_rhs = 36,
  field_signature = 37,
  field_source = 38,
  field_subject = 39,
  field_target = 40,
  field_type = 41,
  field_types = 42,
  field_uniqueness = 43,
  field_value = 44,
  field_variable = 45,
  field_version_info = 46,
  field_version_uri = 47,
  field_wildcard = 48,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_base] = "base",
  [field_binding] = "binding",
  [field_body] = "body",
  [field_byte] = "byte",
  [field_cardinality] = "cardinality",
  [field_domain] = "domain",
  [field_element] = "element",
  [field_empty] = "empty",
  [field_entity] = "entity",
  [field_environment] = "environment",
  [field_facet] = "facet",
  [field_function] = "function",
  [field_identity] = "identity",
  [field_is_fixed] = "is_fixed",
  [field_language] = "language",
  [field_lhs] = "lhs",
  [field_max] = "max",
  [field_member] = "member",
  [field_method] = "method",
  [field_min] = "min",
  [field_module] = "module",
  [field_name] = "name",
  [field_opaque] = "opaque",
  [field_operator] = "operator",
  [field_ordering] = "ordering",
  [field_parameter] = "parameter",
  [field_predicate] = "predicate",
  [field_property] = "property",
  [field_quantifier] = "quantifier",
  [field_range] = "range",
  [field_relation] = "relation",
  [field_rename] = "rename",
  [field_restriction] = "restriction",
  [field_rhs] = "rhs",
  [field_signature] = "signature",
  [field_source] = "source",
  [field_subject] = "subject",
  [field_target] = "target",
  [field_type] = "type",
  [field_types] = "types",
  [field_uniqueness] = "uniqueness",
  [field_value] = "value",
  [field_variable] = "variable",
  [field_version_info] = "version_info",
  [field_version_uri] = "version_uri",
  [field_wildcard] = "wildcard",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [3] = {.index = 3, .length = 5},
  [4] = {.index = 8, .length = 1},
  [5] = {.index = 9, .length = 1},
  [6] = {.index = 10, .length = 1},
  [7] = {.index = 11, .length = 2},
  [8] = {.index = 13, .length = 2},
  [9] = {.index = 15, .length = 2},
  [10] = {.index = 17, .length = 3},
  [11] = {.index = 20, .length = 3},
  [12] = {.index = 23, .length = 1},
  [13] = {.index = 24, .length = 2},
  [14] = {.index = 26, .length = 3},
  [15] = {.index = 29, .length = 1},
  [16] = {.index = 30, .length = 2},
  [17] = {.index = 32, .length = 1},
  [18] = {.index = 33, .length = 2},
  [19] = {.index = 35, .length = 4},
  [20] = {.index = 39, .length = 1},
  [21] = {.index = 40, .length = 1},
  [22] = {.index = 41, .length = 3},
  [23] = {.index = 44, .length = 1},
  [24] = {.index = 45, .length = 1},
  [25] = {.index = 46, .length = 1},
  [26] = {.index = 47, .length = 1},
  [27] = {.index = 48, .length = 1},
  [28] = {.index = 49, .length = 1},
  [29] = {.index = 50, .length = 2},
  [30] = {.index = 52, .length = 1},
  [31] = {.index = 53, .length = 1},
  [32] = {.index = 54, .length = 1},
  [33] = {.index = 55, .length = 2},
  [34] = {.index = 57, .length = 2},
  [35] = {.index = 59, .length = 2},
  [36] = {.index = 61, .length = 2},
  [37] = {.index = 63, .length = 3},
  [38] = {.index = 66, .length = 3},
  [39] = {.index = 69, .length = 3},
  [40] = {.index = 72, .length = 1},
  [41] = {.index = 73, .length = 1},
  [42] = {.index = 74, .length = 2},
  [43] = {.index = 76, .length = 1},
  [44] = {.index = 77, .length = 2},
  [45] = {.index = 79, .length = 1},
  [46] = {.index = 80, .length = 1},
  [47] = {.index = 81, .length = 1},
  [48] = {.index = 82, .length = 2},
  [49] = {.index = 84, .length = 2},
  [50] = {.index = 86, .length = 2},
  [51] = {.index = 88, .length = 2},
  [52] = {.index = 90, .length = 1},
  [53] = {.index = 91, .length = 2},
  [54] = {.index = 93, .length = 1},
  [55] = {.index = 94, .length = 1},
  [56] = {.index = 95, .length = 1},
  [57] = {.index = 96, .length = 2},
  [58] = {.index = 98, .length = 2},
  [59] = {.index = 100, .length = 2},
  [60] = {.index = 102, .length = 2},
  [61] = {.index = 104, .length = 3},
  [62] = {.index = 107, .length = 2},
  [63] = {.index = 109, .length = 2},
  [64] = {.index = 111, .length = 1},
  [65] = {.index = 112, .length = 3},
  [66] = {.index = 115, .length = 3},
  [67] = {.index = 118, .length = 2},
  [68] = {.index = 120, .length = 4},
  [69] = {.index = 124, .length = 4},
  [70] = {.index = 128, .length = 4},
  [71] = {.index = 132, .length = 1},
  [72] = {.index = 133, .length = 2},
  [73] = {.index = 135, .length = 2},
  [74] = {.index = 137, .length = 2},
  [75] = {.index = 139, .length = 1},
  [76] = {.index = 140, .length = 2},
  [77] = {.index = 142, .length = 1},
  [78] = {.index = 143, .length = 3},
  [79] = {.index = 146, .length = 2},
  [80] = {.index = 148, .length = 2},
  [81] = {.index = 150, .length = 3},
  [82] = {.index = 153, .length = 1},
  [83] = {.index = 154, .length = 1},
  [84] = {.index = 155, .length = 2},
  [85] = {.index = 157, .length = 2},
  [86] = {.index = 159, .length = 1},
  [87] = {.index = 160, .length = 5},
  [88] = {.index = 165, .length = 1},
  [89] = {.index = 166, .length = 2},
  [90] = {.index = 168, .length = 1},
  [91] = {.index = 169, .length = 3},
  [92] = {.index = 172, .length = 3},
  [93] = {.index = 175, .length = 3},
  [94] = {.index = 178, .length = 2},
  [95] = {.index = 180, .length = 2},
  [96] = {.index = 182, .length = 2},
  [97] = {.index = 184, .length = 1},
  [98] = {.index = 185, .length = 1},
  [99] = {.index = 186, .length = 2},
  [100] = {.index = 188, .length = 2},
  [101] = {.index = 190, .length = 4},
  [102] = {.index = 194, .length = 4},
  [103] = {.index = 198, .length = 2},
  [104] = {.index = 200, .length = 2},
  [105] = {.index = 202, .length = 1},
  [106] = {.index = 203, .length = 2},
  [107] = {.index = 205, .length = 3},
  [108] = {.index = 208, .length = 1},
  [109] = {.index = 209, .length = 1},
  [110] = {.index = 210, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 2},
    {field_name, 1},
  [2] =
    {field_base, 0},
  [3] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
    {field_version_info, 2, .inherited = true},
    {field_version_uri, 2, .inherited = true},
  [8] =
    {field_name, 0},
  [9] =
    {field_name, 1},
  [10] =
    {field_member, 1},
  [11] =
    {field_base, 0},
    {field_version_uri, 2},
  [13] =
    {field_name, 0},
    {field_rename, 1, .inherited = true},
  [15] =
    {field_name, 0},
    {field_version_uri, 1},
  [17] =
    {field_cardinality, 1, .inherited = true},
    {field_name, 0},
    {field_target, 1, .inherited = true},
  [20] =
    {field_base, 0},
    {field_version_info, 2},
    {field_version_uri, 3},
  [23] =
    {field_rename, 1},
  [24] =
    {field_member, 2},
    {field_module, 0},
  [26] =
    {field_name, 0},
    {field_rename, 2, .inherited = true},
    {field_version_uri, 1},
  [29] =
    {field_empty, 0},
  [30] =
    {field_name, 1},
    {field_value, 3},
  [32] =
    {field_value, 1},
  [33] =
    {field_base, 3},
    {field_name, 1},
  [35] =
    {field_body, 2},
    {field_cardinality, 1, .inherited = true},
    {field_name, 0},
    {field_target, 1, .inherited = true},
  [39] =
    {field_target, 1},
  [40] =
    {field_type, 1},
  [41] =
    {field_body, 3},
    {field_name, 1},
    {field_types, 2},
  [44] =
    {field_signature, 0},
  [45] =
    {field_method, 0},
  [46] =
    {field_variable, 0},
  [47] =
    {field_element, 0},
  [48] =
    {field_language, 1},
  [49] =
    {field_byte, 0},
  [50] =
    {field_name, 1, .inherited = true},
    {field_subject, 0},
  [52] =
    {field_body, 1},
  [53] =
    {field_predicate, 0},
  [54] =
    {field_function, 0},
  [55] =
    {field_operator, 0},
    {field_rhs, 1},
  [57] =
    {field_binding, 1},
    {field_quantifier, 0},
  [59] =
    {field_language, 2},
    {field_value, 1},
  [61] =
    {field_body, 1},
    {field_signature, 0},
  [63] =
    {field_base, 4},
    {field_name, 1},
    {field_opaque, 3},
  [66] =
    {field_base, 3},
    {field_name, 1},
    {field_restriction, 4},
  [69] =
    {field_base, 3},
    {field_body, 4},
    {field_name, 1},
  [72] =
    {field_entity, 1},
  [73] =
    {field_identity, 1},
  [74] =
    {field_body, 1},
    {field_name, 0},
  [76] =
    {field_min, 0},
  [77] =
    {field_cardinality, 1},
    {field_target, 2},
  [79] =
    {field_property, 1},
  [80] =
    {field_type, 0},
  [81] =
    {field_method, 1, .inherited = true},
  [82] =
    {field_method, 0, .inherited = true},
    {field_method, 1, .inherited = true},
  [84] =
    {field_cardinality, 0},
    {field_name, 1},
  [86] =
    {field_name, 1},
    {field_variable, 3, .inherited = true},
  [88] =
    {field_variable, 0, .inherited = true},
    {field_variable, 1, .inherited = true},
  [90] =
    {field_element, 1, .inherited = true},
  [91] =
    {field_element, 0, .inherited = true},
    {field_element, 1, .inherited = true},
  [93] =
    {field_ordering, 1},
  [94] =
    {field_uniqueness, 1},
  [95] =
    {field_byte, 1, .inherited = true},
  [96] =
    {field_byte, 0, .inherited = true},
    {field_byte, 1, .inherited = true},
  [98] =
    {field_ordering, 0, .inherited = true},
    {field_uniqueness, 0, .inherited = true},
  [100] =
    {field_domain, 0},
    {field_range, 2},
  [102] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [104] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 2},
  [107] =
    {field_binding, 0},
    {field_body, 2},
  [109] =
    {field_lhs, 0},
    {field_rhs, 2},
  [111] =
    {field_argument, 0},
  [112] =
    {field_lhs, 0},
    {field_relation, 1},
    {field_rhs, 2},
  [115] =
    {field_cardinality, 2, .inherited = true},
    {field_name, 1},
    {field_target, 2, .inherited = true},
  [118] =
    {field_body, 2},
    {field_environment, 0},
  [120] =
    {field_base, 4},
    {field_name, 1},
    {field_opaque, 3},
    {field_restriction, 5},
  [124] =
    {field_base, 4},
    {field_body, 5},
    {field_name, 1},
    {field_opaque, 3},
  [128] =
    {field_base, 3},
    {field_body, 5},
    {field_name, 1},
    {field_restriction, 4},
  [132] =
    {field_identity, 2},
  [133] =
    {field_min, 0},
    {field_range, 1},
  [135] =
    {field_min, 1, .inherited = true},
    {field_range, 1, .inherited = true},
  [137] =
    {field_name, 0},
    {field_rename, 2},
  [139] =
    {field_type, 2, .inherited = true},
  [140] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [142] =
    {field_method, 2, .inherited = true},
  [143] =
    {field_body, 5},
    {field_name, 1},
    {field_variable, 3, .inherited = true},
  [146] =
    {field_ordering, 1},
    {field_uniqueness, 2},
  [148] =
    {field_name, 0},
    {field_value, 2},
  [150] =
    {field_element, 2, .inherited = true},
    {field_ordering, 0, .inherited = true},
    {field_uniqueness, 0, .inherited = true},
  [153] =
    {field_range, 2},
  [154] =
    {field_argument, 1, .inherited = true},
  [155] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [157] =
    {field_name, 0},
    {field_source, 2},
  [159] =
    {field_parameter, 0},
  [160] =
    {field_base, 4},
    {field_body, 6},
    {field_name, 1},
    {field_opaque, 3},
    {field_restriction, 5},
  [165] =
    {field_member, 0},
  [166] =
    {field_entity, 1},
    {field_member, 3, .inherited = true},
  [168] =
    {field_max, 1},
  [169] =
    {field_min, 2, .inherited = true},
    {field_ordering, 1},
    {field_range, 2, .inherited = true},
  [172] =
    {field_min, 2, .inherited = true},
    {field_range, 2, .inherited = true},
    {field_uniqueness, 1},
  [175] =
    {field_body, 3},
    {field_name, 0},
    {field_rename, 2},
  [178] =
    {field_arguments, 1},
    {field_name, 0},
  [180] =
    {field_body, 3},
    {field_variable, 1, .inherited = true},
  [182] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [184] =
    {field_facet, 0},
  [185] =
    {field_value, 2},
  [186] =
    {field_entity, 3},
    {field_name, 1},
  [188] =
    {field_domain, 1},
    {field_range, 3},
  [190] =
    {field_min, 3, .inherited = true},
    {field_ordering, 1},
    {field_range, 3, .inherited = true},
    {field_uniqueness, 2},
  [194] =
    {field_cardinality, 5, .inherited = true},
    {field_name, 1},
    {field_parameter, 3, .inherited = true},
    {field_target, 5, .inherited = true},
  [198] =
    {field_facet, 0},
    {field_is_fixed, 2},
  [200] =
    {field_is_fixed, 2},
    {field_value, 3},
  [202] =
    {field_member, 1, .inherited = true},
  [203] =
    {field_member, 0, .inherited = true},
    {field_member, 1, .inherited = true},
  [205] =
    {field_body, 4},
    {field_entity, 3},
    {field_name, 1},
  [208] =
    {field_wildcard, 1},
  [209] =
    {field_variable, 1, .inherited = true},
  [210] =
    {field_value, 2},
    {field_value, 3},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 21,
  [28] = 24,
  [29] = 29,
  [30] = 23,
  [31] = 29,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 47,
  [49] = 49,
  [50] = 49,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 67,
  [70] = 65,
  [71] = 63,
  [72] = 62,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 79,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 94,
  [101] = 101,
  [102] = 94,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 3,
  [112] = 112,
  [113] = 113,
  [114] = 13,
  [115] = 2,
  [116] = 116,
  [117] = 19,
  [118] = 118,
  [119] = 66,
  [120] = 12,
  [121] = 74,
  [122] = 7,
  [123] = 9,
  [124] = 6,
  [125] = 5,
  [126] = 126,
  [127] = 77,
  [128] = 128,
  [129] = 75,
  [130] = 11,
  [131] = 76,
  [132] = 10,
  [133] = 133,
  [134] = 78,
  [135] = 133,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 139,
  [141] = 141,
  [142] = 136,
  [143] = 89,
  [144] = 90,
  [145] = 145,
  [146] = 146,
  [147] = 141,
  [148] = 84,
  [149] = 85,
  [150] = 93,
  [151] = 86,
  [152] = 152,
  [153] = 91,
  [154] = 61,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 88,
  [162] = 162,
  [163] = 163,
  [164] = 87,
  [165] = 152,
  [166] = 166,
  [167] = 92,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 179,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 206,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 292,
  [294] = 294,
  [295] = 295,
  [296] = 294,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 156,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 61,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 376,
  [378] = 378,
  [379] = 379,
  [380] = 198,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 195,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 405,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 414,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 508,
  [510] = 497,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 500,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 475,
  [530] = 530,
  [531] = 531,
  [532] = 471,
  [533] = 483,
  [534] = 530,
  [535] = 535,
  [536] = 536,
  [537] = 537,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'a', 'z'}, {0xb5, 0xb5}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x1ba}, {0x1bc, 0x1bf}, {0x1c4, 0x1c4},
  {0x1c6, 0x1c7}, {0x1c9, 0x1ca}, {0x1cc, 0x1f1}, {0x1f3, 0x293}, {0x295, 0x2af}, {0x370, 0x373}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x560, 0x588}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fd, 0x10ff}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1d00, 0x1d2b}, {0x1d6b, 0x1d77}, {0x1d79, 0x1d9a}, {0x1e00, 0x1f15},
  {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d},
  {0x1f80, 0x1f87}, {0x1f90, 0x1f97}, {0x1fa0, 0x1fa7}, {0x1fb0, 0x1fb4}, {0x1fb6, 0x1fbb}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcb},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffb}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113},
  {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2134}, {0x2139, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2183, 0x2184}, {0x2c00, 0x2c7b}, {0x2c7e, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3},
  {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0xa640, 0xa66d}, {0xa680, 0xa69b}, {0xa722, 0xa76f}, {0xa771, 0xa787}, {0xa78b, 0xa78e},
  {0xa790, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f5, 0xa7f6}, {0xa7fa, 0xa7fa}, {0xab30, 0xab5a}, {0xab60, 0xab68},
  {0xab70, 0xabbf}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0x10400, 0x1044f}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xb5, 0xb5}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x1ba},
  {0x1bc, 0x1bf}, {0x1c4, 0x1c4}, {0x1c6, 0x1c7}, {0x1c9, 0x1ca}, {0x1cc, 0x1f1}, {0x1f3, 0x293}, {0x295, 0x2af}, {0x370, 0x373},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x560, 0x588}, {0x660, 0x669}, {0x6f0, 0x6f9}, {0x7c0, 0x7c9}, {0x966, 0x96f},
  {0x9e6, 0x9ef}, {0xa66, 0xa6f}, {0xae6, 0xaef}, {0xb66, 0xb6f}, {0xbe6, 0xbef}, {0xc66, 0xc6f}, {0xce6, 0xcef}, {0xd66, 0xd6f},
  {0xde6, 0xdef}, {0xe50, 0xe59}, {0xed0, 0xed9}, {0xf20, 0xf29}, {0x1040, 0x1049}, {0x1090, 0x1099}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7},
  {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fd, 0x10ff}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x17e0, 0x17e9}, {0x1810, 0x1819}, {0x1946, 0x194f},
  {0x19d0, 0x19d9}, {0x1a80, 0x1a89}, {0x1a90, 0x1a99}, {0x1b50, 0x1b59}, {0x1bb0, 0x1bb9}, {0x1c40, 0x1c49}, {0x1c50, 0x1c59}, {0x1c80, 0x1c88},
  {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1d00, 0x1d2b}, {0x1d6b, 0x1d77}, {0x1d79, 0x1d9a}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45},
  {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1f87}, {0x1f90, 0x1f97},
  {0x1fa0, 0x1fa7}, {0x1fb0, 0x1fb4}, {0x1fb6, 0x1fbb}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcb}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb},
  {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffb}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2119, 0x211d},
  {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2134}, {0x2139, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2183, 0x2184}, {0x2c00, 0x2c7b}, {0x2c7e, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0xa620, 0xa629}, {0xa640, 0xa66d}, {0xa680, 0xa69b}, {0xa722, 0xa76f}, {0xa771, 0xa787}, {0xa78b, 0xa78e}, {0xa790, 0xa7ca},
  {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f5, 0xa7f6}, {0xa7fa, 0xa7fa}, {0xa8d0, 0xa8d9}, {0xa900, 0xa909}, {0xa9d0, 0xa9d9},
  {0xa9f0, 0xa9f9}, {0xaa50, 0xaa59}, {0xab30, 0xab5a}, {0xab60, 0xab68}, {0xab70, 0xabbf}, {0xabf0, 0xabf9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0x10400, 0x1044f}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10570, 0x1057a},
  {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(68);
      ADVANCE_MAP(
        '"', 5,
        '#', 26,
        '(', 90,
        ')', 91,
        '+', 168,
        ',', 92,
        '-', 12,
        '.', 95,
        '/', 20,
        '0', 129,
        ':', 74,
        ';', 180,
        '<', 140,
        '=', 78,
        '>', 142,
        '@', 76,
        '[', 69,
        '\\', 14,
        ']', 70,
        '_', 136,
        '{', 96,
        '|', 161,
        '}', 97,
        0xac, 147,
        0xb7, 93,
        0x2190, 166,
        0x2192, 164,
        0x21d2, 152,
        0x21d4, 154,
        0x2200, 155,
        0x2203, 156,
        0x2205, 170,
        0x2208, 160,
        0x2216, 159,
        0x2227, 148,
        0x2228, 149,
        0x2229, 158,
        0x222a, 157,
        0x2254, 163,
        0x2260, 139,
        0x2264, 144,
        0x2265, 146,
        0x2295, 169,
        0x22a4, 134,
        0x22a5, 135,
        0x22bb, 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(128);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(71);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '"', 5,
        '#', 26,
        '(', 90,
        ')', 91,
        '+', 13,
        '-', 12,
        '.', 94,
        '0', 126,
        ':', 73,
        ';', 180,
        '<', 114,
        '>', 118,
        '@', 75,
        '[', 69,
        '\\', 14,
        ']', 70,
        '{', 96,
        '}', 97,
        0xac, 147,
        0xb7, 93,
        0x2192, 164,
        0x2200, 155,
        0x2203, 156,
        0x2205, 170,
        0x22a4, 134,
        0x22a5, 135,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '"', 5,
        '#', 26,
        '(', 90,
        ')', 91,
        '+', 13,
        '-', 12,
        '0', 126,
        ';', 180,
        '<', 114,
        '@', 75,
        '[', 69,
        '\\', 14,
        ']', 70,
        '{', 96,
        '}', 97,
        0xac, 147,
        0x2192, 164,
        0x2200, 155,
        0x2203, 156,
        0x2205, 170,
        0x22a4, 134,
        0x22a5, 135,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '"', 5,
        '#', 26,
        '(', 90,
        ')', 91,
        '+', 13,
        '-', 12,
        '0', 126,
        ';', 180,
        '<', 114,
        '@', 63,
        '[', 69,
        '\\', 14,
        ']', 70,
        '{', 96,
        0x2192, 164,
        0x2205, 170,
        0x22a4, 134,
        0x22a5, 135,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '"', 5,
        '#', 26,
        '(', 90,
        ')', 91,
        '+', 13,
        '-', 12,
        '0', 126,
        ';', 180,
        '<', 114,
        '[', 69,
        '\\', 14,
        ']', 70,
        '{', 96,
        0x2192, 164,
        0x2205, 170,
        0x22a4, 134,
        0x22a5, 135,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead > 0x08 &&
          (lookahead < 0x0b || 0x1f < lookahead) &&
          lookahead != 0x7f) ADVANCE(5);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '(', 90,
        ')', 91,
        '+', 168,
        ',', 92,
        '-', 22,
        '.', 94,
        '/', 20,
        '0', 132,
        ':', 74,
        ';', 180,
        '<', 141,
        '=', 78,
        '>', 142,
        '@', 75,
        '[', 69,
        ']', 70,
        '_', 136,
        '{', 96,
        '|', 161,
        '}', 97,
        0xb7, 93,
        0x2192, 164,
        0x21d2, 152,
        0x21d4, 154,
        0x2200, 155,
        0x2203, 156,
        0x2208, 160,
        0x2227, 148,
        0x2228, 149,
        0x2254, 163,
        0x2260, 139,
        0x2264, 144,
        0x2265, 146,
        0x2295, 169,
        0x22bb, 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(133);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '(', 90,
        ')', 91,
        '+', 168,
        ',', 92,
        '-', 22,
        '/', 20,
        '0', 132,
        ':', 21,
        ';', 180,
        '<', 141,
        '=', 78,
        '>', 142,
        '@', 75,
        '[', 69,
        ']', 70,
        '_', 136,
        '{', 96,
        '|', 161,
        '}', 97,
        0x2192, 164,
        0x21d2, 152,
        0x21d4, 154,
        0x2200, 155,
        0x2203, 156,
        0x2208, 160,
        0x2227, 148,
        0x2228, 149,
        0x2254, 163,
        0x2260, 139,
        0x2264, 144,
        0x2265, 146,
        0x2295, 169,
        0x22bb, 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(133);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '(', 90,
        ')', 91,
        ',', 92,
        '-', 22,
        '.', 11,
        '/', 20,
        ';', 180,
        '<', 141,
        '=', 78,
        '>', 142,
        '@', 75,
        '}', 97,
        0x2192, 164,
        0x21d2, 152,
        0x21d4, 154,
        0x2227, 148,
        0x2228, 149,
        0x2260, 139,
        0x2264, 144,
        0x2265, 146,
        0x22bb, 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '(', 90,
        ')', 91,
        ',', 92,
        '-', 22,
        '.', 11,
        '/', 20,
        ';', 180,
        '<', 141,
        '=', 78,
        '>', 142,
        '@', 77,
        '}', 97,
        0x2192, 164,
        0x21d2, 152,
        0x21d4, 154,
        0x2227, 148,
        0x2228, 149,
        0x2260, 139,
        0x2264, 144,
        0x2265, 146,
        0x22bb, 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 10:
      if (lookahead == '-') ADVANCE(167);
      END_STATE();
    case 11:
      if (lookahead == '.') ADVANCE(137);
      END_STATE();
    case 12:
      if (lookahead == '0') ADVANCE(126);
      if (lookahead == '>') ADVANCE(165);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 13:
      if (lookahead == '0') ADVANCE(126);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 14:
      if (lookahead == '0') ADVANCE(125);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 15:
      if (lookahead == '0') ADVANCE(122);
      if (lookahead == '+' ||
          lookahead == '-' ||
          lookahead == '\\') ADVANCE(16);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(123);
      END_STATE();
    case 16:
      if (lookahead == '0') ADVANCE(122);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(123);
      END_STATE();
    case 17:
      if (lookahead == ';') ADVANCE(180);
      if (lookahead == '<') ADVANCE(10);
      if (lookahead == '@') ADVANCE(76);
      if (lookahead == 0x2190) ADVANCE(166);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 18:
      if (lookahead == ';') ADVANCE(180);
      if (lookahead == '<') ADVANCE(10);
      if (lookahead == '@') ADVANCE(75);
      if (lookahead == 0x2190) ADVANCE(166);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 19:
      if (lookahead == ';') ADVANCE(180);
      if (lookahead == ']') ADVANCE(70);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 21:
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 22:
      if (lookahead == '>') ADVANCE(165);
      END_STATE();
    case 23:
      if (lookahead == '>') ADVANCE(151);
      END_STATE();
    case 24:
      if (lookahead == '>') ADVANCE(153);
      END_STATE();
    case 25:
      if (lookahead == 'U') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(50);
      END_STATE();
    case 26:
      if (lookahead == '[') ADVANCE(119);
      END_STATE();
    case 27:
      if (lookahead == '_') ADVANCE(27);
      if (set_contains(sym_identifier_character_set_2, 151, lookahead)) ADVANCE(72);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        'u', 29,
        '"', 5,
        '/', 5,
        '\\', 5,
        'a', 5,
        'b', 5,
        'e', 5,
        'f', 5,
        'n', 5,
        'r', 5,
        't', 5,
        'v', 5,
      );
      END_STATE();
    case 29:
      if (lookahead == '{') ADVANCE(47);
      END_STATE();
    case 30:
      if (lookahead == '}') ADVANCE(5);
      END_STATE();
    case 31:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(30);
      END_STATE();
    case 32:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 33:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(32);
      END_STATE();
    case 34:
      if (lookahead == '}') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 35:
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(131);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(124);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(43);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(56);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(43);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(57);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(43);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(58);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(43);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(59);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(43);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(60);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(116);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 55:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(66);
      END_STATE();
    case 56:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(111);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(65);
      END_STATE();
    case 57:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(99);
      END_STATE();
    case 58:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(99);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(65);
      END_STATE();
    case 59:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(112);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(65);
      END_STATE();
    case 60:
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(113);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(65);
      END_STATE();
    case 61:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(81);
      END_STATE();
    case 62:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(105);
      END_STATE();
    case 63:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(62);
      END_STATE();
    case 64:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(107);
      END_STATE();
    case 65:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(64);
      END_STATE();
    case 66:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(89);
      END_STATE();
    case 67:
      if (eof) ADVANCE(68);
      ADVANCE_MAP(
        '"', 5,
        '#', 26,
        '(', 90,
        ')', 91,
        '+', 168,
        ',', 92,
        '-', 12,
        '.', 11,
        '/', 20,
        '0', 129,
        ':', 21,
        ';', 180,
        '<', 140,
        '=', 78,
        '>', 142,
        '@', 75,
        '[', 69,
        '\\', 14,
        ']', 70,
        '_', 136,
        '{', 96,
        '|', 161,
        '}', 97,
        0xac, 147,
        0x2190, 166,
        0x2192, 164,
        0x21d2, 152,
        0x21d4, 154,
        0x2200, 155,
        0x2203, 156,
        0x2205, 170,
        0x2208, 160,
        0x2216, 159,
        0x2227, 148,
        0x2228, 149,
        0x2229, 158,
        0x222a, 157,
        0x2254, 163,
        0x2260, 139,
        0x2264, 144,
        0x2265, 146,
        0x2295, 169,
        0x22a4, 134,
        0x22a5, 135,
        0x22bb, 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(128);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(71);
      if (set_contains(sym_identifier_character_set_1, 112, lookahead)) ADVANCE(72);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 151, lookahead)) ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(27);
      if (set_contains(sym_identifier_character_set_2, 151, lookahead)) ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_AT);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(61);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_AT);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(62);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(23);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (lookahead == '-') ADVANCE(55);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (lookahead == '-') ADVANCE(55);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(80);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(79);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(82);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(83);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(84);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(85);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(86);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(87);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_controlled_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(88);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_u00b7);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(137);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_quoted_string);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_language_tag);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(38);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(38);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(106);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(38);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(38);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(102);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(38);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(103);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(38);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(38);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(100);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(39);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(40);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(41);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_language_tag);
      if (lookahead == '-') ADVANCE(42);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(110);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(108);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_language_tag);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(109);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_iri_token1);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_iri_token1);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(116);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_iri_token1);
      if (lookahead == '\\') ADVANCE(171);
      if ((!eof && lookahead <= '\t') ||
          (0x0b <= lookahead && lookahead <= ' ') ||
          lookahead == '"' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '^' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(180);
      if (lookahead > ' ') ADVANCE(117);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACK);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_hex_byte);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_hex_byte);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == '/') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_double);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_double);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_decimal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(124);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(36);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == '/') ADVANCE(35);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == '/') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == '/') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(121);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == '/') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_rational);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(131);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_unsigned);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_unsigned);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_u22a4);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_u22a5);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_wildcard);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_u2260);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_op_less_than);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_op_less_than);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_op_greater_than);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '=') ADVANCE(24);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_u2264);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_u2265);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_u00ac);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_u2227);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_u2228);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_u22bb);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_GT);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_u21d2);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LT_EQ_EQ_GT);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_u21d4);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_u2200);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_u2203);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_u222a);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_u2229);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_u2216);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_u2208);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_set_op_builder);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_u2254);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_u2192);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_u2190);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_u2295);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__value_empty_sequence);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == 'U') ADVANCE(179);
      if (lookahead == 'u') ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(117);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_line_comment);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'N', 1,
        'T', 2,
        'a', 3,
        'b', 4,
        'c', 5,
        'd', 6,
        'e', 7,
        'f', 8,
        'g', 9,
        'h', 10,
        'i', 11,
        'l', 12,
        'm', 13,
        'n', 14,
        'o', 15,
        'p', 16,
        'r', 17,
        's', 18,
        't', 19,
        'u', 20,
        'v', 21,
        'w', 22,
        'x', 23,
        'y', 24,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'h') ADVANCE(26);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_a);
      if (lookahead == 'n') ADVANCE(27);
      if (lookahead == 's') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'y') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(35);
      if (lookahead == 'e') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 7:
      if (lookahead == 'n') ADVANCE(40);
      if (lookahead == 'v') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(43);
      if (lookahead == 'i') ADVANCE(44);
      if (lookahead == 'l') ADVANCE(45);
      if (lookahead == 'o') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 9:
      if (lookahead == 'D') ADVANCE(48);
      if (lookahead == 'M') ADVANCE(49);
      if (lookahead == 'Y') ADVANCE(50);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(52);
      if (lookahead == 'f') ADVANCE(53);
      if (lookahead == 'm') ADVANCE(54);
      if (lookahead == 'n') ADVANCE(55);
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(58);
      if (lookahead == 'e') ADVANCE(59);
      if (lookahead == 'o') ADVANCE(60);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(61);
      if (lookahead == 'i') ADVANCE(62);
      if (lookahead == 'o') ADVANCE(63);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(66);
      if (lookahead == 'p') ADVANCE(67);
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'o') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(72);
      if (lookahead == 'd') ADVANCE(73);
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(75);
      if (lookahead == 'h') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 19:
      if (lookahead == 'i') ADVANCE(79);
      if (lookahead == 'o') ADVANCE(80);
      if (lookahead == 'r') ADVANCE(81);
      if (lookahead == 'y') ADVANCE(82);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(83);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(86);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 25:
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(89);
      END_STATE();
    case 27:
      if (lookahead == 'd') ADVANCE(90);
      if (lookahead == 'y') ADVANCE(91);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(92);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(93);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 31:
      if (lookahead == 'o') ADVANCE(95);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 33:
      if (lookahead == 'a') ADVANCE(97);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(98);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(99);
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 36:
      if (lookahead == 'c') ADVANCE(101);
      if (lookahead == 'f') ADVANCE(102);
      END_STATE();
    case 37:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(104);
      END_STATE();
    case 39:
      if (lookahead == 'r') ADVANCE(105);
      END_STATE();
    case 40:
      if (lookahead == 'd') ADVANCE(106);
      if (lookahead == 't') ADVANCE(107);
      if (lookahead == 'u') ADVANCE(108);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(109);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(110);
      if (lookahead == 'p') ADVANCE(111);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(112);
      END_STATE();
    case 44:
      if (lookahead == 'x') ADVANCE(113);
      END_STATE();
    case 45:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 46:
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(116);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(117);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 51:
      if (lookahead == 'x') ADVANCE(120);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 53:
      if (lookahead == 'f') ADVANCE(122);
      END_STATE();
    case 54:
      if (lookahead == 'p') ADVANCE(123);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(125);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 58:
      if (lookahead == 'n') ADVANCE(126);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(127);
      END_STATE();
    case 60:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 61:
      if (lookahead == 'x') ADVANCE(129);
      END_STATE();
    case 62:
      if (lookahead == 'n') ADVANCE(130);
      END_STATE();
    case 63:
      if (lookahead == 'd') ADVANCE(131);
      END_STATE();
    case 64:
      if (lookahead == 'g') ADVANCE(132);
      END_STATE();
    case 65:
      if (lookahead == 'n') ADVANCE(133);
      if (lookahead == 'r') ADVANCE(134);
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(136);
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(138);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 70:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(142);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(143);
      END_STATE();
    case 73:
      if (lookahead == 'f') ADVANCE(144);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(145);
      if (lookahead == 'f') ADVANCE(146);
      if (lookahead == 'q') ADVANCE(147);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(149);
      END_STATE();
    case 77:
      if (lookahead == 'u') ADVANCE(150);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(151);
      END_STATE();
    case 79:
      if (lookahead == 'm') ADVANCE(152);
      END_STATE();
    case 80:
      if (lookahead == 'k') ADVANCE(153);
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 81:
      if (lookahead == 'u') ADVANCE(155);
      END_STATE();
    case 82:
      if (lookahead == 'p') ADVANCE(156);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(157);
      if (lookahead == 'k') ADVANCE(158);
      if (lookahead == 'o') ADVANCE(159);
      if (lookahead == 's') ADVANCE(160);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(161);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(163);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(164);
      END_STATE();
    case 88:
      if (lookahead == 'h') ADVANCE(165);
      END_STATE();
    case 89:
      if (lookahead == 'n') ADVANCE(166);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 91:
      if (lookahead == 'U') ADVANCE(167);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(169);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(170);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(171);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 97:
      if (lookahead == 's') ADVANCE(173);
      END_STATE();
    case 98:
      if (lookahead == 'p') ADVANCE(174);
      END_STATE();
    case 99:
      if (lookahead == 'a') ADVANCE(175);
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 100:
      if (lookahead == 'T') ADVANCE(177);
      END_STATE();
    case 101:
      if (lookahead == 'i') ADVANCE(178);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 104:
      if (lookahead == 'b') ADVANCE(180);
      END_STATE();
    case 105:
      if (lookahead == 'a') ADVANCE(181);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 107:
      if (lookahead == 'i') ADVANCE(182);
      END_STATE();
    case 108:
      if (lookahead == 'm') ADVANCE(183);
      END_STATE();
    case 109:
      if (lookahead == 'n') ADVANCE(184);
      END_STATE();
    case 110:
      if (lookahead == 's') ADVANCE(185);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(186);
      END_STATE();
    case 112:
      if (lookahead == 's') ADVANCE(187);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 114:
      if (lookahead == 'a') ADVANCE(189);
      END_STATE();
    case 115:
      if (lookahead == 'a') ADVANCE(190);
      END_STATE();
    case 116:
      if (lookahead == 'c') ADVANCE(191);
      END_STATE();
    case 117:
      if (lookahead == 'y') ADVANCE(192);
      END_STATE();
    case 118:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 119:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 120:
      if (lookahead == 'B') ADVANCE(195);
      END_STATE();
    case 121:
      if (lookahead == 'n') ADVANCE(196);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_iff);
      END_STATE();
    case 123:
      if (lookahead == 'l') ADVANCE(197);
      if (lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_iri);
      END_STATE();
    case 126:
      if (lookahead == 'g') ADVANCE(200);
      END_STATE();
    case 127:
      if (lookahead == 'g') ADVANCE(201);
      END_STATE();
    case 128:
      if (lookahead == 'g') ADVANCE(202);
      END_STATE();
    case 129:
      if (lookahead == 'E') ADVANCE(203);
      if (lookahead == 'I') ADVANCE(204);
      if (lookahead == 'L') ADVANCE(205);
      END_STATE();
    case 130:
      if (lookahead == 'E') ADVANCE(206);
      if (lookahead == 'I') ADVANCE(207);
      if (lookahead == 'L') ADVANCE(208);
      END_STATE();
    case 131:
      if (lookahead == 'u') ADVANCE(209);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(210);
      END_STATE();
    case 133:
      if (lookahead == 'N') ADVANCE(211);
      if (lookahead == 'P') ADVANCE(212);
      if (lookahead == 'u') ADVANCE(213);
      END_STATE();
    case 134:
      if (lookahead == 'm') ADVANCE(214);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 136:
      if (lookahead == 'q') ADVANCE(215);
      END_STATE();
    case 137:
      if (lookahead == 'i') ADVANCE(216);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(217);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 140:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 141:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 142:
      if (lookahead == 'h') ADVANCE(221);
      if (lookahead == 'p') ADVANCE(222);
      END_STATE();
    case 143:
      if (lookahead == 'i') ADVANCE(223);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_rdf);
      END_STATE();
    case 145:
      if (lookahead == 'l') ADVANCE(224);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 147:
      if (lookahead == 'u') ADVANCE(225);
      END_STATE();
    case 148:
      if (lookahead == 'f') ADVANCE(226);
      END_STATE();
    case 149:
      if (lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 150:
      if (lookahead == 'r') ADVANCE(228);
      END_STATE();
    case 151:
      if (lookahead == 'i') ADVANCE(229);
      if (lookahead == 'u') ADVANCE(230);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 153:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 154:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(235);
      END_STATE();
    case 157:
      if (lookahead == 'o') ADVANCE(236);
      if (lookahead == 'q') ADVANCE(237);
      END_STATE();
    case 158:
      if (lookahead == 'n') ADVANCE(238);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 160:
      if (lookahead == 'i') ADVANCE(240);
      END_STATE();
    case 161:
      if (lookahead == 's') ADVANCE(241);
      END_STATE();
    case 162:
      if (lookahead == 'h') ADVANCE(242);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(244);
      END_STATE();
    case 166:
      if (lookahead == 'g') ADVANCE(245);
      END_STATE();
    case 167:
      if (lookahead == 'R') ADVANCE(246);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(247);
      END_STATE();
    case 169:
      if (lookahead == '6') ADVANCE(248);
      END_STATE();
    case 170:
      if (lookahead == 'r') ADVANCE(249);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(250);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 173:
      if (lookahead == 's') ADVANCE(251);
      END_STATE();
    case 174:
      if (lookahead == 'l') ADVANCE(252);
      END_STATE();
    case 175:
      if (lookahead == 't') ADVANCE(253);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_date);
      if (lookahead == 'T') ADVANCE(254);
      END_STATE();
    case 177:
      if (lookahead == 'i') ADVANCE(255);
      END_STATE();
    case 178:
      if (lookahead == 'm') ADVANCE(256);
      END_STATE();
    case 179:
      if (lookahead == 'n') ADVANCE(257);
      END_STATE();
    case 180:
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 181:
      if (lookahead == 't') ADVANCE(259);
      END_STATE();
    case 182:
      if (lookahead == 't') ADVANCE(260);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 184:
      if (lookahead == 't') ADVANCE(261);
      END_STATE();
    case 185:
      if (lookahead == 't') ADVANCE(262);
      END_STATE();
    case 186:
      if (lookahead == 'i') ADVANCE(263);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 188:
      if (lookahead == 'd') ADVANCE(265);
      END_STATE();
    case 189:
      if (lookahead == 't') ADVANCE(266);
      END_STATE();
    case 190:
      if (lookahead == 'l') ADVANCE(267);
      END_STATE();
    case 191:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_gDay);
      END_STATE();
    case 193:
      if (lookahead == 't') ADVANCE(269);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(270);
      END_STATE();
    case 195:
      if (lookahead == 'i') ADVANCE(271);
      END_STATE();
    case 196:
      if (lookahead == 't') ADVANCE(272);
      END_STATE();
    case 197:
      if (lookahead == 'i') ADVANCE(273);
      END_STATE();
    case 198:
      if (lookahead == 'r') ADVANCE(274);
      END_STATE();
    case 199:
      if (lookahead == 'g') ADVANCE(275);
      if (lookahead == 'r') ADVANCE(276);
      END_STATE();
    case 200:
      if (lookahead == 'u') ADVANCE(277);
      END_STATE();
    case 201:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 203:
      if (lookahead == 'x') ADVANCE(279);
      END_STATE();
    case 204:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 205:
      if (lookahead == 'e') ADVANCE(281);
      END_STATE();
    case 206:
      if (lookahead == 'x') ADVANCE(282);
      END_STATE();
    case 207:
      if (lookahead == 'n') ADVANCE(283);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 209:
      if (lookahead == 'l') ADVANCE(285);
      END_STATE();
    case 210:
      if (lookahead == 't') ADVANCE(286);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 212:
      if (lookahead == 'o') ADVANCE(288);
      END_STATE();
    case 213:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 214:
      if (lookahead == 'a') ADVANCE(290);
      END_STATE();
    case 215:
      if (lookahead == 'u') ADVANCE(291);
      END_STATE();
    case 216:
      if (lookahead == 'o') ADVANCE(292);
      END_STATE();
    case 217:
      if (lookahead == 'r') ADVANCE(293);
      END_STATE();
    case 218:
      if (lookahead == 'n') ADVANCE(294);
      END_STATE();
    case 219:
      if (lookahead == 'e') ADVANCE(295);
      END_STATE();
    case 220:
      if (lookahead == 't') ADVANCE(296);
      END_STATE();
    case 221:
      if (lookahead == 'i') ADVANCE(297);
      END_STATE();
    case 222:
      if (lookahead == 'e') ADVANCE(298);
      END_STATE();
    case 223:
      if (lookahead == 'o') ADVANCE(299);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_real);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(300);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_reserved_self);
      END_STATE();
    case 227:
      if (lookahead == 't') ADVANCE(301);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(302);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(303);
      END_STATE();
    case 230:
      if (lookahead == 'c') ADVANCE(304);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_time);
      END_STATE();
    case 232:
      if (lookahead == 'n') ADVANCE(305);
      END_STATE();
    case 233:
      if (lookahead == 'l') ADVANCE(306);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 236:
      if (lookahead == 'n') ADVANCE(307);
      END_STATE();
    case 237:
      if (lookahead == 'u') ADVANCE(308);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(309);
      END_STATE();
    case 239:
      if (lookahead == 'd') ADVANCE(310);
      END_STATE();
    case 240:
      if (lookahead == 'g') ADVANCE(311);
      END_STATE();
    case 241:
      if (lookahead == 'i') ADVANCE(312);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 243:
      if (lookahead == 'M') ADVANCE(313);
      END_STATE();
    case 244:
      if (lookahead == 'n') ADVANCE(314);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_Thing);
      END_STATE();
    case 246:
      if (lookahead == 'I') ADVANCE(315);
      END_STATE();
    case 247:
      if (lookahead == 't') ADVANCE(316);
      END_STATE();
    case 248:
      if (lookahead == '4') ADVANCE(317);
      END_STATE();
    case 249:
      if (lookahead == 'y') ADVANCE(318);
      END_STATE();
    case 250:
      if (lookahead == 'a') ADVANCE(319);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 252:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 253:
      if (lookahead == 'y') ADVANCE(321);
      END_STATE();
    case 254:
      if (lookahead == 'i') ADVANCE(322);
      END_STATE();
    case 255:
      if (lookahead == 'm') ADVANCE(323);
      END_STATE();
    case 256:
      if (lookahead == 'a') ADVANCE(324);
      END_STATE();
    case 257:
      if (lookahead == 's') ADVANCE(325);
      END_STATE();
    case 258:
      if (lookahead == 'e') ADVANCE(326);
      END_STATE();
    case 259:
      if (lookahead == 'i') ADVANCE(327);
      END_STATE();
    case 260:
      if (lookahead == 'y') ADVANCE(328);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 262:
      if (lookahead == 's') ADVANCE(329);
      END_STATE();
    case 263:
      if (lookahead == 'c') ADVANCE(330);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_kw_is_fixed);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 267:
      if (lookahead == 'l') ADVANCE(331);
      END_STATE();
    case 268:
      if (lookahead == 'i') ADVANCE(332);
      END_STATE();
    case 269:
      if (lookahead == 'h') ADVANCE(333);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_gYear);
      if (lookahead == 'M') ADVANCE(334);
      END_STATE();
    case 271:
      if (lookahead == 'n') ADVANCE(335);
      END_STATE();
    case 272:
      if (lookahead == 'i') ADVANCE(336);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(337);
      END_STATE();
    case 274:
      if (lookahead == 't') ADVANCE(338);
      END_STATE();
    case 275:
      if (lookahead == 'e') ADVANCE(339);
      END_STATE();
    case 276:
      if (lookahead == 's') ADVANCE(340);
      END_STATE();
    case 277:
      if (lookahead == 'a') ADVANCE(341);
      END_STATE();
    case 278:
      if (lookahead == 'h') ADVANCE(342);
      END_STATE();
    case 279:
      if (lookahead == 'c') ADVANCE(343);
      END_STATE();
    case 280:
      if (lookahead == 'c') ADVANCE(344);
      END_STATE();
    case 281:
      if (lookahead == 'n') ADVANCE(345);
      END_STATE();
    case 282:
      if (lookahead == 'c') ADVANCE(346);
      END_STATE();
    case 283:
      if (lookahead == 'c') ADVANCE(347);
      END_STATE();
    case 284:
      if (lookahead == 'n') ADVANCE(348);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(349);
      END_STATE();
    case 286:
      if (lookahead == 'i') ADVANCE(350);
      END_STATE();
    case 287:
      if (lookahead == 'g') ADVANCE(351);
      END_STATE();
    case 288:
      if (lookahead == 's') ADVANCE(352);
      END_STATE();
    case 289:
      if (lookahead == 'i') ADVANCE(353);
      END_STATE();
    case 290:
      if (lookahead == 'l') ADVANCE(354);
      END_STATE();
    case 291:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 292:
      if (lookahead == 'n') ADVANCE(356);
      END_STATE();
    case 293:
      if (lookahead == 'e') ADVANCE(357);
      END_STATE();
    case 294:
      if (lookahead == 't') ADVANCE(358);
      END_STATE();
    case 295:
      if (lookahead == 'r') ADVANCE(359);
      END_STATE();
    case 296:
      if (lookahead == 'i') ADVANCE(360);
      END_STATE();
    case 297:
      if (lookahead == 'b') ADVANCE(361);
      END_STATE();
    case 298:
      if (lookahead == 'r') ADVANCE(362);
      END_STATE();
    case 299:
      if (lookahead == 'n') ADVANCE(363);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(364);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 302:
      if (lookahead == 'e') ADVANCE(365);
      END_STATE();
    case 303:
      if (lookahead == 'g') ADVANCE(366);
      END_STATE();
    case 304:
      if (lookahead == 't') ADVANCE(367);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_token);
      END_STATE();
    case 306:
      if (lookahead == 'D') ADVANCE(368);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 308:
      if (lookahead == 'e') ADVANCE(369);
      END_STATE();
    case 309:
      if (lookahead == 'w') ADVANCE(370);
      END_STATE();
    case 310:
      if (lookahead == 'e') ADVANCE(371);
      END_STATE();
    case 311:
      if (lookahead == 'n') ADVANCE(372);
      END_STATE();
    case 312:
      if (lookahead == 'o') ADVANCE(373);
      END_STATE();
    case 313:
      if (lookahead == 'o') ADVANCE(374);
      END_STATE();
    case 314:
      if (lookahead == 'g') ADVANCE(375);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_anyURI);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 317:
      if (lookahead == 'B') ADVANCE(376);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_binary);
      END_STATE();
    case 319:
      if (lookahead == 'n') ADVANCE(377);
      END_STATE();
    case 320:
      if (lookahead == 'm') ADVANCE(378);
      END_STATE();
    case 321:
      if (lookahead == 'p') ADVANCE(379);
      END_STATE();
    case 322:
      if (lookahead == 'm') ADVANCE(380);
      END_STATE();
    case 323:
      if (lookahead == 'e') ADVANCE(381);
      END_STATE();
    case 324:
      if (lookahead == 'l') ADVANCE(382);
      END_STATE();
    case 325:
      if (lookahead == 'i') ADVANCE(383);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 327:
      if (lookahead == 'o') ADVANCE(384);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_entity);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_exists);
      END_STATE();
    case 330:
      if (lookahead == 'i') ADVANCE(385);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 332:
      if (lookahead == 'o') ADVANCE(386);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_gMonth);
      if (lookahead == 'D') ADVANCE(387);
      END_STATE();
    case 334:
      if (lookahead == 'o') ADVANCE(388);
      END_STATE();
    case 335:
      if (lookahead == 'a') ADVANCE(389);
      END_STATE();
    case 336:
      if (lookahead == 't') ADVANCE(390);
      END_STATE();
    case 337:
      if (lookahead == 's') ADVANCE(391);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 339:
      if (lookahead == 'r') ADVANCE(392);
      END_STATE();
    case 340:
      if (lookahead == 'e') ADVANCE(393);
      END_STATE();
    case 341:
      if (lookahead == 'g') ADVANCE(394);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_length);
      END_STATE();
    case 343:
      if (lookahead == 'l') ADVANCE(395);
      END_STATE();
    case 344:
      if (lookahead == 'l') ADVANCE(396);
      END_STATE();
    case 345:
      if (lookahead == 'g') ADVANCE(397);
      END_STATE();
    case 346:
      if (lookahead == 'l') ADVANCE(398);
      END_STATE();
    case 347:
      if (lookahead == 'l') ADVANCE(399);
      END_STATE();
    case 348:
      if (lookahead == 'g') ADVANCE(400);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 350:
      if (lookahead == 'v') ADVANCE(401);
      END_STATE();
    case 351:
      if (lookahead == 'a') ADVANCE(402);
      END_STATE();
    case 352:
      if (lookahead == 'i') ADVANCE(403);
      END_STATE();
    case 353:
      if (lookahead == 'q') ADVANCE(404);
      END_STATE();
    case 354:
      if (lookahead == 'i') ADVANCE(405);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym_opaque);
      END_STATE();
    case 356:
      if (lookahead == 'a') ADVANCE(406);
      END_STATE();
    case 357:
      if (lookahead == 'd') ADVANCE(407);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_parent);
      END_STATE();
    case 359:
      if (lookahead == 'n') ADVANCE(408);
      END_STATE();
    case 360:
      if (lookahead == 'v') ADVANCE(409);
      END_STATE();
    case 361:
      if (lookahead == 'i') ADVANCE(410);
      END_STATE();
    case 362:
      if (lookahead == 't') ADVANCE(411);
      END_STATE();
    case 363:
      if (lookahead == 'a') ADVANCE(412);
      END_STATE();
    case 364:
      if (lookahead == 'e') ADVANCE(413);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_source);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 367:
      if (lookahead == 'u') ADVANCE(414);
      END_STATE();
    case 368:
      if (lookahead == 'i') ADVANCE(415);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_unique);
      END_STATE();
    case 370:
      if (lookahead == 'n') ADVANCE(416);
      END_STATE();
    case 371:
      if (lookahead == 'r') ADVANCE(417);
      END_STATE();
    case 372:
      if (lookahead == 'e') ADVANCE(418);
      END_STATE();
    case 373:
      if (lookahead == 'n') ADVANCE(419);
      END_STATE();
    case 374:
      if (lookahead == 'n') ADVANCE(420);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_Nothing);
      END_STATE();
    case 376:
      if (lookahead == 'i') ADVANCE(421);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 378:
      if (lookahead == 'e') ADVANCE(422);
      END_STATE();
    case 379:
      if (lookahead == 'e') ADVANCE(423);
      END_STATE();
    case 380:
      if (lookahead == 'e') ADVANCE(424);
      END_STATE();
    case 381:
      if (lookahead == 'D') ADVANCE(425);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_decimal);
      END_STATE();
    case 383:
      if (lookahead == 'o') ADVANCE(426);
      END_STATE();
    case 384:
      if (lookahead == 'n') ADVANCE(427);
      END_STATE();
    case 385:
      if (lookahead == 't') ADVANCE(428);
      END_STATE();
    case 386:
      if (lookahead == 'n') ADVANCE(429);
      END_STATE();
    case 387:
      if (lookahead == 'a') ADVANCE(430);
      END_STATE();
    case 388:
      if (lookahead == 'n') ADVANCE(431);
      END_STATE();
    case 389:
      if (lookahead == 'r') ADVANCE(432);
      END_STATE();
    case 390:
      if (lookahead == 'y') ADVANCE(433);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_implies);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_integer);
      END_STATE();
    case 393:
      if (lookahead == 'c') ADVANCE(434);
      END_STATE();
    case 394:
      if (lookahead == 'e') ADVANCE(435);
      END_STATE();
    case 395:
      if (lookahead == 'u') ADVANCE(436);
      END_STATE();
    case 396:
      if (lookahead == 'u') ADVANCE(437);
      END_STATE();
    case 397:
      if (lookahead == 't') ADVANCE(438);
      END_STATE();
    case 398:
      if (lookahead == 'u') ADVANCE(439);
      END_STATE();
    case 399:
      if (lookahead == 'u') ADVANCE(440);
      END_STATE();
    case 400:
      if (lookahead == 't') ADVANCE(441);
      END_STATE();
    case 401:
      if (lookahead == 'e') ADVANCE(442);
      END_STATE();
    case 402:
      if (lookahead == 't') ADVANCE(443);
      END_STATE();
    case 403:
      if (lookahead == 't') ADVANCE(444);
      END_STATE();
    case 404:
      if (lookahead == 'u') ADVANCE(445);
      END_STATE();
    case 405:
      if (lookahead == 'z') ADVANCE(446);
      END_STATE();
    case 406:
      if (lookahead == 'l') ADVANCE(447);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_ordered);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_pattern);
      END_STATE();
    case 409:
      if (lookahead == 'e') ADVANCE(448);
      END_STATE();
    case 410:
      if (lookahead == 't') ADVANCE(449);
      END_STATE();
    case 411:
      if (lookahead == 'y') ADVANCE(450);
      END_STATE();
    case 412:
      if (lookahead == 'l') ADVANCE(451);
      END_STATE();
    case 413:
      if (lookahead == 'd') ADVANCE(452);
      END_STATE();
    case 414:
      if (lookahead == 'r') ADVANCE(453);
      END_STATE();
    case 415:
      if (lookahead == 'g') ADVANCE(454);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_unknown_type);
      END_STATE();
    case 417:
      if (lookahead == 'e') ADVANCE(455);
      END_STATE();
    case 418:
      if (lookahead == 'd') ADVANCE(456);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_version);
      END_STATE();
    case 420:
      if (lookahead == 't') ADVANCE(457);
      END_STATE();
    case 421:
      if (lookahead == 'n') ADVANCE(458);
      END_STATE();
    case 422:
      if (lookahead == 'n') ADVANCE(459);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_datatype);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_dateTime);
      if (lookahead == 'S') ADVANCE(460);
      END_STATE();
    case 425:
      if (lookahead == 'u') ADVANCE(461);
      END_STATE();
    case 426:
      if (lookahead == 'n') ADVANCE(462);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_duration);
      END_STATE();
    case 428:
      if (lookahead == 'T') ADVANCE(463);
      END_STATE();
    case 429:
      if (lookahead == 'D') ADVANCE(464);
      END_STATE();
    case 430:
      if (lookahead == 'y') ADVANCE(465);
      END_STATE();
    case 431:
      if (lookahead == 't') ADVANCE(466);
      END_STATE();
    case 432:
      if (lookahead == 'y') ADVANCE(467);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_identity);
      END_STATE();
    case 434:
      if (lookahead == 't') ADVANCE(468);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_language);
      END_STATE();
    case 436:
      if (lookahead == 's') ADVANCE(469);
      END_STATE();
    case 437:
      if (lookahead == 's') ADVANCE(470);
      END_STATE();
    case 438:
      if (lookahead == 'h') ADVANCE(471);
      END_STATE();
    case 439:
      if (lookahead == 's') ADVANCE(472);
      END_STATE();
    case 440:
      if (lookahead == 's') ADVANCE(473);
      END_STATE();
    case 441:
      if (lookahead == 'h') ADVANCE(474);
      END_STATE();
    case 442:
      if (lookahead == 'I') ADVANCE(475);
      END_STATE();
    case 443:
      if (lookahead == 'i') ADVANCE(476);
      END_STATE();
    case 444:
      if (lookahead == 'i') ADVANCE(477);
      END_STATE();
    case 445:
      if (lookahead == 'e') ADVANCE(478);
      END_STATE();
    case 446:
      if (lookahead == 'e') ADVANCE(479);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_optional);
      END_STATE();
    case 448:
      if (lookahead == 'I') ADVANCE(480);
      END_STATE();
    case 449:
      if (lookahead == 'e') ADVANCE(481);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_rational);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 453:
      if (lookahead == 'e') ADVANCE(482);
      END_STATE();
    case 454:
      if (lookahead == 'i') ADVANCE(483);
      END_STATE();
    case 455:
      if (lookahead == 'd') ADVANCE(484);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_unsigned);
      if (lookahead == 'B') ADVANCE(485);
      if (lookahead == 'I') ADVANCE(486);
      if (lookahead == 'L') ADVANCE(487);
      if (lookahead == 'S') ADVANCE(488);
      END_STATE();
    case 457:
      if (lookahead == 'h') ADVANCE(489);
      END_STATE();
    case 458:
      if (lookahead == 'a') ADVANCE(490);
      END_STATE();
    case 459:
      if (lookahead == 't') ADVANCE(491);
      END_STATE();
    case 460:
      if (lookahead == 't') ADVANCE(492);
      END_STATE();
    case 461:
      if (lookahead == 'r') ADVANCE(493);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_dimension);
      END_STATE();
    case 463:
      if (lookahead == 'i') ADVANCE(494);
      END_STATE();
    case 464:
      if (lookahead == 'i') ADVANCE(495);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_gMonthDay);
      END_STATE();
    case 466:
      if (lookahead == 'h') ADVANCE(496);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_hexBinary);
      END_STATE();
    case 468:
      if (lookahead == 'i') ADVANCE(497);
      END_STATE();
    case 469:
      if (lookahead == 'i') ADVANCE(498);
      END_STATE();
    case 470:
      if (lookahead == 'i') ADVANCE(499);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_maxLength);
      END_STATE();
    case 472:
      if (lookahead == 'i') ADVANCE(500);
      END_STATE();
    case 473:
      if (lookahead == 'i') ADVANCE(501);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_minLength);
      END_STATE();
    case 475:
      if (lookahead == 'n') ADVANCE(502);
      END_STATE();
    case 476:
      if (lookahead == 'v') ADVANCE(503);
      END_STATE();
    case 477:
      if (lookahead == 'v') ADVANCE(504);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_nonunique);
      END_STATE();
    case 479:
      if (lookahead == 'd') ADVANCE(505);
      END_STATE();
    case 480:
      if (lookahead == 'n') ADVANCE(506);
      END_STATE();
    case 481:
      if (lookahead == 'd') ADVANCE(507);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_structure);
      END_STATE();
    case 483:
      if (lookahead == 't') ADVANCE(508);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_unordered);
      END_STATE();
    case 485:
      if (lookahead == 'y') ADVANCE(509);
      END_STATE();
    case 486:
      if (lookahead == 'n') ADVANCE(510);
      END_STATE();
    case 487:
      if (lookahead == 'o') ADVANCE(511);
      END_STATE();
    case 488:
      if (lookahead == 'h') ADVANCE(512);
      END_STATE();
    case 489:
      if (lookahead == 'D') ADVANCE(513);
      END_STATE();
    case 490:
      if (lookahead == 'r') ADVANCE(514);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_complement);
      END_STATE();
    case 492:
      if (lookahead == 'a') ADVANCE(515);
      END_STATE();
    case 493:
      if (lookahead == 'a') ADVANCE(516);
      END_STATE();
    case 494:
      if (lookahead == 'm') ADVANCE(517);
      END_STATE();
    case 495:
      if (lookahead == 'g') ADVANCE(518);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_gYearMonth);
      END_STATE();
    case 497:
      if (lookahead == 'o') ADVANCE(519);
      END_STATE();
    case 498:
      if (lookahead == 'v') ADVANCE(520);
      END_STATE();
    case 499:
      if (lookahead == 'v') ADVANCE(521);
      END_STATE();
    case 500:
      if (lookahead == 'v') ADVANCE(522);
      END_STATE();
    case 501:
      if (lookahead == 'v') ADVANCE(523);
      END_STATE();
    case 502:
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 503:
      if (lookahead == 'e') ADVANCE(525);
      END_STATE();
    case 504:
      if (lookahead == 'e') ADVANCE(526);
      END_STATE();
    case 505:
      if (lookahead == 'S') ADVANCE(527);
      END_STATE();
    case 506:
      if (lookahead == 't') ADVANCE(528);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_prohibited);
      END_STATE();
    case 508:
      if (lookahead == 's') ADVANCE(529);
      END_STATE();
    case 509:
      if (lookahead == 't') ADVANCE(530);
      END_STATE();
    case 510:
      if (lookahead == 't') ADVANCE(531);
      END_STATE();
    case 511:
      if (lookahead == 'n') ADVANCE(532);
      END_STATE();
    case 512:
      if (lookahead == 'o') ADVANCE(533);
      END_STATE();
    case 513:
      if (lookahead == 'u') ADVANCE(534);
      END_STATE();
    case 514:
      if (lookahead == 'y') ADVANCE(535);
      END_STATE();
    case 515:
      if (lookahead == 'm') ADVANCE(536);
      END_STATE();
    case 516:
      if (lookahead == 't') ADVANCE(537);
      END_STATE();
    case 517:
      if (lookahead == 'e') ADVANCE(538);
      END_STATE();
    case 518:
      if (lookahead == 'i') ADVANCE(539);
      END_STATE();
    case 519:
      if (lookahead == 'n') ADVANCE(540);
      END_STATE();
    case 520:
      if (lookahead == 'e') ADVANCE(541);
      END_STATE();
    case 521:
      if (lookahead == 'e') ADVANCE(542);
      END_STATE();
    case 522:
      if (lookahead == 'e') ADVANCE(543);
      END_STATE();
    case 523:
      if (lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 524:
      if (lookahead == 'e') ADVANCE(545);
      END_STATE();
    case 525:
      if (lookahead == 'I') ADVANCE(546);
      END_STATE();
    case 526:
      if (lookahead == 'I') ADVANCE(547);
      END_STATE();
    case 527:
      if (lookahead == 't') ADVANCE(548);
      END_STATE();
    case 528:
      if (lookahead == 'e') ADVANCE(549);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_totalDigits);
      END_STATE();
    case 530:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_unsignedInt);
      END_STATE();
    case 532:
      if (lookahead == 'g') ADVANCE(551);
      END_STATE();
    case 533:
      if (lookahead == 'r') ADVANCE(552);
      END_STATE();
    case 534:
      if (lookahead == 'r') ADVANCE(553);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_base64Binary);
      END_STATE();
    case 536:
      if (lookahead == 'p') ADVANCE(554);
      END_STATE();
    case 537:
      if (lookahead == 'i') ADVANCE(555);
      END_STATE();
    case 538:
      if (lookahead == 'z') ADVANCE(556);
      END_STATE();
    case 539:
      if (lookahead == 't') ADVANCE(557);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_intersection);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_maxExclusive);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_maxInclusive);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_minExclusive);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_minInclusive);
      END_STATE();
    case 545:
      if (lookahead == 'g') ADVANCE(558);
      END_STATE();
    case 546:
      if (lookahead == 'n') ADVANCE(559);
      END_STATE();
    case 547:
      if (lookahead == 'n') ADVANCE(560);
      END_STATE();
    case 548:
      if (lookahead == 'r') ADVANCE(561);
      END_STATE();
    case 549:
      if (lookahead == 'g') ADVANCE(562);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_unsignedByte);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_unsignedLong);
      END_STATE();
    case 552:
      if (lookahead == 't') ADVANCE(563);
      END_STATE();
    case 553:
      if (lookahead == 'a') ADVANCE(564);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_dateTimeStamp);
      END_STATE();
    case 555:
      if (lookahead == 'o') ADVANCE(565);
      END_STATE();
    case 556:
      if (lookahead == 'o') ADVANCE(566);
      END_STATE();
    case 557:
      if (lookahead == 's') ADVANCE(567);
      END_STATE();
    case 558:
      if (lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 559:
      if (lookahead == 't') ADVANCE(569);
      END_STATE();
    case 560:
      if (lookahead == 't') ADVANCE(570);
      END_STATE();
    case 561:
      if (lookahead == 'i') ADVANCE(571);
      END_STATE();
    case 562:
      if (lookahead == 'e') ADVANCE(572);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_unsignedShort);
      END_STATE();
    case 564:
      if (lookahead == 't') ADVANCE(573);
      END_STATE();
    case 565:
      if (lookahead == 'n') ADVANCE(574);
      END_STATE();
    case 566:
      if (lookahead == 'n') ADVANCE(575);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_fractionDigits);
      END_STATE();
    case 568:
      if (lookahead == 'r') ADVANCE(576);
      END_STATE();
    case 569:
      if (lookahead == 'e') ADVANCE(577);
      END_STATE();
    case 570:
      if (lookahead == 'e') ADVANCE(578);
      END_STATE();
    case 571:
      if (lookahead == 'n') ADVANCE(579);
      END_STATE();
    case 572:
      if (lookahead == 'r') ADVANCE(580);
      END_STATE();
    case 573:
      if (lookahead == 'i') ADVANCE(581);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_dayTimeDuration);
      END_STATE();
    case 575:
      if (lookahead == 'e') ADVANCE(582);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_negativeInteger);
      END_STATE();
    case 577:
      if (lookahead == 'g') ADVANCE(583);
      END_STATE();
    case 578:
      if (lookahead == 'g') ADVANCE(584);
      END_STATE();
    case 579:
      if (lookahead == 'g') ADVANCE(585);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_positiveInteger);
      END_STATE();
    case 581:
      if (lookahead == 'o') ADVANCE(586);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(anon_sym_explicitTimezone);
      END_STATE();
    case 583:
      if (lookahead == 'e') ADVANCE(587);
      END_STATE();
    case 584:
      if (lookahead == 'e') ADVANCE(588);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_normalizedString);
      END_STATE();
    case 586:
      if (lookahead == 'n') ADVANCE(589);
      END_STATE();
    case 587:
      if (lookahead == 'r') ADVANCE(590);
      END_STATE();
    case 588:
      if (lookahead == 'r') ADVANCE(591);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_yearMonthDuration);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_nonNegativeInteger);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_nonPositiveInteger);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 6},
  [2] = {.lex_state = 6},
  [3] = {.lex_state = 9},
  [4] = {.lex_state = 6},
  [5] = {.lex_state = 6},
  [6] = {.lex_state = 6},
  [7] = {.lex_state = 6},
  [8] = {.lex_state = 6},
  [9] = {.lex_state = 6},
  [10] = {.lex_state = 6},
  [11] = {.lex_state = 6},
  [12] = {.lex_state = 6},
  [13] = {.lex_state = 6},
  [14] = {.lex_state = 6},
  [15] = {.lex_state = 6},
  [16] = {.lex_state = 6},
  [17] = {.lex_state = 6},
  [18] = {.lex_state = 6},
  [19] = {.lex_state = 6},
  [20] = {.lex_state = 6},
  [21] = {.lex_state = 1},
  [22] = {.lex_state = 1},
  [23] = {.lex_state = 1},
  [24] = {.lex_state = 1},
  [25] = {.lex_state = 1},
  [26] = {.lex_state = 1},
  [27] = {.lex_state = 1},
  [28] = {.lex_state = 1},
  [29] = {.lex_state = 1},
  [30] = {.lex_state = 1},
  [31] = {.lex_state = 1},
  [32] = {.lex_state = 6},
  [33] = {.lex_state = 1},
  [34] = {.lex_state = 6},
  [35] = {.lex_state = 6},
  [36] = {.lex_state = 6},
  [37] = {.lex_state = 6},
  [38] = {.lex_state = 6},
  [39] = {.lex_state = 6},
  [40] = {.lex_state = 6},
  [41] = {.lex_state = 6},
  [42] = {.lex_state = 6},
  [43] = {.lex_state = 6},
  [44] = {.lex_state = 6},
  [45] = {.lex_state = 1},
  [46] = {.lex_state = 1},
  [47] = {.lex_state = 1},
  [48] = {.lex_state = 1},
  [49] = {.lex_state = 1},
  [50] = {.lex_state = 1},
  [51] = {.lex_state = 1},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 1},
  [54] = {.lex_state = 1},
  [55] = {.lex_state = 1},
  [56] = {.lex_state = 1},
  [57] = {.lex_state = 1},
  [58] = {.lex_state = 1},
  [59] = {.lex_state = 1},
  [60] = {.lex_state = 1},
  [61] = {.lex_state = 6},
  [62] = {.lex_state = 1},
  [63] = {.lex_state = 1},
  [64] = {.lex_state = 6},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 6},
  [67] = {.lex_state = 1},
  [68] = {.lex_state = 6},
  [69] = {.lex_state = 1},
  [70] = {.lex_state = 1},
  [71] = {.lex_state = 1},
  [72] = {.lex_state = 1},
  [73] = {.lex_state = 1},
  [74] = {.lex_state = 6},
  [75] = {.lex_state = 6},
  [76] = {.lex_state = 6},
  [77] = {.lex_state = 6},
  [78] = {.lex_state = 6},
  [79] = {.lex_state = 1},
  [80] = {.lex_state = 1},
  [81] = {.lex_state = 1},
  [82] = {.lex_state = 6},
  [83] = {.lex_state = 6},
  [84] = {.lex_state = 6},
  [85] = {.lex_state = 6},
  [86] = {.lex_state = 6},
  [87] = {.lex_state = 6},
  [88] = {.lex_state = 6},
  [89] = {.lex_state = 6},
  [90] = {.lex_state = 6},
  [91] = {.lex_state = 6},
  [92] = {.lex_state = 6},
  [93] = {.lex_state = 6},
  [94] = {.lex_state = 6},
  [95] = {.lex_state = 1},
  [96] = {.lex_state = 1},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 1},
  [99] = {.lex_state = 1},
  [100] = {.lex_state = 6},
  [101] = {.lex_state = 1},
  [102] = {.lex_state = 6},
  [103] = {.lex_state = 1},
  [104] = {.lex_state = 1},
  [105] = {.lex_state = 1},
  [106] = {.lex_state = 1},
  [107] = {.lex_state = 1},
  [108] = {.lex_state = 1},
  [109] = {.lex_state = 1},
  [110] = {.lex_state = 1},
  [111] = {.lex_state = 3},
  [112] = {.lex_state = 6},
  [113] = {.lex_state = 6},
  [114] = {.lex_state = 1},
  [115] = {.lex_state = 1},
  [116] = {.lex_state = 6},
  [117] = {.lex_state = 1},
  [118] = {.lex_state = 6},
  [119] = {.lex_state = 1},
  [120] = {.lex_state = 1},
  [121] = {.lex_state = 1},
  [122] = {.lex_state = 1},
  [123] = {.lex_state = 1},
  [124] = {.lex_state = 1},
  [125] = {.lex_state = 1},
  [126] = {.lex_state = 6},
  [127] = {.lex_state = 1},
  [128] = {.lex_state = 6},
  [129] = {.lex_state = 1},
  [130] = {.lex_state = 1},
  [131] = {.lex_state = 1},
  [132] = {.lex_state = 1},
  [133] = {.lex_state = 6},
  [134] = {.lex_state = 1},
  [135] = {.lex_state = 6},
  [136] = {.lex_state = 6},
  [137] = {.lex_state = 6},
  [138] = {.lex_state = 6},
  [139] = {.lex_state = 6},
  [140] = {.lex_state = 6},
  [141] = {.lex_state = 6},
  [142] = {.lex_state = 6},
  [143] = {.lex_state = 1},
  [144] = {.lex_state = 1},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 1},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 1},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 6},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 1},
  [155] = {.lex_state = 6},
  [156] = {.lex_state = 1},
  [157] = {.lex_state = 6},
  [158] = {.lex_state = 6},
  [159] = {.lex_state = 17},
  [160] = {.lex_state = 6},
  [161] = {.lex_state = 1},
  [162] = {.lex_state = 1},
  [163] = {.lex_state = 6},
  [164] = {.lex_state = 1},
  [165] = {.lex_state = 1},
  [166] = {.lex_state = 6},
  [167] = {.lex_state = 1},
  [168] = {.lex_state = 6},
  [169] = {.lex_state = 6},
  [170] = {.lex_state = 6},
  [171] = {.lex_state = 6},
  [172] = {.lex_state = 6},
  [173] = {.lex_state = 6},
  [174] = {.lex_state = 6},
  [175] = {.lex_state = 6},
  [176] = {.lex_state = 6},
  [177] = {.lex_state = 1},
  [178] = {.lex_state = 6},
  [179] = {.lex_state = 6},
  [180] = {.lex_state = 1},
  [181] = {.lex_state = 1},
  [182] = {.lex_state = 1},
  [183] = {.lex_state = 1},
  [184] = {.lex_state = 6},
  [185] = {.lex_state = 1},
  [186] = {.lex_state = 6},
  [187] = {.lex_state = 1},
  [188] = {.lex_state = 6},
  [189] = {.lex_state = 6},
  [190] = {.lex_state = 6},
  [191] = {.lex_state = 6},
  [192] = {.lex_state = 6},
  [193] = {.lex_state = 6},
  [194] = {.lex_state = 6},
  [195] = {.lex_state = 6},
  [196] = {.lex_state = 6},
  [197] = {.lex_state = 6},
  [198] = {.lex_state = 6},
  [199] = {.lex_state = 6},
  [200] = {.lex_state = 6},
  [201] = {.lex_state = 6},
  [202] = {.lex_state = 6},
  [203] = {.lex_state = 6},
  [204] = {.lex_state = 1},
  [205] = {.lex_state = 6},
  [206] = {.lex_state = 6},
  [207] = {.lex_state = 6},
  [208] = {.lex_state = 6},
  [209] = {.lex_state = 1},
  [210] = {.lex_state = 6},
  [211] = {.lex_state = 6},
  [212] = {.lex_state = 6},
  [213] = {.lex_state = 6},
  [214] = {.lex_state = 6},
  [215] = {.lex_state = 6},
  [216] = {.lex_state = 6},
  [217] = {.lex_state = 6},
  [218] = {.lex_state = 6},
  [219] = {.lex_state = 6},
  [220] = {.lex_state = 6},
  [221] = {.lex_state = 6},
  [222] = {.lex_state = 6},
  [223] = {.lex_state = 6},
  [224] = {.lex_state = 6},
  [225] = {.lex_state = 6},
  [226] = {.lex_state = 6},
  [227] = {.lex_state = 6},
  [228] = {.lex_state = 6},
  [229] = {.lex_state = 6},
  [230] = {.lex_state = 6},
  [231] = {.lex_state = 6},
  [232] = {.lex_state = 6},
  [233] = {.lex_state = 6},
  [234] = {.lex_state = 6},
  [235] = {.lex_state = 6},
  [236] = {.lex_state = 6},
  [237] = {.lex_state = 6},
  [238] = {.lex_state = 6},
  [239] = {.lex_state = 6},
  [240] = {.lex_state = 6},
  [241] = {.lex_state = 6},
  [242] = {.lex_state = 6},
  [243] = {.lex_state = 6},
  [244] = {.lex_state = 6},
  [245] = {.lex_state = 6},
  [246] = {.lex_state = 6},
  [247] = {.lex_state = 6},
  [248] = {.lex_state = 6},
  [249] = {.lex_state = 6},
  [250] = {.lex_state = 6},
  [251] = {.lex_state = 6},
  [252] = {.lex_state = 6},
  [253] = {.lex_state = 6},
  [254] = {.lex_state = 6},
  [255] = {.lex_state = 6},
  [256] = {.lex_state = 6},
  [257] = {.lex_state = 6},
  [258] = {.lex_state = 6},
  [259] = {.lex_state = 6},
  [260] = {.lex_state = 6},
  [261] = {.lex_state = 6},
  [262] = {.lex_state = 6},
  [263] = {.lex_state = 6},
  [264] = {.lex_state = 6},
  [265] = {.lex_state = 6},
  [266] = {.lex_state = 6},
  [267] = {.lex_state = 6},
  [268] = {.lex_state = 6},
  [269] = {.lex_state = 6},
  [270] = {.lex_state = 6},
  [271] = {.lex_state = 6},
  [272] = {.lex_state = 6},
  [273] = {.lex_state = 6},
  [274] = {.lex_state = 6},
  [275] = {.lex_state = 6},
  [276] = {.lex_state = 6},
  [277] = {.lex_state = 6},
  [278] = {.lex_state = 6},
  [279] = {.lex_state = 6},
  [280] = {.lex_state = 6},
  [281] = {.lex_state = 6},
  [282] = {.lex_state = 6},
  [283] = {.lex_state = 6},
  [284] = {.lex_state = 6},
  [285] = {.lex_state = 6},
  [286] = {.lex_state = 6},
  [287] = {.lex_state = 6},
  [288] = {.lex_state = 6},
  [289] = {.lex_state = 6},
  [290] = {.lex_state = 6},
  [291] = {.lex_state = 6},
  [292] = {.lex_state = 6},
  [293] = {.lex_state = 6},
  [294] = {.lex_state = 6},
  [295] = {.lex_state = 6},
  [296] = {.lex_state = 6},
  [297] = {.lex_state = 6},
  [298] = {.lex_state = 6},
  [299] = {.lex_state = 6},
  [300] = {.lex_state = 6},
  [301] = {.lex_state = 6},
  [302] = {.lex_state = 6},
  [303] = {.lex_state = 6},
  [304] = {.lex_state = 6},
  [305] = {.lex_state = 6},
  [306] = {.lex_state = 6},
  [307] = {.lex_state = 6},
  [308] = {.lex_state = 6},
  [309] = {.lex_state = 6},
  [310] = {.lex_state = 6},
  [311] = {.lex_state = 6},
  [312] = {.lex_state = 6},
  [313] = {.lex_state = 6},
  [314] = {.lex_state = 6},
  [315] = {.lex_state = 6},
  [316] = {.lex_state = 6},
  [317] = {.lex_state = 6},
  [318] = {.lex_state = 6},
  [319] = {.lex_state = 6},
  [320] = {.lex_state = 6},
  [321] = {.lex_state = 6},
  [322] = {.lex_state = 6},
  [323] = {.lex_state = 6},
  [324] = {.lex_state = 6},
  [325] = {.lex_state = 1},
  [326] = {.lex_state = 6},
  [327] = {.lex_state = 6},
  [328] = {.lex_state = 6},
  [329] = {.lex_state = 6},
  [330] = {.lex_state = 6},
  [331] = {.lex_state = 6},
  [332] = {.lex_state = 6},
  [333] = {.lex_state = 6},
  [334] = {.lex_state = 6},
  [335] = {.lex_state = 6},
  [336] = {.lex_state = 6},
  [337] = {.lex_state = 6},
  [338] = {.lex_state = 6},
  [339] = {.lex_state = 6},
  [340] = {.lex_state = 6},
  [341] = {.lex_state = 6},
  [342] = {.lex_state = 6},
  [343] = {.lex_state = 6},
  [344] = {.lex_state = 6},
  [345] = {.lex_state = 6},
  [346] = {.lex_state = 6},
  [347] = {.lex_state = 6},
  [348] = {.lex_state = 6},
  [349] = {.lex_state = 6},
  [350] = {.lex_state = 6},
  [351] = {.lex_state = 0},
  [352] = {.lex_state = 6},
  [353] = {.lex_state = 6},
  [354] = {.lex_state = 1},
  [355] = {.lex_state = 6},
  [356] = {.lex_state = 6},
  [357] = {.lex_state = 6},
  [358] = {.lex_state = 6},
  [359] = {.lex_state = 6},
  [360] = {.lex_state = 6},
  [361] = {.lex_state = 6},
  [362] = {.lex_state = 6},
  [363] = {.lex_state = 6},
  [364] = {.lex_state = 6},
  [365] = {.lex_state = 6},
  [366] = {.lex_state = 6},
  [367] = {.lex_state = 6},
  [368] = {.lex_state = 6},
  [369] = {.lex_state = 6},
  [370] = {.lex_state = 6},
  [371] = {.lex_state = 6},
  [372] = {.lex_state = 6},
  [373] = {.lex_state = 6},
  [374] = {.lex_state = 6},
  [375] = {.lex_state = 6},
  [376] = {.lex_state = 6},
  [377] = {.lex_state = 6},
  [378] = {.lex_state = 6},
  [379] = {.lex_state = 0},
  [380] = {.lex_state = 6},
  [381] = {.lex_state = 6},
  [382] = {.lex_state = 6},
  [383] = {.lex_state = 6},
  [384] = {.lex_state = 6},
  [385] = {.lex_state = 6},
  [386] = {.lex_state = 6},
  [387] = {.lex_state = 6},
  [388] = {.lex_state = 6},
  [389] = {.lex_state = 6},
  [390] = {.lex_state = 6},
  [391] = {.lex_state = 6},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 6},
  [394] = {.lex_state = 6},
  [395] = {.lex_state = 0},
  [396] = {.lex_state = 6},
  [397] = {.lex_state = 0},
  [398] = {.lex_state = 6},
  [399] = {.lex_state = 6},
  [400] = {.lex_state = 6},
  [401] = {.lex_state = 6},
  [402] = {.lex_state = 6},
  [403] = {.lex_state = 6},
  [404] = {.lex_state = 6},
  [405] = {.lex_state = 19},
  [406] = {.lex_state = 1},
  [407] = {.lex_state = 6},
  [408] = {.lex_state = 6},
  [409] = {.lex_state = 6},
  [410] = {.lex_state = 6},
  [411] = {.lex_state = 9},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 6},
  [414] = {.lex_state = 19},
  [415] = {.lex_state = 19},
  [416] = {.lex_state = 17},
  [417] = {.lex_state = 6},
  [418] = {.lex_state = 0},
  [419] = {.lex_state = 0},
  [420] = {.lex_state = 6},
  [421] = {.lex_state = 6},
  [422] = {.lex_state = 19},
  [423] = {.lex_state = 6},
  [424] = {.lex_state = 6},
  [425] = {.lex_state = 6},
  [426] = {.lex_state = 6},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 19},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 6},
  [432] = {.lex_state = 19},
  [433] = {.lex_state = 6},
  [434] = {.lex_state = 6},
  [435] = {.lex_state = 6},
  [436] = {.lex_state = 6},
  [437] = {.lex_state = 6},
  [438] = {.lex_state = 6},
  [439] = {.lex_state = 6},
  [440] = {.lex_state = 1},
  [441] = {.lex_state = 6},
  [442] = {.lex_state = 6},
  [443] = {.lex_state = 6},
  [444] = {.lex_state = 6},
  [445] = {.lex_state = 6},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 6},
  [448] = {.lex_state = 6},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 6},
  [451] = {.lex_state = 6},
  [452] = {.lex_state = 6},
  [453] = {.lex_state = 6},
  [454] = {.lex_state = 6},
  [455] = {.lex_state = 6},
  [456] = {.lex_state = 6},
  [457] = {.lex_state = 6},
  [458] = {.lex_state = 6},
  [459] = {.lex_state = 6},
  [460] = {.lex_state = 6},
  [461] = {.lex_state = 6},
  [462] = {.lex_state = 0},
  [463] = {.lex_state = 6},
  [464] = {.lex_state = 0},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 6},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 0},
  [470] = {.lex_state = 6},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 6},
  [473] = {.lex_state = 6},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 0},
  [477] = {.lex_state = 0},
  [478] = {.lex_state = 0},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 6},
  [481] = {.lex_state = 0},
  [482] = {.lex_state = 6},
  [483] = {.lex_state = 0},
  [484] = {.lex_state = 6},
  [485] = {.lex_state = 6},
  [486] = {.lex_state = 6},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 6},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 0},
  [493] = {.lex_state = 0},
  [494] = {.lex_state = 6},
  [495] = {.lex_state = 0},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 6},
  [498] = {.lex_state = 6},
  [499] = {.lex_state = 0},
  [500] = {.lex_state = 6},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 0},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 0},
  [506] = {.lex_state = 0},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 1},
  [509] = {.lex_state = 1},
  [510] = {.lex_state = 6},
  [511] = {.lex_state = 6},
  [512] = {.lex_state = 6},
  [513] = {.lex_state = 6},
  [514] = {.lex_state = 6},
  [515] = {.lex_state = 6},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 6},
  [518] = {.lex_state = 6},
  [519] = {.lex_state = 6},
  [520] = {.lex_state = 6},
  [521] = {.lex_state = 6},
  [522] = {.lex_state = 6},
  [523] = {.lex_state = 6},
  [524] = {.lex_state = 6},
  [525] = {.lex_state = 0},
  [526] = {.lex_state = 0},
  [527] = {.lex_state = 6},
  [528] = {.lex_state = 0},
  [529] = {.lex_state = 0},
  [530] = {.lex_state = 115},
  [531] = {.lex_state = 0},
  [532] = {.lex_state = 0},
  [533] = {.lex_state = 0},
  [534] = {.lex_state = 115},
  [535] = {.lex_state = 0},
  [536] = {.lex_state = 0},
  [537] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_version] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [sym_controlled_language_tag] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_u00b7] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_reserved_self] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_Thing] = ACTIONS(1),
    [anon_sym_Nothing] = ACTIONS(1),
    [anon_sym_real] = ACTIONS(1),
    [anon_sym_rational] = ACTIONS(1),
    [anon_sym_anyURI] = ACTIONS(1),
    [anon_sym_iri] = ACTIONS(1),
    [anon_sym_base64Binary] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_date] = ACTIONS(1),
    [anon_sym_dateTime] = ACTIONS(1),
    [anon_sym_decimal] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_duration] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_gDay] = ACTIONS(1),
    [anon_sym_gMonth] = ACTIONS(1),
    [anon_sym_gMonthDay] = ACTIONS(1),
    [anon_sym_gYearMonth] = ACTIONS(1),
    [anon_sym_gYear] = ACTIONS(1),
    [anon_sym_hexBinary] = ACTIONS(1),
    [anon_sym_binary] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_time] = ACTIONS(1),
    [anon_sym_dateTimeStamp] = ACTIONS(1),
    [anon_sym_dayTimeDuration] = ACTIONS(1),
    [anon_sym_yearMonthDuration] = ACTIONS(1),
    [anon_sym_integer] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_nonNegativeInteger] = ACTIONS(1),
    [anon_sym_positiveInteger] = ACTIONS(1),
    [anon_sym_unsignedLong] = ACTIONS(1),
    [anon_sym_unsignedInt] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_unsignedShort] = ACTIONS(1),
    [anon_sym_unsignedByte] = ACTIONS(1),
    [anon_sym_nonPositiveInteger] = ACTIONS(1),
    [anon_sym_negativeInteger] = ACTIONS(1),
    [anon_sym_normalizedString] = ACTIONS(1),
    [anon_sym_token] = ACTIONS(1),
    [anon_sym_language] = ACTIONS(1),
    [sym_quoted_string] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_POUND_LBRACK] = ACTIONS(1),
    [sym_hex_byte] = ACTIONS(1),
    [sym_double] = ACTIONS(1),
    [sym_decimal] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_rational] = ACTIONS(1),
    [sym_unsigned] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_u22a4] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_u22a5] = ACTIONS(1),
    [anon_sym_datatype] = ACTIONS(1),
    [sym_opaque] = ACTIONS(1),
    [anon_sym_length] = ACTIONS(1),
    [anon_sym_maxLength] = ACTIONS(1),
    [anon_sym_minLength] = ACTIONS(1),
    [anon_sym_fractionDigits] = ACTIONS(1),
    [anon_sym_totalDigits] = ACTIONS(1),
    [anon_sym_maxExclusive] = ACTIONS(1),
    [anon_sym_maxInclusive] = ACTIONS(1),
    [anon_sym_minExclusive] = ACTIONS(1),
    [anon_sym_minInclusive] = ACTIONS(1),
    [anon_sym_explicitTimezone] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_prohibited] = ACTIONS(1),
    [anon_sym_optional] = ACTIONS(1),
    [anon_sym_pattern] = ACTIONS(1),
    [sym_kw_is_fixed] = ACTIONS(1),
    [anon_sym_dimension] = ACTIONS(1),
    [anon_sym_source] = ACTIONS(1),
    [anon_sym_parent] = ACTIONS(1),
    [anon_sym_entity] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_structure] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_rdf] = ACTIONS(1),
    [anon_sym_a] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [sym_wildcard] = ACTIONS(1),
    [anon_sym_identity] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [sym_unknown_type] = ACTIONS(1),
    [anon_sym_ordered] = ACTIONS(1),
    [anon_sym_unordered] = ACTIONS(1),
    [anon_sym_unique] = ACTIONS(1),
    [anon_sym_nonunique] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_u2260] = ACTIONS(1),
    [sym_op_less_than] = ACTIONS(1),
    [sym_op_greater_than] = ACTIONS(1),
    [anon_sym_u2264] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_u2265] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_u00ac] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_u2227] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_u2228] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_u22bb] = ACTIONS(1),
    [anon_sym_implies] = ACTIONS(1),
    [anon_sym_EQ_EQ_GT] = ACTIONS(1),
    [anon_sym_u21d2] = ACTIONS(1),
    [anon_sym_iff] = ACTIONS(1),
    [anon_sym_u21d4] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_u2200] = ACTIONS(1),
    [anon_sym_exists] = ACTIONS(1),
    [anon_sym_u2203] = ACTIONS(1),
    [anon_sym_u222a] = ACTIONS(1),
    [anon_sym_intersection] = ACTIONS(1),
    [anon_sym_u2229] = ACTIONS(1),
    [anon_sym_complement] = ACTIONS(1),
    [anon_sym_u2216] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_u2208] = ACTIONS(1),
    [sym_set_op_builder] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_u2254] = ACTIONS(1),
    [anon_sym_u2192] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_u2190] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_u2295] = ACTIONS(1),
    [sym__value_empty_sequence] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_module] = STATE(537),
    [anon_sym_module] = ACTIONS(5),
    [sym_line_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(7), 6,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(9), 54,
      anon_sym_version,
      anon_sym_is,
      anon_sym_end,
      anon_sym_import,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [68] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(15), 1,
      sym_language_tag,
    ACTIONS(11), 6,
      sym_identifier,
      anon_sym_AT,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(13), 51,
      anon_sym_is,
      anon_sym_end,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [136] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      sym_unknown_type,
    STATE(14), 1,
      sym_cardinality_expression,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(203), 1,
      sym_type_reference,
    STATE(174), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(126), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(25), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(23), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [220] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(29), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(31), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [285] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(33), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(35), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [350] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(37), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(39), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [415] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(17), 1,
      sym_function_cardinality_expression,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(309), 1,
      sym_function_type_reference,
    STATE(320), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(126), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(25), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(23), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [496] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(43), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(45), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [561] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(47), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(49), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [626] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(51), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(53), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [691] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(55), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(57), 52,
      anon_sym_is,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [756] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(59), 6,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(61), 50,
      anon_sym_is,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_with,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_u2295,
  [820] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(27), 1,
      sym_unknown_type,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(201), 1,
      sym_type_reference,
    STATE(174), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(126), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(25), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(23), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [898] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(27), 1,
      sym_unknown_type,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(469), 1,
      sym_type_reference,
    STATE(174), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(126), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(25), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(23), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [976] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(27), 1,
      sym_unknown_type,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(412), 1,
      sym_type_reference,
    STATE(174), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(126), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(25), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(23), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1054] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(304), 1,
      sym_function_type_reference,
    STATE(320), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym_mapping_type,
    STATE(126), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(25), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(23), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1129] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(63), 1,
      sym_opaque,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(205), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym__datatype_base,
    STATE(126), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(25), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(23), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1201] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(65), 5,
      sym_identifier,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(67), 49,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_with,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_u2295,
  [1263] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(202), 3,
      sym_identifier_reference,
      sym_builtin_simple_type,
      sym__datatype_base,
    STATE(126), 5,
      sym__owl_builtin_types,
      sym__builtin_primitive_datatypes,
      sym__derived_date_datetypes,
      sym__derived_numeric_datatypes,
      sym__derived_string_datatypes,
    ACTIONS(25), 6,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(23), 37,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [1332] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(135), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(206), 1,
      sym_term,
    STATE(483), 1,
      sym__sequence_value_constraints,
    STATE(532), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1453] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(27), 1,
      sym_logical_op_negation,
    STATE(168), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(207), 1,
      sym_term,
    STATE(471), 1,
      sym_quantified_variable_binding,
    STATE(483), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1574] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(136), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(206), 1,
      sym_term,
    STATE(483), 1,
      sym__sequence_value_constraints,
    STATE(532), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1695] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(140), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(206), 1,
      sym_term,
    STATE(483), 1,
      sym__sequence_value_constraints,
    STATE(532), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1816] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(27), 1,
      sym_logical_op_negation,
    STATE(160), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(207), 1,
      sym_term,
    STATE(471), 1,
      sym_quantified_variable_binding,
    STATE(483), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [1937] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(27), 1,
      sym_logical_op_negation,
    STATE(157), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(207), 1,
      sym_term,
    STATE(471), 1,
      sym_quantified_variable_binding,
    STATE(483), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2058] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(27), 1,
      sym_logical_op_negation,
    STATE(133), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(207), 1,
      sym_term,
    STATE(471), 1,
      sym_quantified_variable_binding,
    STATE(483), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2179] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(27), 1,
      sym_logical_op_negation,
    STATE(139), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(207), 1,
      sym_term,
    STATE(471), 1,
      sym_quantified_variable_binding,
    STATE(483), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2300] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(138), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(199), 1,
      sym_term,
    STATE(483), 1,
      sym__sequence_value_constraints,
    STATE(532), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2421] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(27), 1,
      sym_logical_op_negation,
    STATE(142), 1,
      sym_constraint_sentence,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(207), 1,
      sym_term,
    STATE(471), 1,
      sym_quantified_variable_binding,
    STATE(483), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2542] = 33,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(21), 1,
      sym_logical_op_negation,
    STATE(138), 1,
      sym_constraint_sentence,
    STATE(179), 1,
      sym_term,
    STATE(184), 1,
      sym_quantified_sentence,
    STATE(188), 1,
      sym_boolean_sentence,
    STATE(189), 1,
      sym_simple_sentence,
    STATE(483), 1,
      sym__sequence_value_constraints,
    STATE(532), 1,
      sym_quantified_variable_binding,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    ACTIONS(93), 2,
      anon_sym_not,
      anon_sym_u00ac,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    STATE(186), 2,
      sym_unary_boolean_sentence,
      sym_binary_boolean_sentence,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(178), 3,
      sym_atomic_sentence,
      sym_equation,
      sym_inequation,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [2663] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(101), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(103), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2717] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(105), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(107), 42,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [2771] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(109), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(111), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2825] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(113), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(115), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2879] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(117), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(119), 39,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
      sym_unknown_type,
  [2933] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(121), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(123), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [2986] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(125), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(127), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3039] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(129), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(131), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3092] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(133), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(135), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3145] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(137), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(139), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3198] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(141), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(143), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3251] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(145), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(147), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3304] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(149), 7,
      sym_identifier,
      anon_sym_date,
      anon_sym_dateTime,
      anon_sym_gMonth,
      anon_sym_gYear,
      anon_sym_int,
      anon_sym_unsigned,
    ACTIONS(151), 38,
      anon_sym_LPAREN,
      anon_sym_Thing,
      anon_sym_Nothing,
      anon_sym_real,
      anon_sym_rational,
      anon_sym_anyURI,
      anon_sym_iri,
      anon_sym_base64Binary,
      anon_sym_boolean,
      anon_sym_decimal,
      anon_sym_double,
      anon_sym_duration,
      anon_sym_float,
      anon_sym_gDay,
      anon_sym_gMonthDay,
      anon_sym_gYearMonth,
      anon_sym_hexBinary,
      anon_sym_binary,
      anon_sym_string,
      anon_sym_time,
      anon_sym_dateTimeStamp,
      anon_sym_dayTimeDuration,
      anon_sym_yearMonthDuration,
      anon_sym_integer,
      anon_sym_long,
      anon_sym_short,
      anon_sym_byte,
      anon_sym_nonNegativeInteger,
      anon_sym_positiveInteger,
      anon_sym_unsignedLong,
      anon_sym_unsignedInt,
      anon_sym_unsignedShort,
      anon_sym_unsignedByte,
      anon_sym_nonPositiveInteger,
      anon_sym_negativeInteger,
      anon_sym_normalizedString,
      anon_sym_token,
      anon_sym_language,
  [3357] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(153), 1,
      sym_identifier,
    ACTIONS(156), 1,
      anon_sym_LBRACK,
    ACTIONS(159), 1,
      anon_sym_RPAREN,
    ACTIONS(161), 1,
      sym_reserved_self,
    ACTIONS(164), 1,
      anon_sym_LBRACE,
    ACTIONS(167), 1,
      sym_quoted_string,
    ACTIONS(170), 1,
      anon_sym_LT,
    ACTIONS(173), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(188), 1,
      sym__value_empty_sequence,
    STATE(45), 1,
      aux_sym_actual_arguments_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(145), 1,
      sym_term,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(176), 2,
      sym_double,
      sym_rational,
    ACTIONS(182), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(185), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(150), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(179), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(153), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3438] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(195), 1,
      anon_sym_LPAREN,
    ACTIONS(191), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(193), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3483] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(197), 1,
      sym_identifier,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(201), 1,
      anon_sym_RPAREN,
    ACTIONS(203), 1,
      sym_reserved_self,
    ACTIONS(205), 1,
      anon_sym_LBRACE,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    STATE(45), 1,
      aux_sym_actual_arguments_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(145), 1,
      sym_term,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(150), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(153), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3564] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(197), 1,
      sym_identifier,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(203), 1,
      sym_reserved_self,
    ACTIONS(205), 1,
      anon_sym_LBRACE,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(223), 1,
      anon_sym_RPAREN,
    STATE(45), 1,
      aux_sym_actual_arguments_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(145), 1,
      sym_term,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(150), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(153), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3645] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(197), 1,
      sym_identifier,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(203), 1,
      sym_reserved_self,
    ACTIONS(205), 1,
      anon_sym_LBRACE,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(225), 1,
      anon_sym_RPAREN,
    STATE(48), 1,
      aux_sym_actual_arguments_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(145), 1,
      sym_term,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(150), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(153), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3726] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(197), 1,
      sym_identifier,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(203), 1,
      sym_reserved_self,
    ACTIONS(205), 1,
      anon_sym_LBRACE,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(227), 1,
      anon_sym_RPAREN,
    STATE(47), 1,
      aux_sym_actual_arguments_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(145), 1,
      sym_term,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(150), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(153), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [3807] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(229), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(231), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3849] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(191), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(193), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3891] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(233), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(235), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3933] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(237), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(239), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [3975] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(241), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(243), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4017] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(245), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(247), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4059] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(249), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(251), 30,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      sym__value_empty_sequence,
  [4101] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(166), 1,
      sym_term,
    STATE(483), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4176] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(427), 1,
      sym_term,
    STATE(483), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4251] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_LBRACK,
    ACTIONS(75), 1,
      sym_reserved_self,
    ACTIONS(77), 1,
      anon_sym_LBRACE,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(99), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(155), 1,
      sym_term,
    STATE(483), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(93), 2,
      sym_sequence_of_predicate_values,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
    STATE(91), 5,
      sym_identifier_reference,
      sym_functional_term,
      sym_function_composition,
      sym_predicate_value,
      sym_sequence_builder,
  [4326] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(65), 1,
      sym_identifier,
    ACTIONS(253), 1,
      anon_sym_COLON,
    ACTIONS(67), 31,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_assert,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_with,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_u2295,
  [4369] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(257), 1,
      anon_sym_RBRACK,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    STATE(73), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_simple_value,
    STATE(150), 1,
      sym_sequence_of_predicate_values,
    STATE(177), 1,
      sym_identifier_reference,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(187), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4447] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(261), 1,
      anon_sym_RBRACK,
    STATE(62), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_simple_value,
    STATE(150), 1,
      sym_sequence_of_predicate_values,
    STATE(177), 1,
      sym_identifier_reference,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(187), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4525] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(263), 1,
      anon_sym_end,
    ACTIONS(265), 1,
      anon_sym_import,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(271), 1,
      anon_sym_datatype,
    ACTIONS(273), 1,
      anon_sym_dimension,
    ACTIONS(275), 1,
      anon_sym_entity,
    ACTIONS(277), 1,
      anon_sym_enum,
    ACTIONS(279), 1,
      anon_sym_event,
    ACTIONS(281), 1,
      anon_sym_property,
    ACTIONS(283), 1,
      anon_sym_structure,
    ACTIONS(285), 1,
      anon_sym_union,
    ACTIONS(287), 1,
      anon_sym_rdf,
    ACTIONS(289), 1,
      anon_sym_class,
    STATE(68), 2,
      sym_import_statement,
      aux_sym_module_body_repeat1,
    STATE(83), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(118), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(247), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [4599] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(291), 1,
      anon_sym_RBRACK,
    STATE(73), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_simple_value,
    STATE(150), 1,
      sym_sequence_of_predicate_values,
    STATE(177), 1,
      sym_identifier_reference,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(187), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4677] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(293), 1,
      anon_sym_COLON,
    STATE(77), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(295), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(65), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(67), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [4723] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(297), 1,
      anon_sym_RBRACK,
    STATE(70), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_simple_value,
    STATE(150), 1,
      sym_sequence_of_predicate_values,
    STATE(177), 1,
      sym_identifier_reference,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(187), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4801] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(265), 1,
      anon_sym_import,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(271), 1,
      anon_sym_datatype,
    ACTIONS(273), 1,
      anon_sym_dimension,
    ACTIONS(275), 1,
      anon_sym_entity,
    ACTIONS(277), 1,
      anon_sym_enum,
    ACTIONS(279), 1,
      anon_sym_event,
    ACTIONS(281), 1,
      anon_sym_property,
    ACTIONS(283), 1,
      anon_sym_structure,
    ACTIONS(285), 1,
      anon_sym_union,
    ACTIONS(287), 1,
      anon_sym_rdf,
    ACTIONS(289), 1,
      anon_sym_class,
    ACTIONS(299), 1,
      anon_sym_end,
    STATE(82), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(113), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(193), 2,
      sym_import_statement,
      aux_sym_module_body_repeat1,
    STATE(247), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [4875] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(301), 1,
      anon_sym_RBRACK,
    STATE(65), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_simple_value,
    STATE(150), 1,
      sym_sequence_of_predicate_values,
    STATE(177), 1,
      sym_identifier_reference,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(187), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [4953] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(303), 1,
      anon_sym_RBRACK,
    STATE(73), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_simple_value,
    STATE(150), 1,
      sym_sequence_of_predicate_values,
    STATE(177), 1,
      sym_identifier_reference,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(187), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5031] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(305), 1,
      anon_sym_RBRACK,
    STATE(72), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_simple_value,
    STATE(150), 1,
      sym_sequence_of_predicate_values,
    STATE(177), 1,
      sym_identifier_reference,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(187), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5109] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(199), 1,
      anon_sym_LBRACK,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(221), 1,
      sym__value_empty_sequence,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_RBRACK,
    STATE(73), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_simple_value,
    STATE(150), 1,
      sym_sequence_of_predicate_values,
    STATE(177), 1,
      sym_identifier_reference,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(187), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5187] = 22,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(309), 1,
      sym_identifier,
    ACTIONS(312), 1,
      anon_sym_LBRACK,
    ACTIONS(315), 1,
      anon_sym_RBRACK,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(320), 1,
      sym_quoted_string,
    ACTIONS(323), 1,
      anon_sym_LT,
    ACTIONS(326), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(341), 1,
      sym__value_empty_sequence,
    STATE(73), 1,
      aux_sym_sequence_of_predicate_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(146), 1,
      sym_simple_value,
    STATE(150), 1,
      sym_sequence_of_predicate_values,
    STATE(177), 1,
      sym_identifier_reference,
    STATE(533), 1,
      sym__sequence_value_constraints,
    ACTIONS(329), 2,
      sym_double,
      sym_rational,
    ACTIONS(335), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(338), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(332), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(187), 3,
      sym_predicate_value,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5265] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(75), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(295), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(346), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(344), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5308] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(75), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(352), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(350), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(348), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5351] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(74), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(295), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(357), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(355), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5394] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(75), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(295), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(346), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(344), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5437] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(361), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(359), 26,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_u00b7,
      anon_sym_DOT,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5475] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(363), 1,
      anon_sym_LBRACK,
    ACTIONS(365), 1,
      sym__value_empty_sequence,
    STATE(46), 1,
      sym_identifier_reference,
    STATE(51), 1,
      sym_value,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(147), 1,
      sym_simple_value,
    STATE(487), 1,
      sym__sequence_value_constraints,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(52), 3,
      sym_sequence_of_values,
      sym_value_constructor,
      sym_mapping_value,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5547] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(363), 1,
      anon_sym_LBRACK,
    ACTIONS(365), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(46), 1,
      sym_identifier_reference,
    STATE(141), 1,
      sym_simple_value,
    STATE(173), 1,
      sym_value,
    STATE(487), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(52), 3,
      sym_sequence_of_values,
      sym_value_constructor,
      sym_mapping_value,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5619] = 20,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(259), 1,
      anon_sym_LBRACE,
    ACTIONS(363), 1,
      anon_sym_LBRACK,
    ACTIONS(365), 1,
      sym__value_empty_sequence,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(46), 1,
      sym_identifier_reference,
    STATE(51), 1,
      sym_value,
    STATE(141), 1,
      sym_simple_value,
    STATE(487), 1,
      sym__sequence_value_constraints,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(52), 3,
      sym_sequence_of_values,
      sym_value_constructor,
      sym_mapping_value,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [5691] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(271), 1,
      anon_sym_datatype,
    ACTIONS(273), 1,
      anon_sym_dimension,
    ACTIONS(275), 1,
      anon_sym_entity,
    ACTIONS(277), 1,
      anon_sym_enum,
    ACTIONS(279), 1,
      anon_sym_event,
    ACTIONS(281), 1,
      anon_sym_property,
    ACTIONS(283), 1,
      anon_sym_structure,
    ACTIONS(285), 1,
      anon_sym_union,
    ACTIONS(287), 1,
      anon_sym_rdf,
    ACTIONS(289), 1,
      anon_sym_class,
    ACTIONS(367), 1,
      anon_sym_end,
    STATE(116), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(247), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [5758] = 18,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(271), 1,
      anon_sym_datatype,
    ACTIONS(273), 1,
      anon_sym_dimension,
    ACTIONS(275), 1,
      anon_sym_entity,
    ACTIONS(277), 1,
      anon_sym_enum,
    ACTIONS(279), 1,
      anon_sym_event,
    ACTIONS(281), 1,
      anon_sym_property,
    ACTIONS(283), 1,
      anon_sym_structure,
    ACTIONS(285), 1,
      anon_sym_union,
    ACTIONS(287), 1,
      anon_sym_rdf,
    ACTIONS(289), 1,
      anon_sym_class,
    ACTIONS(299), 1,
      anon_sym_end,
    STATE(113), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(247), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [5825] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(371), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(369), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5861] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(375), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(373), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5897] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(379), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(377), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5933] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(383), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(381), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [5969] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(387), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(385), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6005] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(391), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(389), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6041] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(395), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(393), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6077] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(357), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(355), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6113] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(399), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(397), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6149] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(403), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(401), 24,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6185] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(409), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(405), 8,
      anon_sym_is,
      anon_sym_LPAREN,
      anon_sym_def,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(407), 15,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6222] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(411), 1,
      anon_sym_RBRACK,
    STATE(98), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(185), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(209), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6284] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(413), 1,
      anon_sym_RBRACK,
    STATE(99), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(185), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(209), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6346] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(415), 1,
      anon_sym_RBRACK,
    STATE(96), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(185), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(209), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6408] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(207), 1,
      sym_quoted_string,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(211), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(255), 1,
      sym_identifier,
    ACTIONS(417), 1,
      anon_sym_RBRACK,
    STATE(99), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(185), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(213), 2,
      sym_double,
      sym_rational,
    ACTIONS(217), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(219), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(209), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(215), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6470] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(419), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_RBRACK,
    ACTIONS(424), 1,
      sym_quoted_string,
    ACTIONS(427), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_POUND_LBRACK,
    STATE(99), 1,
      aux_sym_sequence_of_values_repeat1,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(185), 1,
      sym_simple_value,
    STATE(204), 1,
      sym_identifier_reference,
    ACTIONS(433), 2,
      sym_double,
      sym_rational,
    ACTIONS(439), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(442), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(122), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(209), 2,
      sym_value_constructor,
      sym_mapping_value,
    ACTIONS(436), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(130), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6532] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(409), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(405), 9,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_def,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(407), 12,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6567] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(445), 1,
      sym_kw_is_fixed,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(225), 1,
      sym_restriction_value,
    STATE(493), 1,
      sym_identifier_reference,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(237), 2,
      sym_value_constructor,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6626] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(409), 4,
      anon_sym_EQ,
      sym_op_less_than,
      sym_op_greater_than,
      anon_sym_LT_EQ,
    ACTIONS(405), 6,
      anon_sym_LPAREN,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
      anon_sym_u2264,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(407), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [6661] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(447), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(449), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6693] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(451), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(453), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6725] = 15,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(227), 1,
      sym_restriction_value,
    STATE(493), 1,
      sym_identifier_reference,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    STATE(237), 2,
      sym_value_constructor,
      sym_simple_value,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [6781] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(455), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(457), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6813] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(459), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(461), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6845] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(463), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(465), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6877] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(467), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(469), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6909] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(471), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(473), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_not,
      anon_sym_u00ac,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_exists,
      anon_sym_u2203,
      sym__value_empty_sequence,
  [6941] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(475), 1,
      sym_language_tag,
    ACTIONS(11), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(13), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [6974] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(477), 1,
      anon_sym_end,
    ACTIONS(479), 1,
      anon_sym_datatype,
    ACTIONS(482), 1,
      anon_sym_dimension,
    ACTIONS(485), 1,
      anon_sym_entity,
    ACTIONS(488), 1,
      anon_sym_enum,
    ACTIONS(491), 1,
      anon_sym_event,
    ACTIONS(494), 1,
      anon_sym_property,
    ACTIONS(497), 1,
      anon_sym_structure,
    ACTIONS(500), 1,
      anon_sym_union,
    ACTIONS(503), 1,
      anon_sym_rdf,
    ACTIONS(506), 1,
      anon_sym_class,
    STATE(112), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(247), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7027] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(271), 1,
      anon_sym_datatype,
    ACTIONS(273), 1,
      anon_sym_dimension,
    ACTIONS(275), 1,
      anon_sym_entity,
    ACTIONS(277), 1,
      anon_sym_enum,
    ACTIONS(279), 1,
      anon_sym_event,
    ACTIONS(281), 1,
      anon_sym_property,
    ACTIONS(283), 1,
      anon_sym_structure,
    ACTIONS(285), 1,
      anon_sym_union,
    ACTIONS(287), 1,
      anon_sym_rdf,
    ACTIONS(289), 1,
      anon_sym_class,
    ACTIONS(367), 1,
      anon_sym_end,
    STATE(112), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(247), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7080] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(59), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(61), 19,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7111] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(7), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(9), 19,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7142] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(271), 1,
      anon_sym_datatype,
    ACTIONS(273), 1,
      anon_sym_dimension,
    ACTIONS(275), 1,
      anon_sym_entity,
    ACTIONS(277), 1,
      anon_sym_enum,
    ACTIONS(279), 1,
      anon_sym_event,
    ACTIONS(281), 1,
      anon_sym_property,
    ACTIONS(283), 1,
      anon_sym_structure,
    ACTIONS(285), 1,
      anon_sym_union,
    ACTIONS(287), 1,
      anon_sym_rdf,
    ACTIONS(289), 1,
      anon_sym_class,
    ACTIONS(509), 1,
      anon_sym_end,
    STATE(112), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(247), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7195] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(65), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(67), 19,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7226] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(271), 1,
      anon_sym_datatype,
    ACTIONS(273), 1,
      anon_sym_dimension,
    ACTIONS(275), 1,
      anon_sym_entity,
    ACTIONS(277), 1,
      anon_sym_enum,
    ACTIONS(279), 1,
      anon_sym_event,
    ACTIONS(281), 1,
      anon_sym_property,
    ACTIONS(283), 1,
      anon_sym_structure,
    ACTIONS(285), 1,
      anon_sym_union,
    ACTIONS(287), 1,
      anon_sym_rdf,
    ACTIONS(289), 1,
      anon_sym_class,
    ACTIONS(299), 1,
      anon_sym_end,
    STATE(112), 2,
      sym_definition,
      aux_sym_module_body_repeat3,
    STATE(247), 10,
      sym_data_type_def,
      sym_dimension_def,
      sym_entity_def,
      sym_enum_def,
      sym_event_def,
      sym_property_def,
      sym_structure_def,
      sym_union_def,
      sym_rdf_def,
      sym_type_class_def,
  [7279] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(511), 1,
      anon_sym_COLON,
    STATE(127), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(513), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(65), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(67), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7316] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(55), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(57), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7346] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(129), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(513), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(346), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(344), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7380] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(37), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(39), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7410] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(43), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(45), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7440] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(33), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(35), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7470] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(29), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(31), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7500] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(515), 1,
      sym_identifier,
    ACTIONS(517), 21,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_LBRACE,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [7530] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(129), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(513), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(346), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(344), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7564] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(519), 1,
      sym_identifier,
    ACTIONS(523), 1,
      anon_sym_AT,
    ACTIONS(526), 1,
      anon_sym_assert,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    ACTIONS(521), 15,
      anon_sym_end,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [7602] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(129), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(529), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(350), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(348), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7636] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(51), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(53), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7666] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(121), 1,
      aux_sym_function_composition_repeat1,
    ACTIONS(513), 2,
      anon_sym_u00b7,
      anon_sym_DOT,
    ACTIONS(357), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(355), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7700] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(47), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(49), 18,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__value_empty_sequence,
  [7730] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(532), 15,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [7759] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(361), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(359), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_u00b7,
      anon_sym_DOT,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [7788] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(23), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(532), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [7817] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(23), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(534), 15,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [7846] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(536), 1,
      sym_identifier,
    ACTIONS(538), 20,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [7875] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(542), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(544), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(546), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(540), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
    ACTIONS(548), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(550), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(23), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [7914] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(542), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(544), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(546), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(548), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(550), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    ACTIONS(552), 3,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [7953] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(542), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(544), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(546), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(548), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(550), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    ACTIONS(552), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
    STATE(23), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [7992] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(191), 1,
      sym_identifier,
    STATE(81), 1,
      sym__type_op_has_type,
    ACTIONS(554), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(193), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8025] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
    ACTIONS(534), 15,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8054] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(391), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(389), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8082] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(395), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(393), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8110] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(560), 1,
      anon_sym_LPAREN,
    STATE(165), 1,
      sym_actual_arguments,
    ACTIONS(556), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(558), 14,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8142] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(79), 1,
      sym__type_op_has_type,
    ACTIONS(562), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(403), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(401), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8174] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(79), 1,
      sym__type_op_has_type,
    ACTIONS(562), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(191), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(193), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8206] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(371), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(369), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8234] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(375), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(373), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8262] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(403), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(401), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8290] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(379), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(377), 16,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8318] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(405), 19,
      anon_sym_is,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8343] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(357), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(355), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8370] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(511), 1,
      anon_sym_COLON,
    ACTIONS(65), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(67), 14,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8399] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 1,
      anon_sym_LPAREN,
    STATE(152), 1,
      sym_actual_arguments,
    ACTIONS(564), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8428] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(293), 1,
      anon_sym_COLON,
    ACTIONS(570), 1,
      anon_sym_as,
    STATE(194), 1,
      sym__rename_import,
    STATE(198), 1,
      sym_iri,
    ACTIONS(568), 14,
      anon_sym_end,
      anon_sym_import,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [8463] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(572), 1,
      anon_sym_end,
    ACTIONS(542), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(544), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(546), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(548), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(550), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8500] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(574), 1,
      anon_sym_RBRACE,
    ACTIONS(582), 1,
      anon_sym_explicitTimezone,
    ACTIONS(584), 1,
      anon_sym_pattern,
    ACTIONS(578), 2,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
    ACTIONS(576), 3,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
    ACTIONS(580), 4,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
    STATE(163), 7,
      sym__restriction_facet,
      sym_length_restriction_facet,
      sym_digit_restriction_facet,
      sym_value_restriction_facet,
      sym_tz_restriction_facet,
      sym_pattern_restriction_facet,
      aux_sym_datatype_def_restriction_repeat1,
  [8537] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(590), 1,
      sym_controlled_language_tag,
    ACTIONS(586), 2,
      sym_identifier,
      anon_sym_AT,
    ACTIONS(588), 16,
      anon_sym_end,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8566] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(592), 1,
      anon_sym_end,
    ACTIONS(542), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(544), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(546), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(548), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(550), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8603] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(387), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(385), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8630] = 11,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(79), 1,
      sym_quoted_string,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(83), 1,
      anon_sym_POUND_LBRACK,
    STATE(516), 1,
      sym_simple_value,
    ACTIONS(85), 2,
      sym_double,
      sym_rational,
    ACTIONS(89), 2,
      anon_sym_true,
      anon_sym_u22a4,
    ACTIONS(91), 2,
      anon_sym_false,
      anon_sym_u22a5,
    STATE(7), 2,
      sym_boolean_truth,
      sym_boolean_falsity,
    ACTIONS(87), 3,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    STATE(11), 4,
      sym_string,
      sym_iri,
      sym_binary,
      sym_boolean,
  [8673] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(594), 1,
      anon_sym_RBRACE,
    ACTIONS(605), 1,
      anon_sym_explicitTimezone,
    ACTIONS(608), 1,
      anon_sym_pattern,
    ACTIONS(599), 2,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
    ACTIONS(596), 3,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
    ACTIONS(602), 4,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
    STATE(163), 7,
      sym__restriction_facet,
      sym_length_restriction_facet,
      sym_digit_restriction_facet,
      sym_value_restriction_facet,
      sym_tz_restriction_facet,
      sym_pattern_restriction_facet,
      aux_sym_datatype_def_restriction_repeat1,
  [8710] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(383), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(381), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8737] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(409), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(405), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8764] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 1,
      anon_sym_LPAREN,
    STATE(152), 1,
      sym_actual_arguments,
    ACTIONS(611), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [8793] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(399), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(397), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [8820] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(613), 1,
      anon_sym_RPAREN,
    ACTIONS(542), 2,
      anon_sym_and,
      anon_sym_u2227,
    ACTIONS(544), 2,
      anon_sym_or,
      anon_sym_u2228,
    ACTIONS(546), 2,
      anon_sym_xor,
      anon_sym_u22bb,
    ACTIONS(548), 3,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
    ACTIONS(550), 3,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
    STATE(30), 6,
      sym__logical_connective,
      sym_logical_op_conjunction,
      sym_logical_op_disjunction,
      sym_logical_op_exclusive_disjunction,
      sym_logical_op_implication,
      sym_logical_op_biconditional,
  [8857] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(615), 1,
      sym_identifier,
    ACTIONS(617), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8883] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(621), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8909] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(623), 1,
      sym_identifier,
    ACTIONS(625), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8935] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(582), 1,
      anon_sym_explicitTimezone,
    ACTIONS(584), 1,
      anon_sym_pattern,
    ACTIONS(578), 2,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
    ACTIONS(576), 3,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
    ACTIONS(580), 4,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
    STATE(158), 7,
      sym__restriction_facet,
      sym_length_restriction_facet,
      sym_digit_restriction_facet,
      sym_value_restriction_facet,
      sym_tz_restriction_facet,
      sym_pattern_restriction_facet,
      aux_sym_datatype_def_restriction_repeat1,
  [8969] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(627), 1,
      sym_identifier,
    ACTIONS(629), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [8995] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(631), 1,
      sym_identifier,
    ACTIONS(633), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [9021] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(635), 1,
      sym_identifier,
    ACTIONS(637), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9047] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(639), 1,
      sym_identifier,
    ACTIONS(641), 17,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_source,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_identity,
      anon_sym_ref,
  [9073] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(195), 1,
      anon_sym_LPAREN,
    ACTIONS(643), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(645), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9101] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(647), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9124] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_EQ,
    STATE(100), 1,
      sym_actual_arguments,
    ACTIONS(651), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(653), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(655), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(657), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    ACTIONS(540), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
    STATE(60), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [9163] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(659), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(661), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9188] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(663), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(665), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9213] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(667), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(669), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9238] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(671), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(673), 13,
      anon_sym_LBRACK,
      sym_reserved_self,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9263] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(675), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9286] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(79), 1,
      sym__type_op_has_type,
    ACTIONS(562), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(677), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(679), 10,
      anon_sym_RBRACK,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
  [9315] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(681), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9338] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(643), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(645), 13,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
      sym__value_empty_sequence,
  [9363] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(675), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9386] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(675), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9409] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(683), 17,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_u2227,
      anon_sym_or,
      anon_sym_u2228,
      anon_sym_xor,
      anon_sym_u22bb,
      anon_sym_implies,
      anon_sym_EQ_EQ_GT,
      anon_sym_u21d2,
      anon_sym_iff,
      anon_sym_LT_EQ_EQ_GT,
      anon_sym_u21d4,
  [9432] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(685), 1,
      sym_identifier,
    ACTIONS(687), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9456] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(689), 1,
      sym_identifier,
    ACTIONS(691), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9480] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(695), 1,
      anon_sym_import,
    STATE(193), 2,
      sym_import_statement,
      aux_sym_module_body_repeat1,
    ACTIONS(693), 13,
      anon_sym_end,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9506] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(698), 1,
      sym_identifier,
    ACTIONS(700), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9530] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(570), 1,
      anon_sym_as,
    STATE(191), 1,
      sym__rename_import,
    ACTIONS(702), 14,
      anon_sym_end,
      anon_sym_import,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9556] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(704), 1,
      sym_identifier,
    ACTIONS(706), 1,
      anon_sym_is,
    STATE(211), 1,
      sym_annotation_only_body,
    ACTIONS(708), 13,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9584] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(710), 1,
      sym_identifier,
    ACTIONS(712), 15,
      anon_sym_end,
      anon_sym_import,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9608] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(570), 1,
      anon_sym_as,
    STATE(197), 1,
      sym__rename_import,
    ACTIONS(714), 14,
      anon_sym_end,
      anon_sym_import,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9634] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_EQ,
    STATE(94), 1,
      sym_actual_arguments,
    ACTIONS(540), 2,
      anon_sym_is,
      anon_sym_def,
    ACTIONS(651), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(653), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(655), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(657), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    STATE(60), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [9672] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(716), 1,
      sym_identifier,
    ACTIONS(718), 14,
      anon_sym_end,
      anon_sym_def,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9695] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(720), 1,
      sym_identifier,
    ACTIONS(722), 14,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9718] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    ACTIONS(726), 1,
      anon_sym_LBRACE,
    STATE(221), 1,
      sym_datatype_def_restriction,
    STATE(260), 1,
      sym_annotation_only_body,
    ACTIONS(724), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9747] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(728), 1,
      sym_identifier,
    ACTIONS(730), 14,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9770] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(195), 1,
      anon_sym_LPAREN,
    ACTIONS(677), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(679), 10,
      anon_sym_RBRACK,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
  [9795] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    ACTIONS(726), 1,
      anon_sym_LBRACE,
    STATE(215), 1,
      sym_datatype_def_restriction,
    STATE(242), 1,
      sym_annotation_only_body,
    ACTIONS(732), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9824] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_EQ,
    STATE(102), 1,
      sym_actual_arguments,
    ACTIONS(651), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(653), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(655), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(657), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    STATE(60), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [9858] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_EQ,
    STATE(94), 1,
      sym_actual_arguments,
    ACTIONS(651), 2,
      anon_sym_SLASH_EQ,
      anon_sym_u2260,
    ACTIONS(653), 2,
      sym_op_less_than,
      sym_op_greater_than,
    ACTIONS(655), 2,
      anon_sym_LT_EQ,
      anon_sym_u2264,
    ACTIONS(657), 2,
      anon_sym_GT_EQ,
      anon_sym_u2265,
    STATE(60), 3,
      sym_op_inequality,
      sym_op_less_than_or_equal,
      sym_op_greater_than_or_equal,
  [9892] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(734), 14,
      anon_sym_end,
      anon_sym_import,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9912] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(677), 4,
      sym_identifier,
      sym_decimal,
      sym_integer,
      sym_unsigned,
    ACTIONS(679), 10,
      anon_sym_RBRACK,
      sym_quoted_string,
      anon_sym_LT,
      anon_sym_POUND_LBRACK,
      sym_double,
      sym_rational,
      anon_sym_true,
      anon_sym_u22a4,
      anon_sym_false,
      anon_sym_u22a5,
  [9934] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(736), 14,
      anon_sym_end,
      anon_sym_import,
      anon_sym_AT,
      anon_sym_assert,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [9954] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(738), 1,
      sym_identifier,
    ACTIONS(740), 13,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_parent,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
      anon_sym_ref,
  [9976] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(742), 1,
      anon_sym_is,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    STATE(283), 1,
      sym_type_class_body,
    ACTIONS(744), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10002] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(750), 1,
      anon_sym_end,
    ACTIONS(752), 1,
      anon_sym_ref,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(305), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [10037] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(754), 1,
      anon_sym_is,
    STATE(267), 1,
      sym_structure_body,
    ACTIONS(756), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10060] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    STATE(275), 1,
      sym_annotation_only_body,
    ACTIONS(758), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10083] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(760), 1,
      anon_sym_is,
    STATE(239), 1,
      sym_entity_body,
    ACTIONS(762), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10106] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(764), 1,
      anon_sym_end,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(213), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(329), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [10141] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(768), 1,
      anon_sym_of,
    STATE(265), 1,
      sym_enum_body,
    ACTIONS(766), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10164] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(770), 1,
      anon_sym_is,
    STATE(266), 1,
      sym_event_body,
    ACTIONS(772), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10187] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(742), 1,
      anon_sym_is,
    STATE(282), 1,
      sym_type_class_body,
    ACTIONS(774), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10210] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    STATE(263), 1,
      sym_annotation_only_body,
    ACTIONS(776), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10233] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(780), 1,
      anon_sym_of,
    STATE(271), 1,
      sym_union_body,
    ACTIONS(778), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10256] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(782), 1,
      anon_sym_is,
    STATE(258), 1,
      sym_dimension_body,
    ACTIONS(784), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10279] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(786), 12,
      anon_sym_is,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10297] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(788), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10315] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(790), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10333] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(792), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10351] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(794), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10369] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(796), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10387] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(798), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10405] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(800), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10423] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(802), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10441] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(804), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10459] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(806), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_end,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(361), 1,
      sym_identifier_reference,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(343), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [10493] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(810), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10511] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(812), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10529] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(814), 12,
      anon_sym_RBRACE,
      anon_sym_length,
      anon_sym_maxLength,
      anon_sym_minLength,
      anon_sym_fractionDigits,
      anon_sym_totalDigits,
      anon_sym_maxExclusive,
      anon_sym_maxInclusive,
      anon_sym_minExclusive,
      anon_sym_minInclusive,
      anon_sym_explicitTimezone,
      anon_sym_pattern,
  [10547] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(806), 1,
      sym_identifier,
    ACTIONS(816), 1,
      anon_sym_end,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(361), 1,
      sym_identifier_reference,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(234), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(334), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [10581] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(818), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10598] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(820), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10615] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(822), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10632] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(824), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10649] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(826), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10666] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(828), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10683] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(830), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10700] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(832), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10717] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(834), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10734] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(836), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10751] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(838), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10768] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(840), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10785] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(842), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10802] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(844), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10819] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(846), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10836] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(848), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10853] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(850), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10870] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(852), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10887] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(854), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10904] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(856), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10921] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(858), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10938] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(860), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10955] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(862), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10972] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(864), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [10989] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(866), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11006] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(868), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11023] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(870), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11040] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(872), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11057] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(874), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11074] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(876), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11091] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(878), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11108] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(880), 1,
      anon_sym_end,
    ACTIONS(882), 1,
      anon_sym_def,
    STATE(302), 1,
      sym_function_signature,
    STATE(368), 1,
      aux_sym_type_class_body_repeat1,
    STATE(458), 1,
      sym_method_def,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
  [11141] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(884), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11158] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(886), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11175] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(888), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11192] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(890), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11209] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(892), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11226] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(894), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11243] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(896), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11260] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(882), 1,
      anon_sym_def,
    ACTIONS(898), 1,
      anon_sym_end,
    STATE(302), 1,
      sym_function_signature,
    STATE(356), 1,
      aux_sym_type_class_body_repeat1,
    STATE(458), 1,
      sym_method_def,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(270), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [11293] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(900), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11310] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(902), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11327] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(904), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11344] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(906), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11361] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(908), 11,
      anon_sym_end,
      anon_sym_datatype,
      anon_sym_dimension,
      anon_sym_entity,
      anon_sym_enum,
      anon_sym_event,
      anon_sym_property,
      anon_sym_structure,
      anon_sym_union,
      anon_sym_rdf,
      anon_sym_class,
  [11378] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(910), 1,
      anon_sym_end,
    ACTIONS(912), 1,
      anon_sym_parent,
    STATE(291), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(310), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [11406] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(914), 1,
      anon_sym_source,
    ACTIONS(916), 1,
      anon_sym_identity,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(290), 2,
      sym_source_entity,
      sym_entity_identity,
  [11434] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(918), 1,
      sym_identifier,
    ACTIONS(920), 1,
      anon_sym_end,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(372), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [11462] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(918), 1,
      sym_identifier,
    ACTIONS(922), 1,
      anon_sym_end,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(286), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(389), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [11490] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(912), 1,
      anon_sym_parent,
    ACTIONS(924), 1,
      anon_sym_end,
    STATE(321), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(345), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [11518] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(914), 1,
      anon_sym_source,
    ACTIONS(916), 1,
      anon_sym_identity,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(284), 2,
      sym_source_entity,
      sym_entity_identity,
    STATE(285), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [11546] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(912), 1,
      anon_sym_parent,
    ACTIONS(926), 1,
      anon_sym_end,
    STATE(288), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(307), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [11574] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(912), 1,
      anon_sym_parent,
    ACTIONS(928), 1,
      anon_sym_end,
    STATE(312), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(345), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [11602] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(930), 1,
      sym_identifier,
    STATE(377), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(387), 1,
      sym_sequence_ordering,
    STATE(439), 1,
      sym_variable,
    STATE(499), 1,
      sym_sequence_uniqueness,
    ACTIONS(932), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(934), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [11629] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(930), 1,
      sym_identifier,
    STATE(376), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(387), 1,
      sym_sequence_ordering,
    STATE(439), 1,
      sym_variable,
    STATE(499), 1,
      sym_sequence_uniqueness,
    ACTIONS(932), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(934), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [11656] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(471), 1,
      sym_quantified_variable_binding,
    STATE(475), 1,
      sym_sequence_builder_body,
    STATE(476), 1,
      sym_quantified_sentence,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
  [11681] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(936), 1,
      anon_sym_RBRACE,
    ACTIONS(938), 1,
      sym_unsigned,
    STATE(346), 1,
      sym_sequence_ordering,
    STATE(426), 1,
      sym_sequence_uniqueness,
    STATE(462), 1,
      sym__cardinality_inner,
    ACTIONS(932), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(934), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [11708] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(471), 1,
      sym_quantified_variable_binding,
    STATE(476), 1,
      sym_quantified_sentence,
    STATE(529), 1,
      sym_sequence_builder_body,
    ACTIONS(95), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(97), 2,
      anon_sym_exists,
      anon_sym_u2203,
    STATE(424), 2,
      sym_logical_quantifier_universal,
      sym_logical_quantifier_existential,
  [11733] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(916), 1,
      anon_sym_identity,
    STATE(308), 1,
      sym_entity_identity,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
  [11757] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(914), 1,
      anon_sym_source,
    STATE(326), 1,
      sym_source_entity,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
  [11781] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(914), 1,
      anon_sym_source,
    STATE(319), 1,
      sym_source_entity,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(298), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [11805] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(938), 1,
      sym_unsigned,
    STATE(359), 1,
      sym_sequence_ordering,
    STATE(444), 1,
      sym_sequence_uniqueness,
    STATE(474), 1,
      sym__cardinality_inner,
    ACTIONS(932), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(934), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [11829] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(916), 1,
      anon_sym_identity,
    STATE(317), 1,
      sym_entity_identity,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(297), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [11853] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    STATE(31), 1,
      sym_function_op_by_definition,
    STATE(390), 1,
      sym_function_body,
    STATE(433), 1,
      sym_annotation_only_body,
    ACTIONS(940), 2,
      anon_sym_end,
      anon_sym_def,
    ACTIONS(942), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [11877] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    ACTIONS(944), 1,
      anon_sym_end,
    STATE(128), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
  [11898] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(946), 1,
      sym_identifier,
    ACTIONS(948), 6,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [11913] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(950), 1,
      anon_sym_end,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [11934] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(952), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_end,
    ACTIONS(957), 1,
      anon_sym_ref,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [11955] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(924), 1,
      anon_sym_end,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [11976] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(960), 1,
      anon_sym_end,
    STATE(311), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [11997] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(962), 1,
      sym_identifier,
    ACTIONS(964), 6,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [12012] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(928), 1,
      anon_sym_end,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12033] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(966), 1,
      anon_sym_end,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12054] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(968), 1,
      anon_sym_end,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12075] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(355), 1,
      sym_type_class_arguments,
    ACTIONS(970), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [12092] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(974), 1,
      sym_identifier,
    ACTIONS(976), 1,
      anon_sym_RBRACK,
    STATE(384), 1,
      sym_qualified_identifier,
    STATE(316), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [12111] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(375), 1,
      sym__type_op_has_type,
    STATE(420), 1,
      sym__type_variable_restriction,
    ACTIONS(980), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(978), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12130] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(982), 1,
      sym_identifier,
    ACTIONS(985), 1,
      anon_sym_RBRACK,
    STATE(384), 1,
      sym_qualified_identifier,
    STATE(316), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [12149] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(987), 1,
      anon_sym_end,
    STATE(323), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12170] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(330), 1,
      aux_sym__type_variable_restriction_repeat1,
    STATE(378), 1,
      sym_type_op_combiner,
    ACTIONS(991), 2,
      anon_sym_PLUS,
      anon_sym_u2295,
    ACTIONS(989), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12189] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(993), 1,
      anon_sym_end,
    STATE(324), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12210] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(995), 1,
      sym_identifier,
    ACTIONS(997), 6,
      anon_sym_is,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [12225] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(999), 1,
      anon_sym_end,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12246] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(1001), 1,
      anon_sym_end,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12267] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(1003), 1,
      anon_sym_end,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12288] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(1005), 1,
      anon_sym_end,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12309] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(209), 1,
      anon_sym_LT,
    ACTIONS(511), 1,
      anon_sym_COLON,
    ACTIONS(568), 1,
      anon_sym_RBRACK,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_as,
    STATE(194), 1,
      sym__rename_import,
    STATE(380), 1,
      sym_iri,
  [12334] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    ACTIONS(1011), 1,
      anon_sym_end,
    STATE(322), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12355] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(318), 1,
      aux_sym__type_variable_restriction_repeat1,
    STATE(378), 1,
      sym_type_op_combiner,
    ACTIONS(991), 2,
      anon_sym_PLUS,
      anon_sym_u2295,
    ACTIONS(1013), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12374] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      sym_identifier,
    STATE(511), 1,
      sym__type_op_has_type,
    ACTIONS(1019), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(1017), 3,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
  [12393] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(750), 1,
      anon_sym_end,
    ACTIONS(752), 1,
      anon_sym_ref,
    STATE(306), 2,
      sym_member,
      aux_sym_dimension_body_repeat2,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [12414] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(330), 1,
      aux_sym__type_variable_restriction_repeat1,
    STATE(378), 1,
      sym_type_op_combiner,
    ACTIONS(1023), 2,
      anon_sym_PLUS,
      anon_sym_u2295,
    ACTIONS(1021), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12433] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(375), 1,
      sym__type_op_has_type,
    STATE(413), 1,
      sym__type_variable_restriction,
    ACTIONS(980), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(1026), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [12452] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    ACTIONS(1030), 1,
      anon_sym_RPAREN,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(313), 1,
      sym_identifier_reference,
    STATE(337), 1,
      aux_sym_type_class_arguments_repeat1,
    STATE(455), 1,
      sym_type_class_reference,
  [12474] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(1032), 1,
      sym_identifier,
    ACTIONS(1034), 1,
      anon_sym_RPAREN,
    STATE(338), 1,
      aux_sym_type_class_def_repeat1,
    STATE(417), 1,
      sym_type_variable,
    STATE(466), 1,
      sym_function_cardinality_expression,
  [12496] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(806), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_end,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(361), 1,
      sym_identifier_reference,
    STATE(341), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [12516] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    ACTIONS(1036), 1,
      sym_identifier,
    STATE(396), 1,
      sym_annotation_only_body,
    ACTIONS(1038), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [12534] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    ACTIONS(1040), 1,
      sym_wildcard,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(313), 1,
      sym_identifier_reference,
    STATE(332), 1,
      aux_sym_type_class_arguments_repeat1,
    STATE(455), 1,
      sym_type_class_reference,
  [12556] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1042), 1,
      sym_identifier,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(313), 1,
      sym_identifier_reference,
    STATE(337), 1,
      aux_sym_type_class_arguments_repeat1,
    STATE(455), 1,
      sym_type_class_reference,
  [12578] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1047), 1,
      sym_identifier,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
    ACTIONS(1052), 1,
      anon_sym_LBRACE,
    STATE(338), 1,
      aux_sym_type_class_def_repeat1,
    STATE(417), 1,
      sym_type_variable,
    STATE(466), 1,
      sym_function_cardinality_expression,
  [12600] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_LBRACK,
    STATE(195), 1,
      sym_qualified_identifier,
    STATE(210), 3,
      sym__import,
      sym_member_import,
      sym_module_import,
  [12618] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(387), 1,
      sym_sequence_ordering,
    STATE(499), 1,
      sym_sequence_uniqueness,
    ACTIONS(932), 2,
      anon_sym_ordered,
      anon_sym_unordered,
    ACTIONS(934), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [12636] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1062), 1,
      anon_sym_end,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(361), 1,
      sym_identifier_reference,
    STATE(341), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [12656] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_AT,
    ACTIONS(269), 1,
      anon_sym_assert,
    STATE(170), 2,
      sym_annotation_property,
      sym_constraint,
    STATE(303), 2,
      sym_annotation,
      aux_sym_module_body_repeat2,
  [12674] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(806), 1,
      sym_identifier,
    ACTIONS(1064), 1,
      anon_sym_end,
    STATE(117), 1,
      sym_qualified_identifier,
    STATE(361), 1,
      sym_identifier_reference,
    STATE(341), 2,
      sym_type_variant,
      aux_sym_union_body_repeat1,
  [12694] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1066), 1,
      anon_sym_is,
    ACTIONS(1068), 1,
      anon_sym_EQ,
    ACTIONS(1070), 1,
      anon_sym_with,
    STATE(494), 1,
      sym_constraint_environment,
    STATE(175), 2,
      sym_informal_constraint,
      sym_formal_constraint,
  [12714] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 1,
      sym_identifier,
    ACTIONS(1076), 1,
      anon_sym_parent,
    ACTIONS(1074), 2,
      anon_sym_end,
      anon_sym_ref,
    STATE(345), 2,
      sym_dimension_parent,
      aux_sym_dimension_body_repeat1,
  [12732] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(938), 1,
      sym_unsigned,
    ACTIONS(1079), 1,
      anon_sym_RBRACE,
    STATE(421), 1,
      sym_sequence_uniqueness,
    STATE(479), 1,
      sym__cardinality_inner,
    ACTIONS(934), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [12752] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(974), 1,
      sym_identifier,
    STATE(384), 1,
      sym_qualified_identifier,
    STATE(314), 4,
      sym__import,
      sym_member_import,
      sym_module_import,
      aux_sym_import_statement_repeat1,
  [12768] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1083), 1,
      sym_kw_is_fixed,
    STATE(230), 1,
      sym_tz_restriction_value,
    ACTIONS(1081), 3,
      anon_sym_required,
      anon_sym_prohibited,
      anon_sym_optional,
  [12783] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1085), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [12794] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1087), 1,
      anon_sym_end,
    ACTIONS(1089), 1,
      anon_sym_def,
    STATE(302), 1,
      sym_function_signature,
    STATE(350), 1,
      aux_sym_type_class_body_repeat1,
    STATE(458), 1,
      sym_method_def,
  [12813] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    STATE(8), 1,
      sym__type_op_has_type,
    STATE(362), 1,
      sym__function_type,
    ACTIONS(1094), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [12830] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1096), 1,
      anon_sym_is,
    ACTIONS(1098), 1,
      anon_sym_def,
    STATE(379), 1,
      sym_function_signature,
    STATE(352), 2,
      sym_function_def,
      aux_sym_constraint_environment_repeat1,
  [12847] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1101), 1,
      sym_identifier,
    ACTIONS(1105), 1,
      anon_sym_with,
    ACTIONS(1103), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [12862] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1107), 1,
      anon_sym_is,
    STATE(435), 1,
      sym__module_locations,
    STATE(437), 1,
      sym_iri,
    STATE(528), 1,
      sym_module_body,
  [12881] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1109), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [12892] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(882), 1,
      anon_sym_def,
    ACTIONS(1111), 1,
      anon_sym_end,
    STATE(302), 1,
      sym_function_signature,
    STATE(350), 1,
      aux_sym_type_class_body_repeat1,
    STATE(458), 1,
      sym_method_def,
  [12911] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1021), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [12922] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1113), 5,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [12933] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(938), 1,
      sym_unsigned,
    STATE(456), 1,
      sym_sequence_uniqueness,
    STATE(488), 1,
      sym__cardinality_inner,
    ACTIONS(934), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [12950] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_RBRACK,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(363), 1,
      aux_sym_rdf_types_repeat1,
    STATE(457), 1,
      sym_identifier_reference,
  [12969] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    ACTIONS(1117), 1,
      sym_identifier,
    ACTIONS(1119), 1,
      anon_sym_end,
    ACTIONS(1121), 1,
      anon_sym_as,
    STATE(454), 1,
      sym_annotation_only_body,
  [12988] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 5,
      anon_sym_is,
      anon_sym_end,
      anon_sym_def,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [12999] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_RBRACK,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(371), 1,
      aux_sym_rdf_types_repeat1,
    STATE(457), 1,
      sym_identifier_reference,
  [13018] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 5,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_u2295,
  [13029] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    STATE(277), 1,
      sym_annotation_only_body,
    STATE(442), 1,
      sym_rdf_types,
    ACTIONS(1129), 2,
      anon_sym_a,
      anon_sym_type,
  [13046] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(65), 1,
      sym_identifier,
    ACTIONS(511), 1,
      anon_sym_COLON,
    ACTIONS(67), 3,
      anon_sym_is,
      anon_sym_end,
      anon_sym_as,
  [13061] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      sym_identifier,
    ACTIONS(752), 1,
      anon_sym_ref,
    STATE(383), 1,
      sym_member,
    STATE(401), 2,
      sym_member_def,
      sym_property_ref,
  [13078] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(882), 1,
      anon_sym_def,
    ACTIONS(1131), 1,
      anon_sym_end,
    STATE(302), 1,
      sym_function_signature,
    STATE(350), 1,
      aux_sym_type_class_body_repeat1,
    STATE(458), 1,
      sym_method_def,
  [13097] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(882), 1,
      anon_sym_def,
    ACTIONS(1133), 1,
      anon_sym_is,
    STATE(379), 1,
      sym_function_signature,
    STATE(352), 2,
      sym_function_def,
      aux_sym_constraint_environment_repeat1,
  [13114] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(1032), 1,
      sym_identifier,
    STATE(333), 1,
      aux_sym_type_class_def_repeat1,
    STATE(417), 1,
      sym_type_variable,
    STATE(466), 1,
      sym_function_cardinality_expression,
  [13133] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 1,
      sym_identifier,
    ACTIONS(1138), 1,
      anon_sym_RBRACK,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(371), 1,
      aux_sym_rdf_types_repeat1,
    STATE(457), 1,
      sym_identifier_reference,
  [13152] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(918), 1,
      sym_identifier,
    ACTIONS(1140), 1,
      anon_sym_end,
    STATE(393), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [13166] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13178] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    ACTIONS(1146), 1,
      anon_sym_LBRACK,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(470), 1,
      sym_identifier_reference,
  [13194] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(313), 1,
      sym_identifier_reference,
    STATE(327), 1,
      sym_type_class_reference,
  [13210] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 1,
      sym_identifier,
    ACTIONS(1150), 1,
      sym_set_op_builder,
    STATE(403), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(439), 1,
      sym_variable,
  [13226] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 1,
      sym_identifier,
    ACTIONS(1152), 1,
      sym_set_op_builder,
    STATE(403), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(439), 1,
      sym_variable,
  [13242] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(313), 1,
      sym_identifier_reference,
    STATE(357), 1,
      sym_type_class_reference,
  [13258] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(29), 1,
      sym_function_op_by_definition,
    STATE(434), 1,
      sym_function_body,
    ACTIONS(942), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [13272] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(714), 1,
      anon_sym_RBRACK,
    ACTIONS(1009), 1,
      anon_sym_as,
    ACTIONS(1154), 1,
      sym_identifier,
    STATE(197), 1,
      sym__rename_import,
  [13288] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    ACTIONS(1156), 1,
      sym_identifier,
    ACTIONS(1158), 1,
      anon_sym_end,
    STATE(445), 1,
      sym_annotation_only_body,
  [13304] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(1163), 1,
      anon_sym_RPAREN,
    STATE(382), 1,
      aux_sym_function_signature_repeat1,
    STATE(459), 1,
      sym_function_parameter,
  [13320] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1165), 1,
      sym_identifier,
    ACTIONS(1167), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13332] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(702), 1,
      anon_sym_RBRACK,
    ACTIONS(1009), 1,
      anon_sym_as,
    ACTIONS(1169), 1,
      sym_identifier,
    STATE(191), 1,
      sym__rename_import,
  [13348] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(233), 1,
      sym_tz_restriction_value,
    ACTIONS(1081), 3,
      anon_sym_required,
      anon_sym_prohibited,
      anon_sym_optional,
  [13360] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 1,
      sym_identifier,
    ACTIONS(1173), 3,
      anon_sym_in,
      anon_sym_u2208,
      sym_set_op_builder,
  [13372] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 1,
      anon_sym_RBRACE,
    STATE(535), 1,
      sym_sequence_uniqueness,
    ACTIONS(934), 2,
      anon_sym_unique,
      anon_sym_nonunique,
  [13386] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    ACTIONS(1177), 1,
      sym_identifier,
    ACTIONS(1179), 1,
      anon_sym_end,
    STATE(452), 1,
      sym_annotation_only_body,
  [13402] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(918), 1,
      sym_identifier,
    ACTIONS(920), 1,
      anon_sym_end,
    STATE(393), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [13416] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    STATE(450), 1,
      sym_annotation_only_body,
    ACTIONS(1181), 2,
      anon_sym_end,
      anon_sym_def,
  [13430] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 4,
      anon_sym_RBRACE,
      sym_unsigned,
      anon_sym_unique,
      anon_sym_nonunique,
  [13440] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(8), 1,
      sym__type_op_has_type,
    STATE(436), 1,
      sym__function_type,
    ACTIONS(1094), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13454] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1185), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      anon_sym_end,
    STATE(393), 2,
      sym_value_variant,
      aux_sym_enum_body_repeat1,
  [13468] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1190), 1,
      sym_identifier,
    ACTIONS(1192), 1,
      anon_sym_RPAREN,
    STATE(382), 1,
      aux_sym_function_signature_repeat1,
    STATE(459), 1,
      sym_function_parameter,
  [13484] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(4), 1,
      sym__type_op_has_type,
    STATE(196), 1,
      sym__type_expression_to,
    ACTIONS(1194), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13498] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 1,
      sym_identifier,
    ACTIONS(1198), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13510] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(8), 1,
      sym__type_op_has_type,
    STATE(358), 1,
      sym__function_type,
    ACTIONS(1094), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13524] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1200), 1,
      sym_identifier,
    ACTIONS(1202), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13536] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 1,
      sym_identifier,
    ACTIONS(1206), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13548] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1208), 1,
      sym_identifier,
    ACTIONS(1210), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13560] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1212), 1,
      sym_identifier,
    ACTIONS(1214), 3,
      anon_sym_end,
      anon_sym_parent,
      anon_sym_ref,
  [13572] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(882), 1,
      anon_sym_def,
    STATE(379), 1,
      sym_function_signature,
    STATE(369), 2,
      sym_function_def,
      aux_sym_constraint_environment_repeat1,
  [13586] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1216), 1,
      sym_identifier,
    ACTIONS(1219), 1,
      sym_set_op_builder,
    STATE(403), 1,
      aux_sym_sequence_builder_repeat1,
    STATE(439), 1,
      sym_variable,
  [13602] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1221), 1,
      sym_identifier,
    ACTIONS(1223), 1,
      anon_sym_RBRACK,
    STATE(410), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [13615] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1225), 1,
      anon_sym_RBRACK,
    ACTIONS(1227), 1,
      sym_hex_byte,
    STATE(415), 1,
      aux_sym_binary_repeat1,
  [13628] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1229), 1,
      sym_quoted_string,
    STATE(461), 1,
      sym_iri,
  [13641] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(373), 1,
      sym_identifier_reference,
  [13654] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1190), 1,
      sym_identifier,
    STATE(394), 1,
      aux_sym_function_signature_repeat1,
    STATE(459), 1,
      sym_function_parameter,
  [13667] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(335), 1,
      sym_identifier_reference,
  [13680] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 1,
      sym_identifier,
    ACTIONS(1234), 1,
      anon_sym_RBRACK,
    STATE(410), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [13693] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1236), 1,
      anon_sym_RBRACE,
    ACTIONS(1238), 1,
      anon_sym_DOT_DOT,
    STATE(491), 1,
      sym_cardinality_range,
  [13706] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(15), 1,
      sym__type_op_has_type,
    ACTIONS(1240), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13717] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1242), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13726] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 1,
      sym_hex_byte,
    ACTIONS(1244), 1,
      anon_sym_RBRACK,
    STATE(422), 1,
      aux_sym_binary_repeat1,
  [13739] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1246), 1,
      anon_sym_RBRACK,
    ACTIONS(1248), 1,
      sym_hex_byte,
    STATE(415), 1,
      aux_sym_binary_repeat1,
  [13752] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(18), 1,
      sym__type_op_type_restriction,
    ACTIONS(1251), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
  [13763] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1253), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13772] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 1,
      anon_sym_RBRACK,
    ACTIONS(1257), 1,
      sym_quoted_string,
    STATE(419), 1,
      aux_sym_pattern_restriction_facet_repeat1,
  [13785] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 1,
      anon_sym_RBRACK,
    ACTIONS(1261), 1,
      sym_quoted_string,
    STATE(419), 1,
      aux_sym_pattern_restriction_facet_repeat1,
  [13798] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1264), 3,
      sym_identifier,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [13807] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(938), 1,
      sym_unsigned,
    ACTIONS(1266), 1,
      anon_sym_RBRACE,
    STATE(492), 1,
      sym__cardinality_inner,
  [13820] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 1,
      sym_hex_byte,
    ACTIONS(1268), 1,
      anon_sym_RBRACK,
    STATE(415), 1,
      aux_sym_binary_repeat1,
  [13833] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(353), 1,
      sym_identifier_reference,
  [13846] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 1,
      sym_identifier,
    STATE(430), 1,
      sym_variable,
    STATE(531), 1,
      sym_quantified_variable,
  [13859] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1028), 1,
      sym_identifier,
    STATE(19), 1,
      sym_qualified_identifier,
    STATE(505), 1,
      sym_identifier_reference,
  [13872] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(938), 1,
      sym_unsigned,
    ACTIONS(1270), 1,
      anon_sym_RBRACE,
    STATE(478), 1,
      sym__cardinality_inner,
  [13885] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 1,
      anon_sym_LPAREN,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    STATE(152), 1,
      sym_actual_arguments,
  [13898] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 1,
      sym_hex_byte,
    ACTIONS(1274), 1,
      anon_sym_RBRACK,
    STATE(405), 1,
      aux_sym_binary_repeat1,
  [13911] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(409), 1,
      sym__type_op_has_type,
    ACTIONS(1276), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
  [13922] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    STATE(59), 1,
      sym_set_op_membership,
    ACTIONS(1278), 2,
      anon_sym_in,
      anon_sym_u2208,
  [13933] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    STATE(399), 1,
      sym__identifier_or_sequence,
  [13946] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1284), 2,
      anon_sym_RBRACK,
      sym_hex_byte,
  [13954] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1286), 2,
      anon_sym_end,
      anon_sym_def,
  [13962] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1288), 2,
      anon_sym_is,
      anon_sym_def,
  [13970] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 1,
      anon_sym_is,
    STATE(507), 1,
      sym_module_body,
  [13980] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1290), 2,
      sym_identifier,
      anon_sym_RPAREN,
  [13988] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1292), 1,
      anon_sym_version,
    ACTIONS(1294), 1,
      anon_sym_is,
  [13998] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1296), 1,
      sym_identifier,
    STATE(249), 1,
      sym_member_def,
  [14008] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1298), 2,
      sym_identifier,
      sym_set_op_builder,
  [14016] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    STATE(489), 1,
      sym_iri,
  [14026] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1300), 1,
      anon_sym_RBRACE,
    ACTIONS(1302), 1,
      sym_unsigned,
  [14036] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_is,
    STATE(243), 1,
      sym_annotation_only_body,
  [14046] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1221), 1,
      sym_identifier,
    STATE(404), 1,
      aux_sym__identifier_or_sequence_repeat1,
  [14056] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(938), 1,
      sym_unsigned,
    STATE(481), 1,
      sym__cardinality_inner,
  [14066] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1304), 1,
      sym_identifier,
    ACTIONS(1306), 1,
      anon_sym_end,
  [14076] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1308), 1,
      sym_quoted_string,
    STATE(418), 1,
      aux_sym_pattern_restriction_facet_repeat1,
  [14086] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1310), 2,
      anon_sym_RBRACE,
      sym_unsigned,
  [14094] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1312), 2,
      anon_sym_RBRACK,
      sym_identifier,
  [14102] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      sym_quoted_string,
  [14112] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1318), 2,
      anon_sym_end,
      anon_sym_def,
  [14120] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1320), 1,
      sym_unsigned,
    ACTIONS(1322), 1,
      sym_kw_is_fixed,
  [14130] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1326), 1,
      anon_sym_end,
  [14140] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1328), 1,
      sym_unsigned,
    ACTIONS(1330), 1,
      sym_kw_is_fixed,
  [14150] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1332), 1,
      sym_identifier,
    ACTIONS(1334), 1,
      anon_sym_end,
  [14160] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1336), 2,
      sym_identifier,
      anon_sym_RPAREN,
  [14168] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(938), 1,
      sym_unsigned,
    STATE(464), 1,
      sym__cardinality_inner,
  [14178] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1338), 2,
      anon_sym_RBRACK,
      sym_identifier,
  [14186] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1340), 2,
      anon_sym_end,
      anon_sym_def,
  [14194] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1342), 2,
      sym_identifier,
      anon_sym_RPAREN,
  [14202] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1344), 1,
      sym_identifier,
  [14209] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1346), 1,
      anon_sym_is,
  [14216] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1348), 1,
      anon_sym_RBRACE,
  [14223] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1350), 1,
      sym_identifier,
  [14230] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1352), 1,
      anon_sym_RBRACE,
  [14237] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1354), 1,
      ts_builtin_sym_end,
  [14244] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1356), 1,
      sym_identifier,
  [14251] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1358), 1,
      anon_sym_RPAREN,
  [14258] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1360), 1,
      anon_sym_RBRACE,
  [14265] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1362), 1,
      anon_sym_RPAREN,
  [14272] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1364), 1,
      anon_sym_is,
  [14279] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1366), 1,
      anon_sym_COMMA,
  [14286] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1368), 1,
      sym_identifier,
  [14293] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1370), 1,
      anon_sym_is,
  [14300] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1372), 1,
      anon_sym_RBRACE,
  [14307] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1374), 1,
      anon_sym_RBRACE,
  [14314] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1376), 1,
      anon_sym_RBRACE,
  [14321] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1378), 1,
      anon_sym_LBRACK,
  [14328] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1380), 1,
      anon_sym_RBRACE,
  [14335] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1382), 1,
      anon_sym_RBRACE,
  [14342] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1384), 1,
      anon_sym_is,
  [14349] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1386), 1,
      anon_sym_RBRACE,
  [14356] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1388), 1,
      sym_identifier,
  [14363] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1390), 1,
      anon_sym_LBRACK,
  [14370] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1392), 1,
      sym_identifier,
  [14377] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1394), 1,
      sym_identifier,
  [14384] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1396), 1,
      sym_identifier,
  [14391] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1398), 1,
      anon_sym_LBRACK,
  [14398] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1400), 1,
      anon_sym_RBRACE,
  [14405] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1402), 1,
      anon_sym_is,
  [14412] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1404), 1,
      ts_builtin_sym_end,
  [14419] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1406), 1,
      anon_sym_RBRACE,
  [14426] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1408), 1,
      anon_sym_RBRACE,
  [14433] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(195), 1,
      anon_sym_LPAREN,
  [14440] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1410), 1,
      anon_sym_is,
  [14447] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1412), 1,
      anon_sym_EQ,
  [14454] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1414), 1,
      sym_quoted_string,
  [14461] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1416), 1,
      sym_identifier,
  [14468] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1418), 1,
      sym_identifier,
  [14475] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1420), 1,
      anon_sym_RBRACE,
  [14482] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1422), 1,
      sym_identifier,
  [14489] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1424), 1,
      ts_builtin_sym_end,
  [14496] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1426), 1,
      anon_sym_EQ,
  [14503] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1428), 1,
      anon_sym_EQ,
  [14510] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1430), 1,
      anon_sym_EQ,
  [14517] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
  [14524] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1434), 1,
      anon_sym_EQ,
  [14531] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1436), 1,
      ts_builtin_sym_end,
  [14538] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1438), 1,
      anon_sym_GT,
  [14545] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1440), 1,
      anon_sym_GT,
  [14552] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1442), 1,
      sym_identifier,
  [14559] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1444), 1,
      sym_identifier,
  [14566] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1446), 1,
      sym_identifier,
  [14573] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1448), 1,
      sym_identifier,
  [14580] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1450), 1,
      sym_identifier,
  [14587] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1452), 1,
      sym_identifier,
  [14594] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
  [14601] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1456), 1,
      sym_unsigned,
  [14608] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1458), 1,
      sym_identifier,
  [14615] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1460), 1,
      sym_identifier,
  [14622] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1462), 1,
      sym_identifier,
  [14629] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1464), 1,
      sym_identifier,
  [14636] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1466), 1,
      sym_identifier,
  [14643] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1468), 1,
      sym_identifier,
  [14650] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1470), 1,
      sym_identifier,
  [14657] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1472), 1,
      anon_sym_LBRACK,
  [14664] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1474), 1,
      ts_builtin_sym_end,
  [14671] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1476), 1,
      sym_unsigned,
  [14678] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1478), 1,
      ts_builtin_sym_end,
  [14685] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1480), 1,
      anon_sym_RBRACE,
  [14692] = 2,
    ACTIONS(1482), 1,
      aux_sym_iri_token1,
    ACTIONS(1484), 1,
      sym_line_comment,
  [14699] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1486), 1,
      anon_sym_COMMA,
  [14706] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1488), 1,
      anon_sym_COMMA,
  [14713] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1490), 1,
      anon_sym_LBRACK,
  [14720] = 2,
    ACTIONS(1484), 1,
      sym_line_comment,
    ACTIONS(1492), 1,
      aux_sym_iri_token1,
  [14727] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1494), 1,
      anon_sym_RBRACE,
  [14734] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1496), 1,
      anon_sym_LBRACK,
  [14741] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1498), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 68,
  [SMALL_STATE(4)] = 136,
  [SMALL_STATE(5)] = 220,
  [SMALL_STATE(6)] = 285,
  [SMALL_STATE(7)] = 350,
  [SMALL_STATE(8)] = 415,
  [SMALL_STATE(9)] = 496,
  [SMALL_STATE(10)] = 561,
  [SMALL_STATE(11)] = 626,
  [SMALL_STATE(12)] = 691,
  [SMALL_STATE(13)] = 756,
  [SMALL_STATE(14)] = 820,
  [SMALL_STATE(15)] = 898,
  [SMALL_STATE(16)] = 976,
  [SMALL_STATE(17)] = 1054,
  [SMALL_STATE(18)] = 1129,
  [SMALL_STATE(19)] = 1201,
  [SMALL_STATE(20)] = 1263,
  [SMALL_STATE(21)] = 1332,
  [SMALL_STATE(22)] = 1453,
  [SMALL_STATE(23)] = 1574,
  [SMALL_STATE(24)] = 1695,
  [SMALL_STATE(25)] = 1816,
  [SMALL_STATE(26)] = 1937,
  [SMALL_STATE(27)] = 2058,
  [SMALL_STATE(28)] = 2179,
  [SMALL_STATE(29)] = 2300,
  [SMALL_STATE(30)] = 2421,
  [SMALL_STATE(31)] = 2542,
  [SMALL_STATE(32)] = 2663,
  [SMALL_STATE(33)] = 2717,
  [SMALL_STATE(34)] = 2771,
  [SMALL_STATE(35)] = 2825,
  [SMALL_STATE(36)] = 2879,
  [SMALL_STATE(37)] = 2933,
  [SMALL_STATE(38)] = 2986,
  [SMALL_STATE(39)] = 3039,
  [SMALL_STATE(40)] = 3092,
  [SMALL_STATE(41)] = 3145,
  [SMALL_STATE(42)] = 3198,
  [SMALL_STATE(43)] = 3251,
  [SMALL_STATE(44)] = 3304,
  [SMALL_STATE(45)] = 3357,
  [SMALL_STATE(46)] = 3438,
  [SMALL_STATE(47)] = 3483,
  [SMALL_STATE(48)] = 3564,
  [SMALL_STATE(49)] = 3645,
  [SMALL_STATE(50)] = 3726,
  [SMALL_STATE(51)] = 3807,
  [SMALL_STATE(52)] = 3849,
  [SMALL_STATE(53)] = 3891,
  [SMALL_STATE(54)] = 3933,
  [SMALL_STATE(55)] = 3975,
  [SMALL_STATE(56)] = 4017,
  [SMALL_STATE(57)] = 4059,
  [SMALL_STATE(58)] = 4101,
  [SMALL_STATE(59)] = 4176,
  [SMALL_STATE(60)] = 4251,
  [SMALL_STATE(61)] = 4326,
  [SMALL_STATE(62)] = 4369,
  [SMALL_STATE(63)] = 4447,
  [SMALL_STATE(64)] = 4525,
  [SMALL_STATE(65)] = 4599,
  [SMALL_STATE(66)] = 4677,
  [SMALL_STATE(67)] = 4723,
  [SMALL_STATE(68)] = 4801,
  [SMALL_STATE(69)] = 4875,
  [SMALL_STATE(70)] = 4953,
  [SMALL_STATE(71)] = 5031,
  [SMALL_STATE(72)] = 5109,
  [SMALL_STATE(73)] = 5187,
  [SMALL_STATE(74)] = 5265,
  [SMALL_STATE(75)] = 5308,
  [SMALL_STATE(76)] = 5351,
  [SMALL_STATE(77)] = 5394,
  [SMALL_STATE(78)] = 5437,
  [SMALL_STATE(79)] = 5475,
  [SMALL_STATE(80)] = 5547,
  [SMALL_STATE(81)] = 5619,
  [SMALL_STATE(82)] = 5691,
  [SMALL_STATE(83)] = 5758,
  [SMALL_STATE(84)] = 5825,
  [SMALL_STATE(85)] = 5861,
  [SMALL_STATE(86)] = 5897,
  [SMALL_STATE(87)] = 5933,
  [SMALL_STATE(88)] = 5969,
  [SMALL_STATE(89)] = 6005,
  [SMALL_STATE(90)] = 6041,
  [SMALL_STATE(91)] = 6077,
  [SMALL_STATE(92)] = 6113,
  [SMALL_STATE(93)] = 6149,
  [SMALL_STATE(94)] = 6185,
  [SMALL_STATE(95)] = 6222,
  [SMALL_STATE(96)] = 6284,
  [SMALL_STATE(97)] = 6346,
  [SMALL_STATE(98)] = 6408,
  [SMALL_STATE(99)] = 6470,
  [SMALL_STATE(100)] = 6532,
  [SMALL_STATE(101)] = 6567,
  [SMALL_STATE(102)] = 6626,
  [SMALL_STATE(103)] = 6661,
  [SMALL_STATE(104)] = 6693,
  [SMALL_STATE(105)] = 6725,
  [SMALL_STATE(106)] = 6781,
  [SMALL_STATE(107)] = 6813,
  [SMALL_STATE(108)] = 6845,
  [SMALL_STATE(109)] = 6877,
  [SMALL_STATE(110)] = 6909,
  [SMALL_STATE(111)] = 6941,
  [SMALL_STATE(112)] = 6974,
  [SMALL_STATE(113)] = 7027,
  [SMALL_STATE(114)] = 7080,
  [SMALL_STATE(115)] = 7111,
  [SMALL_STATE(116)] = 7142,
  [SMALL_STATE(117)] = 7195,
  [SMALL_STATE(118)] = 7226,
  [SMALL_STATE(119)] = 7279,
  [SMALL_STATE(120)] = 7316,
  [SMALL_STATE(121)] = 7346,
  [SMALL_STATE(122)] = 7380,
  [SMALL_STATE(123)] = 7410,
  [SMALL_STATE(124)] = 7440,
  [SMALL_STATE(125)] = 7470,
  [SMALL_STATE(126)] = 7500,
  [SMALL_STATE(127)] = 7530,
  [SMALL_STATE(128)] = 7564,
  [SMALL_STATE(129)] = 7602,
  [SMALL_STATE(130)] = 7636,
  [SMALL_STATE(131)] = 7666,
  [SMALL_STATE(132)] = 7700,
  [SMALL_STATE(133)] = 7730,
  [SMALL_STATE(134)] = 7759,
  [SMALL_STATE(135)] = 7788,
  [SMALL_STATE(136)] = 7817,
  [SMALL_STATE(137)] = 7846,
  [SMALL_STATE(138)] = 7875,
  [SMALL_STATE(139)] = 7914,
  [SMALL_STATE(140)] = 7953,
  [SMALL_STATE(141)] = 7992,
  [SMALL_STATE(142)] = 8025,
  [SMALL_STATE(143)] = 8054,
  [SMALL_STATE(144)] = 8082,
  [SMALL_STATE(145)] = 8110,
  [SMALL_STATE(146)] = 8142,
  [SMALL_STATE(147)] = 8174,
  [SMALL_STATE(148)] = 8206,
  [SMALL_STATE(149)] = 8234,
  [SMALL_STATE(150)] = 8262,
  [SMALL_STATE(151)] = 8290,
  [SMALL_STATE(152)] = 8318,
  [SMALL_STATE(153)] = 8343,
  [SMALL_STATE(154)] = 8370,
  [SMALL_STATE(155)] = 8399,
  [SMALL_STATE(156)] = 8428,
  [SMALL_STATE(157)] = 8463,
  [SMALL_STATE(158)] = 8500,
  [SMALL_STATE(159)] = 8537,
  [SMALL_STATE(160)] = 8566,
  [SMALL_STATE(161)] = 8603,
  [SMALL_STATE(162)] = 8630,
  [SMALL_STATE(163)] = 8673,
  [SMALL_STATE(164)] = 8710,
  [SMALL_STATE(165)] = 8737,
  [SMALL_STATE(166)] = 8764,
  [SMALL_STATE(167)] = 8793,
  [SMALL_STATE(168)] = 8820,
  [SMALL_STATE(169)] = 8857,
  [SMALL_STATE(170)] = 8883,
  [SMALL_STATE(171)] = 8909,
  [SMALL_STATE(172)] = 8935,
  [SMALL_STATE(173)] = 8969,
  [SMALL_STATE(174)] = 8995,
  [SMALL_STATE(175)] = 9021,
  [SMALL_STATE(176)] = 9047,
  [SMALL_STATE(177)] = 9073,
  [SMALL_STATE(178)] = 9101,
  [SMALL_STATE(179)] = 9124,
  [SMALL_STATE(180)] = 9163,
  [SMALL_STATE(181)] = 9188,
  [SMALL_STATE(182)] = 9213,
  [SMALL_STATE(183)] = 9238,
  [SMALL_STATE(184)] = 9263,
  [SMALL_STATE(185)] = 9286,
  [SMALL_STATE(186)] = 9315,
  [SMALL_STATE(187)] = 9338,
  [SMALL_STATE(188)] = 9363,
  [SMALL_STATE(189)] = 9386,
  [SMALL_STATE(190)] = 9409,
  [SMALL_STATE(191)] = 9432,
  [SMALL_STATE(192)] = 9456,
  [SMALL_STATE(193)] = 9480,
  [SMALL_STATE(194)] = 9506,
  [SMALL_STATE(195)] = 9530,
  [SMALL_STATE(196)] = 9556,
  [SMALL_STATE(197)] = 9584,
  [SMALL_STATE(198)] = 9608,
  [SMALL_STATE(199)] = 9634,
  [SMALL_STATE(200)] = 9672,
  [SMALL_STATE(201)] = 9695,
  [SMALL_STATE(202)] = 9718,
  [SMALL_STATE(203)] = 9747,
  [SMALL_STATE(204)] = 9770,
  [SMALL_STATE(205)] = 9795,
  [SMALL_STATE(206)] = 9824,
  [SMALL_STATE(207)] = 9858,
  [SMALL_STATE(208)] = 9892,
  [SMALL_STATE(209)] = 9912,
  [SMALL_STATE(210)] = 9934,
  [SMALL_STATE(211)] = 9954,
  [SMALL_STATE(212)] = 9976,
  [SMALL_STATE(213)] = 10002,
  [SMALL_STATE(214)] = 10037,
  [SMALL_STATE(215)] = 10060,
  [SMALL_STATE(216)] = 10083,
  [SMALL_STATE(217)] = 10106,
  [SMALL_STATE(218)] = 10141,
  [SMALL_STATE(219)] = 10164,
  [SMALL_STATE(220)] = 10187,
  [SMALL_STATE(221)] = 10210,
  [SMALL_STATE(222)] = 10233,
  [SMALL_STATE(223)] = 10256,
  [SMALL_STATE(224)] = 10279,
  [SMALL_STATE(225)] = 10297,
  [SMALL_STATE(226)] = 10315,
  [SMALL_STATE(227)] = 10333,
  [SMALL_STATE(228)] = 10351,
  [SMALL_STATE(229)] = 10369,
  [SMALL_STATE(230)] = 10387,
  [SMALL_STATE(231)] = 10405,
  [SMALL_STATE(232)] = 10423,
  [SMALL_STATE(233)] = 10441,
  [SMALL_STATE(234)] = 10459,
  [SMALL_STATE(235)] = 10493,
  [SMALL_STATE(236)] = 10511,
  [SMALL_STATE(237)] = 10529,
  [SMALL_STATE(238)] = 10547,
  [SMALL_STATE(239)] = 10581,
  [SMALL_STATE(240)] = 10598,
  [SMALL_STATE(241)] = 10615,
  [SMALL_STATE(242)] = 10632,
  [SMALL_STATE(243)] = 10649,
  [SMALL_STATE(244)] = 10666,
  [SMALL_STATE(245)] = 10683,
  [SMALL_STATE(246)] = 10700,
  [SMALL_STATE(247)] = 10717,
  [SMALL_STATE(248)] = 10734,
  [SMALL_STATE(249)] = 10751,
  [SMALL_STATE(250)] = 10768,
  [SMALL_STATE(251)] = 10785,
  [SMALL_STATE(252)] = 10802,
  [SMALL_STATE(253)] = 10819,
  [SMALL_STATE(254)] = 10836,
  [SMALL_STATE(255)] = 10853,
  [SMALL_STATE(256)] = 10870,
  [SMALL_STATE(257)] = 10887,
  [SMALL_STATE(258)] = 10904,
  [SMALL_STATE(259)] = 10921,
  [SMALL_STATE(260)] = 10938,
  [SMALL_STATE(261)] = 10955,
  [SMALL_STATE(262)] = 10972,
  [SMALL_STATE(263)] = 10989,
  [SMALL_STATE(264)] = 11006,
  [SMALL_STATE(265)] = 11023,
  [SMALL_STATE(266)] = 11040,
  [SMALL_STATE(267)] = 11057,
  [SMALL_STATE(268)] = 11074,
  [SMALL_STATE(269)] = 11091,
  [SMALL_STATE(270)] = 11108,
  [SMALL_STATE(271)] = 11141,
  [SMALL_STATE(272)] = 11158,
  [SMALL_STATE(273)] = 11175,
  [SMALL_STATE(274)] = 11192,
  [SMALL_STATE(275)] = 11209,
  [SMALL_STATE(276)] = 11226,
  [SMALL_STATE(277)] = 11243,
  [SMALL_STATE(278)] = 11260,
  [SMALL_STATE(279)] = 11293,
  [SMALL_STATE(280)] = 11310,
  [SMALL_STATE(281)] = 11327,
  [SMALL_STATE(282)] = 11344,
  [SMALL_STATE(283)] = 11361,
  [SMALL_STATE(284)] = 11378,
  [SMALL_STATE(285)] = 11406,
  [SMALL_STATE(286)] = 11434,
  [SMALL_STATE(287)] = 11462,
  [SMALL_STATE(288)] = 11490,
  [SMALL_STATE(289)] = 11518,
  [SMALL_STATE(290)] = 11546,
  [SMALL_STATE(291)] = 11574,
  [SMALL_STATE(292)] = 11602,
  [SMALL_STATE(293)] = 11629,
  [SMALL_STATE(294)] = 11656,
  [SMALL_STATE(295)] = 11681,
  [SMALL_STATE(296)] = 11708,
  [SMALL_STATE(297)] = 11733,
  [SMALL_STATE(298)] = 11757,
  [SMALL_STATE(299)] = 11781,
  [SMALL_STATE(300)] = 11805,
  [SMALL_STATE(301)] = 11829,
  [SMALL_STATE(302)] = 11853,
  [SMALL_STATE(303)] = 11877,
  [SMALL_STATE(304)] = 11898,
  [SMALL_STATE(305)] = 11913,
  [SMALL_STATE(306)] = 11934,
  [SMALL_STATE(307)] = 11955,
  [SMALL_STATE(308)] = 11976,
  [SMALL_STATE(309)] = 11997,
  [SMALL_STATE(310)] = 12012,
  [SMALL_STATE(311)] = 12033,
  [SMALL_STATE(312)] = 12054,
  [SMALL_STATE(313)] = 12075,
  [SMALL_STATE(314)] = 12092,
  [SMALL_STATE(315)] = 12111,
  [SMALL_STATE(316)] = 12130,
  [SMALL_STATE(317)] = 12149,
  [SMALL_STATE(318)] = 12170,
  [SMALL_STATE(319)] = 12189,
  [SMALL_STATE(320)] = 12210,
  [SMALL_STATE(321)] = 12225,
  [SMALL_STATE(322)] = 12246,
  [SMALL_STATE(323)] = 12267,
  [SMALL_STATE(324)] = 12288,
  [SMALL_STATE(325)] = 12309,
  [SMALL_STATE(326)] = 12334,
  [SMALL_STATE(327)] = 12355,
  [SMALL_STATE(328)] = 12374,
  [SMALL_STATE(329)] = 12393,
  [SMALL_STATE(330)] = 12414,
  [SMALL_STATE(331)] = 12433,
  [SMALL_STATE(332)] = 12452,
  [SMALL_STATE(333)] = 12474,
  [SMALL_STATE(334)] = 12496,
  [SMALL_STATE(335)] = 12516,
  [SMALL_STATE(336)] = 12534,
  [SMALL_STATE(337)] = 12556,
  [SMALL_STATE(338)] = 12578,
  [SMALL_STATE(339)] = 12600,
  [SMALL_STATE(340)] = 12618,
  [SMALL_STATE(341)] = 12636,
  [SMALL_STATE(342)] = 12656,
  [SMALL_STATE(343)] = 12674,
  [SMALL_STATE(344)] = 12694,
  [SMALL_STATE(345)] = 12714,
  [SMALL_STATE(346)] = 12732,
  [SMALL_STATE(347)] = 12752,
  [SMALL_STATE(348)] = 12768,
  [SMALL_STATE(349)] = 12783,
  [SMALL_STATE(350)] = 12794,
  [SMALL_STATE(351)] = 12813,
  [SMALL_STATE(352)] = 12830,
  [SMALL_STATE(353)] = 12847,
  [SMALL_STATE(354)] = 12862,
  [SMALL_STATE(355)] = 12881,
  [SMALL_STATE(356)] = 12892,
  [SMALL_STATE(357)] = 12911,
  [SMALL_STATE(358)] = 12922,
  [SMALL_STATE(359)] = 12933,
  [SMALL_STATE(360)] = 12950,
  [SMALL_STATE(361)] = 12969,
  [SMALL_STATE(362)] = 12988,
  [SMALL_STATE(363)] = 12999,
  [SMALL_STATE(364)] = 13018,
  [SMALL_STATE(365)] = 13029,
  [SMALL_STATE(366)] = 13046,
  [SMALL_STATE(367)] = 13061,
  [SMALL_STATE(368)] = 13078,
  [SMALL_STATE(369)] = 13097,
  [SMALL_STATE(370)] = 13114,
  [SMALL_STATE(371)] = 13133,
  [SMALL_STATE(372)] = 13152,
  [SMALL_STATE(373)] = 13166,
  [SMALL_STATE(374)] = 13178,
  [SMALL_STATE(375)] = 13194,
  [SMALL_STATE(376)] = 13210,
  [SMALL_STATE(377)] = 13226,
  [SMALL_STATE(378)] = 13242,
  [SMALL_STATE(379)] = 13258,
  [SMALL_STATE(380)] = 13272,
  [SMALL_STATE(381)] = 13288,
  [SMALL_STATE(382)] = 13304,
  [SMALL_STATE(383)] = 13320,
  [SMALL_STATE(384)] = 13332,
  [SMALL_STATE(385)] = 13348,
  [SMALL_STATE(386)] = 13360,
  [SMALL_STATE(387)] = 13372,
  [SMALL_STATE(388)] = 13386,
  [SMALL_STATE(389)] = 13402,
  [SMALL_STATE(390)] = 13416,
  [SMALL_STATE(391)] = 13430,
  [SMALL_STATE(392)] = 13440,
  [SMALL_STATE(393)] = 13454,
  [SMALL_STATE(394)] = 13468,
  [SMALL_STATE(395)] = 13484,
  [SMALL_STATE(396)] = 13498,
  [SMALL_STATE(397)] = 13510,
  [SMALL_STATE(398)] = 13524,
  [SMALL_STATE(399)] = 13536,
  [SMALL_STATE(400)] = 13548,
  [SMALL_STATE(401)] = 13560,
  [SMALL_STATE(402)] = 13572,
  [SMALL_STATE(403)] = 13586,
  [SMALL_STATE(404)] = 13602,
  [SMALL_STATE(405)] = 13615,
  [SMALL_STATE(406)] = 13628,
  [SMALL_STATE(407)] = 13641,
  [SMALL_STATE(408)] = 13654,
  [SMALL_STATE(409)] = 13667,
  [SMALL_STATE(410)] = 13680,
  [SMALL_STATE(411)] = 13693,
  [SMALL_STATE(412)] = 13706,
  [SMALL_STATE(413)] = 13717,
  [SMALL_STATE(414)] = 13726,
  [SMALL_STATE(415)] = 13739,
  [SMALL_STATE(416)] = 13752,
  [SMALL_STATE(417)] = 13763,
  [SMALL_STATE(418)] = 13772,
  [SMALL_STATE(419)] = 13785,
  [SMALL_STATE(420)] = 13798,
  [SMALL_STATE(421)] = 13807,
  [SMALL_STATE(422)] = 13820,
  [SMALL_STATE(423)] = 13833,
  [SMALL_STATE(424)] = 13846,
  [SMALL_STATE(425)] = 13859,
  [SMALL_STATE(426)] = 13872,
  [SMALL_STATE(427)] = 13885,
  [SMALL_STATE(428)] = 13898,
  [SMALL_STATE(429)] = 13911,
  [SMALL_STATE(430)] = 13922,
  [SMALL_STATE(431)] = 13933,
  [SMALL_STATE(432)] = 13946,
  [SMALL_STATE(433)] = 13954,
  [SMALL_STATE(434)] = 13962,
  [SMALL_STATE(435)] = 13970,
  [SMALL_STATE(436)] = 13980,
  [SMALL_STATE(437)] = 13988,
  [SMALL_STATE(438)] = 13998,
  [SMALL_STATE(439)] = 14008,
  [SMALL_STATE(440)] = 14016,
  [SMALL_STATE(441)] = 14026,
  [SMALL_STATE(442)] = 14036,
  [SMALL_STATE(443)] = 14046,
  [SMALL_STATE(444)] = 14056,
  [SMALL_STATE(445)] = 14066,
  [SMALL_STATE(446)] = 14076,
  [SMALL_STATE(447)] = 14086,
  [SMALL_STATE(448)] = 14094,
  [SMALL_STATE(449)] = 14102,
  [SMALL_STATE(450)] = 14112,
  [SMALL_STATE(451)] = 14120,
  [SMALL_STATE(452)] = 14130,
  [SMALL_STATE(453)] = 14140,
  [SMALL_STATE(454)] = 14150,
  [SMALL_STATE(455)] = 14160,
  [SMALL_STATE(456)] = 14168,
  [SMALL_STATE(457)] = 14178,
  [SMALL_STATE(458)] = 14186,
  [SMALL_STATE(459)] = 14194,
  [SMALL_STATE(460)] = 14202,
  [SMALL_STATE(461)] = 14209,
  [SMALL_STATE(462)] = 14216,
  [SMALL_STATE(463)] = 14223,
  [SMALL_STATE(464)] = 14230,
  [SMALL_STATE(465)] = 14237,
  [SMALL_STATE(466)] = 14244,
  [SMALL_STATE(467)] = 14251,
  [SMALL_STATE(468)] = 14258,
  [SMALL_STATE(469)] = 14265,
  [SMALL_STATE(470)] = 14272,
  [SMALL_STATE(471)] = 14279,
  [SMALL_STATE(472)] = 14286,
  [SMALL_STATE(473)] = 14293,
  [SMALL_STATE(474)] = 14300,
  [SMALL_STATE(475)] = 14307,
  [SMALL_STATE(476)] = 14314,
  [SMALL_STATE(477)] = 14321,
  [SMALL_STATE(478)] = 14328,
  [SMALL_STATE(479)] = 14335,
  [SMALL_STATE(480)] = 14342,
  [SMALL_STATE(481)] = 14349,
  [SMALL_STATE(482)] = 14356,
  [SMALL_STATE(483)] = 14363,
  [SMALL_STATE(484)] = 14370,
  [SMALL_STATE(485)] = 14377,
  [SMALL_STATE(486)] = 14384,
  [SMALL_STATE(487)] = 14391,
  [SMALL_STATE(488)] = 14398,
  [SMALL_STATE(489)] = 14405,
  [SMALL_STATE(490)] = 14412,
  [SMALL_STATE(491)] = 14419,
  [SMALL_STATE(492)] = 14426,
  [SMALL_STATE(493)] = 14433,
  [SMALL_STATE(494)] = 14440,
  [SMALL_STATE(495)] = 14447,
  [SMALL_STATE(496)] = 14454,
  [SMALL_STATE(497)] = 14461,
  [SMALL_STATE(498)] = 14468,
  [SMALL_STATE(499)] = 14475,
  [SMALL_STATE(500)] = 14482,
  [SMALL_STATE(501)] = 14489,
  [SMALL_STATE(502)] = 14496,
  [SMALL_STATE(503)] = 14503,
  [SMALL_STATE(504)] = 14510,
  [SMALL_STATE(505)] = 14517,
  [SMALL_STATE(506)] = 14524,
  [SMALL_STATE(507)] = 14531,
  [SMALL_STATE(508)] = 14538,
  [SMALL_STATE(509)] = 14545,
  [SMALL_STATE(510)] = 14552,
  [SMALL_STATE(511)] = 14559,
  [SMALL_STATE(512)] = 14566,
  [SMALL_STATE(513)] = 14573,
  [SMALL_STATE(514)] = 14580,
  [SMALL_STATE(515)] = 14587,
  [SMALL_STATE(516)] = 14594,
  [SMALL_STATE(517)] = 14601,
  [SMALL_STATE(518)] = 14608,
  [SMALL_STATE(519)] = 14615,
  [SMALL_STATE(520)] = 14622,
  [SMALL_STATE(521)] = 14629,
  [SMALL_STATE(522)] = 14636,
  [SMALL_STATE(523)] = 14643,
  [SMALL_STATE(524)] = 14650,
  [SMALL_STATE(525)] = 14657,
  [SMALL_STATE(526)] = 14664,
  [SMALL_STATE(527)] = 14671,
  [SMALL_STATE(528)] = 14678,
  [SMALL_STATE(529)] = 14685,
  [SMALL_STATE(530)] = 14692,
  [SMALL_STATE(531)] = 14699,
  [SMALL_STATE(532)] = 14706,
  [SMALL_STATE(533)] = 14713,
  [SMALL_STATE(534)] = 14720,
  [SMALL_STATE(535)] = 14727,
  [SMALL_STATE(536)] = 14734,
  [SMALL_STATE(537)] = 14741,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [7] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iri, 3, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iri, 3, 0, 0),
  [11] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [13] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [29] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 27),
  [31] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 27),
  [33] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 2, 0, 0),
  [35] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 2, 0, 0),
  [37] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [43] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_falsity, 1, 0, 0),
  [45] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_falsity, 1, 0, 0),
  [47] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_truth, 1, 0, 0),
  [49] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_truth, 1, 0, 0),
  [51] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_value, 1, 0, 0),
  [53] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_value, 1, 0, 0),
  [55] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 3, 0, 56),
  [57] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 3, 0, 56),
  [59] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 13),
  [61] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 13),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [65] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_reference, 1, 0, 0),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_reference, 1, 0, 0),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 3, 0, 73),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 3, 0, 73),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_constructor, 4, 0, 80),
  [107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_constructor, 4, 0, 80),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 5, 0, 101),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 5, 0, 101),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 4, 0, 91),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 4, 0, 91),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cardinality_expression, 4, 0, 92),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_expression, 4, 0, 92),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 3, 0, 55),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 3, 0, 55),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 2, 0, 0),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 2, 0, 0),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 3, 0, 54),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 3, 0, 54),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 5, 0, 101),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 5, 0, 101),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 3, 0, 73),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 3, 0, 73),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 4, 0, 92),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 4, 0, 92),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 4, 0, 79),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 4, 0, 79),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cardinality_expression, 4, 0, 91),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cardinality_expression, 4, 0, 91),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(119),
  [156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(69),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84),
  [161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(131),
  [164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(293),
  [167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(111),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(530),
  [173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(414),
  [176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(130),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(130),
  [182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(132),
  [185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(123),
  [188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 2, 0, 84), SHIFT_REPEAT(149),
  [191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 1, 0, 0),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1, 0, 0),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mapping_value, 3, 0, 59),
  [231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapping_value, 3, 0, 59),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 1, 0, 15),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 1, 0, 15),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 3, 0, 58),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 3, 0, 58),
  [241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 4, 0, 81),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 4, 0, 81),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 2, 0, 0),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 2, 0, 0),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_values, 3, 0, 52),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_values, 3, 0, 52),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(154),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(69),
  [315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53),
  [317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(340),
  [320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(111),
  [323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(530),
  [326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(414),
  [329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(130),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(130),
  [335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(132),
  [338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(123),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 2, 0, 53), SHIFT_REPEAT(149),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_composition, 2, 0, 29),
  [346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_composition, 2, 0, 29),
  [348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 60),
  [350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 60),
  [352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 60), SHIFT_REPEAT(500),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term, 1, 0, 0),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_term, 1, 0, 0),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 5),
  [361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 5),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 52),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 52),
  [373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 1, 0, 15),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 1, 0, 15),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 0),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 2, 0, 0),
  [381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_builder, 5, 0, 95),
  [383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_builder, 5, 0, 95),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_actual_arguments, 3, 0, 83),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_actual_arguments, 3, 0, 83),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 58),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 3, 0, 58),
  [393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_of_predicate_values, 4, 0, 81),
  [395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_of_predicate_values, 4, 0, 81),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_actual_arguments, 2, 0, 0),
  [399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_actual_arguments, 2, 0, 0),
  [401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicate_value, 1, 0, 0),
  [403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicate_value, 1, 0, 0),
  [405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_functional_term, 2, 0, 32),
  [407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_sentence, 2, 0, 31),
  [409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_functional_term, 2, 0, 32),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 53), SHIFT_REPEAT(154),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 53),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 53), SHIFT_REPEAT(111),
  [427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 53), SHIFT_REPEAT(530),
  [430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 53), SHIFT_REPEAT(414),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 53), SHIFT_REPEAT(130),
  [436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 53), SHIFT_REPEAT(130),
  [439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 53), SHIFT_REPEAT(132),
  [442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 2, 0, 53), SHIFT_REPEAT(123),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_biconditional, 1, 0, 0),
  [449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_biconditional, 1, 0, 0),
  [451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_op_by_definition, 1, 0, 0),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_op_by_definition, 1, 0, 0),
  [455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_negation, 1, 0, 0),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_negation, 1, 0, 0),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_conjunction, 1, 0, 0),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_conjunction, 1, 0, 0),
  [463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_disjunction, 1, 0, 0),
  [465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_disjunction, 1, 0, 0),
  [467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_exclusive_disjunction, 1, 0, 0),
  [469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_exclusive_disjunction, 1, 0, 0),
  [471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_op_implication, 1, 0, 0),
  [473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_op_implication, 1, 0, 0),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(523),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(522),
  [485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(521),
  [488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(520),
  [491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(519),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(438),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(515),
  [500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(514),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(513),
  [506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat3, 2, 0, 0), SHIFT_REPEAT(512),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_simple_type, 1, 0, 0),
  [517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_simple_type, 1, 0, 0),
  [519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0),
  [523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0), SHIFT_REPEAT(425),
  [526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat2, 2, 0, 0), SHIFT_REPEAT(524),
  [529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_composition_repeat1, 2, 0, 60), SHIFT_REPEAT(518),
  [532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_boolean_sentence, 2, 0, 33),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_boolean_sentence, 3, 0, 61),
  [536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mapping_type, 5, 0, 100),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapping_type, 5, 0, 100),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2, 0, 30),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_sentence, 3, 0, 62),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_actual_arguments_repeat1, 1, 0, 64),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_actual_arguments_repeat1, 1, 0, 64),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inequation, 3, 0, 65),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 1, 0, 4),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_informal_constraint, 2, 0, 17),
  [588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_informal_constraint, 2, 0, 17),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0),
  [596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(506),
  [599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(504),
  [602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(503),
  [605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(502),
  [608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_datatype_def_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(495),
  [611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equation, 3, 0, 63),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_informal_constraint, 3, 0, 35),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_informal_constraint, 3, 0, 35),
  [619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 1, 0, 0),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 1, 0, 0),
  [623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_constraint, 3, 0, 30),
  [625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_constraint, 3, 0, 30),
  [627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_property, 4, 0, 16),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_property, 4, 0, 16),
  [631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_reference, 1, 0, 0),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_reference, 1, 0, 0),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 3, 0, 1),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 3, 0, 1),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_constraint, 4, 0, 67),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_constraint, 4, 0, 67),
  [643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 1, 0, 26),
  [645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_predicate_values_repeat1, 1, 0, 26),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_sentence, 1, 0, 0),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_inequality, 1, 0, 0),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_inequality, 1, 0, 0),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_op_membership, 1, 0, 0),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_op_membership, 1, 0, 0),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_less_than_or_equal, 1, 0, 0),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_less_than_or_equal, 1, 0, 0),
  [671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_greater_than_or_equal, 1, 0, 0),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_greater_than_or_equal, 1, 0, 0),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_sentence, 1, 0, 0),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequence_of_values_repeat1, 1, 0, 26),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_of_values_repeat1, 1, 0, 26),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_sentence, 1, 0, 0),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_sentence, 3, 0, 0),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_import, 2, 0, 8),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_import, 2, 0, 8),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__rename_import, 2, 0, 12),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_import, 2, 0, 12),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2, 0, 0),
  [695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2, 0, 0), SHIFT_REPEAT(339),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 2, 0, 8),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 2, 0, 8),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_import, 1, 0, 4),
  [704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_def, 2, 0, 10),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_def, 2, 0, 10),
  [710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 3, 0, 14),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 3, 0, 14),
  [714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_import, 2, 0, 9),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_only_body, 3, 0, 0),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_only_body, 3, 0, 0),
  [720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_expression_to, 3, 0, 44),
  [722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_expression_to, 3, 0, 44),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 5, 0, 37),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_expression_to, 2, 0, 20),
  [730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_expression_to, 2, 0, 20),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 4, 0, 18),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 0),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, 0, 0),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_def, 3, 0, 19),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_def, 3, 0, 19),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 2, 0, 5),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_def, 2, 0, 5),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 5, 0, 38),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_def, 2, 0, 5),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_def, 2, 0, 5),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_def, 2, 0, 5),
  [774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 5, 0, 50),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 6, 0, 68),
  [778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_def, 2, 0, 5),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_def, 2, 0, 5),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datatype_def_restriction, 3, 0, 0),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_restriction_facet, 3, 0, 97),
  [790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_digit_restriction_facet, 4, 0, 103),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_restriction_facet, 4, 0, 103),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_digit_restriction_facet, 3, 0, 97),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_restriction_facet, 3, 0, 98),
  [798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tz_restriction_facet, 3, 0, 98),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tz_restriction_value, 1, 0, 0),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_length_restriction_facet, 4, 0, 103),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tz_restriction_facet, 4, 0, 104),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_restriction_facet, 5, 0, 110),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_length_restriction_facet, 3, 0, 97),
  [814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_restriction_value, 1, 0, 0),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_def, 3, 0, 1),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 3, 0, 0),
  [822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 2, 0, 0),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 5, 0, 39),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_def, 4, 0, 22),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 3, 0, 41),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 6, 0, 71),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 4, 0, 71),
  [834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 1, 0, 0),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 4, 0, 41),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_def, 2, 0, 6),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 3, 0, 41),
  [842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 5, 0, 71),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 0),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 5, 0, 71),
  [848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 3, 0, 41),
  [850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 5, 0, 71),
  [852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_body, 5, 0, 41),
  [854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 4, 0, 0),
  [856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_def, 3, 0, 1),
  [858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 2, 0, 0),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 6, 0, 69),
  [862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 2, 0, 0),
  [864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 3, 0, 0),
  [866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 7, 0, 87),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_body, 3, 0, 0),
  [870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_def, 3, 0, 1),
  [872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_def, 3, 0, 1),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_def, 3, 0, 1),
  [876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_body, 4, 0, 0),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2, 0, 0),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_def, 3, 0, 1),
  [886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 3, 0, 47),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 4, 0, 41),
  [890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_body, 4, 0, 71),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type_def, 6, 0, 70),
  [894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 0),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_def, 3, 0, 1),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_body, 4, 0, 77),
  [902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 4, 0, 41),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_body, 4, 0, 71),
  [906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 6, 0, 78),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_def, 3, 0, 1),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 1, 0, 23),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 3, 0, 44),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 3, 0, 44),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dimension_body_repeat2, 2, 0, 0), SHIFT_REPEAT(395),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat2, 2, 0, 0),
  [957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat2, 2, 0, 0), SHIFT_REPEAT(407),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 2, 0, 20),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 2, 0, 20),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_reference, 1, 0, 4),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 2, 0, 49),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(325),
  [985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2, 0, 0),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_variable_restriction, 3, 0, 0),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_reference, 1, 0, 0),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_reference, 1, 0, 0),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 1, 0, 4),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_variable_restriction, 2, 0, 0),
  [1015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1, 0, 0),
  [1017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1, 0, 0),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_variable_restriction_repeat1, 2, 0, 0),
  [1023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_variable_restriction_repeat1, 2, 0, 0), SHIFT_REPEAT(485),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 1, 0, 4),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimension_parent, 4, 0, 99),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_parent, 4, 0, 99),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_arguments_repeat1, 2, 0, 51), SHIFT_REPEAT(61),
  [1045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_arguments_repeat1, 2, 0, 51),
  [1047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 2, 0, 51), SHIFT_REPEAT(331),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 2, 0, 51),
  [1052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 2, 0, 51), SHIFT_REPEAT(295),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_body_repeat1, 2, 0, 0), SHIFT_REPEAT(366),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_body_repeat1, 2, 0, 0),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimension_body_repeat1, 2, 0, 0),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat1, 2, 0, 0),
  [1076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(463),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_arguments, 3, 0, 109),
  [1087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_body_repeat1, 2, 0, 48),
  [1089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_class_body_repeat1, 2, 0, 48), SHIFT_REPEAT(482),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constraint_environment_repeat1, 2, 0, 0),
  [1098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_environment_repeat1, 2, 0, 0), SHIFT_REPEAT(482),
  [1101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_source_entity, 2, 0, 40),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_entity, 2, 0, 40),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_reference, 2, 0, 94),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 6, 0, 102),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 1, 0, 4),
  [1119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 1, 0, 4),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, 0, 66),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_class_arguments, 3, 0, 108),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_environment, 2, 0, 0),
  [1135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rdf_types_repeat1, 2, 0, 76), SHIFT_REPEAT(61),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rdf_types_repeat1, 2, 0, 76),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_ref, 2, 0, 45),
  [1144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_ref, 2, 0, 45),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_import, 2, 0, 9),
  [1156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 3, 0, 74),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 3, 0, 74),
  [1160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_signature_repeat1, 2, 0, 96), SHIFT_REPEAT(392),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_signature_repeat1, 2, 0, 96),
  [1165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_entity_identity, 2, 0, 41),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_identity, 2, 0, 41),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_import, 1, 0, 4),
  [1171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 3, 0, 82),
  [1173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 3, 0, 82),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_variant, 1, 0, 4),
  [1179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_variant, 1, 0, 4),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 2, 0, 36),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_ordering, 1, 0, 0),
  [1185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0), SHIFT_REPEAT(388),
  [1188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimension_parent, 5, 0, 107),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension_parent, 5, 0, 107),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_or_sequence, 3, 0, 105),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_sequence, 3, 0, 105),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_source_entity, 4, 0, 89),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_entity, 4, 0, 89),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_or_sequence, 1, 0, 88),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_sequence, 1, 0, 88),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member, 1, 0, 0),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member, 1, 0, 0),
  [1216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_builder_repeat1, 2, 0, 51), SHIFT_REPEAT(328),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_builder_repeat1, 2, 0, 51),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_or_sequence_repeat1, 2, 0, 106), SHIFT_REPEAT(448),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_or_sequence_repeat1, 2, 0, 106),
  [1236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cardinality_inner, 1, 0, 43),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 2, 0, 4),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_binary_repeat1, 2, 0, 57),
  [1248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_binary_repeat1, 2, 0, 57), SHIFT_REPEAT(432),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_def_repeat1, 1, 0, 25),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_restriction_facet_repeat1, 2, 0, 0),
  [1261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_restriction_facet_repeat1, 2, 0, 0), SHIFT_REPEAT(419),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 3, 0, 49),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_variable, 3, 0, 85),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_binary_repeat1, 1, 0, 28),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 2, 0, 23),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_def, 2, 0, 36),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 2, 0, 10),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_locations, 1, 0, 2),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_builder_repeat1, 1, 0, 25),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_range, 1, 0, 0),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 4, 0, 93),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 4, 0, 93),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_uniqueness, 1, 0, 0),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_or_sequence_repeat1, 1, 0, 88),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_def, 3, 0, 36),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_variant, 2, 0, 42),
  [1326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_variant, 2, 0, 42),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variant, 2, 0, 42),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variant, 2, 0, 42),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_arguments_repeat1, 1, 0, 25),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rdf_types_repeat1, 1, 0, 46),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_class_body_repeat1, 1, 0, 24),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_signature_repeat1, 1, 0, 86),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_quantifier_existential, 1, 0, 0),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_locations, 3, 0, 7),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 5, 0, 0),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cardinality_range, 2, 0, 90),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_types, 2, 0, 21),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_types, 3, 0, 0),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_builder_body, 1, 0, 0),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sequence_value_constraints, 4, 0, 79),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rdf_types, 4, 0, 75),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_op_combiner, 1, 0, 0),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_quantifier_universal, 1, 0, 0),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_locations, 4, 0, 11),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 4, 0, 0),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cardinality_inner, 2, 0, 72),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 3, 0, 0),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 3),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sequence_value_constraints, 3, 0, 55),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 2, 0, 0),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, 0, 1),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_variable_binding, 2, 0, 34),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sequence_value_constraints, 3, 0, 54),
  [1498] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_sdml(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
